from epyk.core.html.options import Options
from typing import Any
from epyk.core.js import JsUtils
from epyk.core.py import types as etypes

        
class OptionPlotoptionsXrangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsXrangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsXrangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{point.x} - {point.x2}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.yCategory}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsXrangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsXrangeStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsXrangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsXrangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsXrangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsXrangeStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsXrangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsXrangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsXrangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsXrangeStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsXrangeStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsXrangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsXrangeStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsXrangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsXrangeStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsXrangeStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsXrangeStatesSelect)

        
class OptionPlotoptionsXrangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsXrangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsXrangeSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsXrangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsXrangeSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsXrangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsXrangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsXrangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsXrangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsXrangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsXrangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsXrangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsXrangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsXrangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsXrangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsXrangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsXrangeSonificationTracksMappingVolume)

        
class OptionPlotoptionsXrangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsXrangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsXrangeSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsXrangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsXrangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsXrangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsXrangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsXrangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsXrangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsXrangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsXrangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsXrangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsXrangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsXrangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsXrangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsXrangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsXrangeSonificationTracks)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsXrangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsXrangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsXrangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsXrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsXrangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsXrangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsXrangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsXrangeSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsXrangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsXrangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsXrangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsXrangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsXrangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsXrangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsXrangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsXrangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsXrangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsXrangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsXrangeSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsXrangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsXrangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsXrangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsXrangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsXrangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsXrangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsXrangeSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsXrangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrangePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsXrangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsXrangePointEvents)

        
class OptionPlotoptionsXrangePartialfill(Options):

    @property
    def fill(self):
        """The fill color to be used for partial fills.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(None)

    @fill.setter
    def fill(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsXrangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsXrangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsXrangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsXrangeOnpointPosition)

        
class OptionPlotoptionsXrangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsXrangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsXrangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsXrangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsXrangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsXrangeDragdropGuideboxDefault)

        
class OptionPlotoptionsXrangeDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX1(self):
        """Allow x value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableX1.setter
    def draggableX1(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX2(self):
        """Allow x2 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableX2.setter
    def draggableX2(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsXrangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsXrangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsXrangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsXrangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsXrangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsXrange(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsXrangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsXrangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """In an X-range series, this option makes all points of the same Y-axis category the same color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsXrangeDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsXrangeDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsXrangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsXrangeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsXrangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsXrangeEvents)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsXrangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsXrangeLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsXrangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsXrangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def partialFill(self) -> 'OptionPlotoptionsXrangePartialfill':
        """A partial fill for each point, typically used to visualize how much of a task is performed. """
        return self._config_sub_data("partialFill", OptionPlotoptionsXrangePartialfill)

    @property
    def point(self) -> 'OptionPlotoptionsXrangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsXrangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsXrangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsXrangeSonification)

    @property
    def states(self) -> 'OptionPlotoptionsXrangeStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsXrangeStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsXrangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsXrangeTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsXrangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsXrangeZones)

        
class OptionPlotoptionsXrangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsXrangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsXrangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsXrangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsXrangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsXrangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsXrangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsXrangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsXrangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsXrangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsXrangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsXrangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsXrangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsXrangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsXrangeAccessibilityPoint)

        
class OptionPlotoptionsWordcloudTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsWordcloudTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsWordcloudTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.weight}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWordcloudStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsWordcloudStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWordcloudStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWordcloudStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWordcloudStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsWordcloudStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWordcloudStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWordcloudStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsWordcloudStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsWordcloudStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsWordcloudStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsWordcloudStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsWordcloudStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsWordcloudStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsWordcloudStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsWordcloudStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsWordcloudStatesSelect)

        
class OptionPlotoptionsWordcloudSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWordcloudSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWordcloudSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWordcloudSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWordcloudSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWordcloudSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWordcloudSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWordcloudSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWordcloudSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWordcloudSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWordcloudSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsWordcloudSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWordcloudSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWordcloudSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWordcloudSonificationTracksMappingVolume)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWordcloudSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsWordcloudSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWordcloudSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWordcloudSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWordcloudSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWordcloudSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWordcloudSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWordcloudSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsWordcloudSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsWordcloudSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWordcloudSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWordcloudSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsWordcloudSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsWordcloudSonificationTracks)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsWordcloudSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWordcloudSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWordcloudSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsWordcloudSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWordcloudSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWordcloudSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWordcloudSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWordcloudSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWordcloudSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWordcloudSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWordcloudSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWordcloudSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsWordcloudSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWordcloudSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWordcloudSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWordcloudSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsWordcloudSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWordcloudSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWordcloudSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWordcloudSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWordcloudSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsWordcloudRotation(Options):

    @property
    def from_(self):
        """The smallest degree of rotation for a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(0)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def orientations(self):
        """The number of possible orientations for a word, within the range of <code>rotation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(2)

    @orientations.setter
    def orientations(self, num: float): self._config(num, js_type=False)

    @property
    def to(self):
        """The largest degree of rotation for a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(90)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloudPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsWordcloudPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsWordcloudPointEvents)

        
class OptionPlotoptionsWordcloudOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsWordcloudOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsWordcloudOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsWordcloudOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsWordcloudOnpointPosition)

        
class OptionPlotoptionsWordcloudLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsWordcloudLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsWordcloudLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWordcloudAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(500)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWordcloudEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWordcloud(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsWordcloudAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsWordcloudAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsWordcloudAnimation':
        """Enable or disable the initial animation when a series is displayed. """
        return self._config_sub_data("animation", OptionPlotoptionsWordcloudAnimation)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsWordcloudEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsWordcloudEvents)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsWordcloudLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsWordcloudLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxFontSize(self):
        """The word with the largest weight will have a font size equal to this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(25)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """A threshold determining the minimum font size that can be applied to a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(1)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsWordcloudOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsWordcloudOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def placementStrategy(self):
        """This option decides which algorithm is used for placement, and rotation of a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get("center")

    @placementStrategy.setter
    def placementStrategy(self, text: str): self._config(text, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsWordcloudPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsWordcloudPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rotation(self) -> 'OptionPlotoptionsWordcloudRotation':
        """Rotation options for the words in the wordcloud. """
        return self._config_sub_data("rotation", OptionPlotoptionsWordcloudRotation)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsWordcloudSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsWordcloudSonification)

    @property
    def spiral(self):
        """Spiral used for placing a word after the initial position experienced a collision with either another word or the borders.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get("rectangular")

    @spiral.setter
    def spiral(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsWordcloudStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsWordcloudStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """CSS styles for the words.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get({"fontFamily":"sans-serif", "fontWeight": "900"})

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsWordcloudTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsWordcloudTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWordcloudAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWordcloudAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWordcloudAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsWordcloudAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsWordcloudAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsWordcloudAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsWordcloudAccessibilityPoint)

        
class OptionPlotoptionsWindbarbZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsWindbarbTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsWindbarbTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The default point format for the wind barb tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.value}</b> ({point.beaufort})<br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWindbarbStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsWindbarbStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWindbarbStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWindbarbStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWindbarbStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsWindbarbStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidthPlus(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWindbarbStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsWindbarbStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsWindbarbStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsWindbarbStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsWindbarbStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsWindbarbStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsWindbarbStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsWindbarbStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsWindbarbStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsWindbarbStatesSelect)

        
class OptionPlotoptionsWindbarbSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWindbarbSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWindbarbSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWindbarbSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWindbarbSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWindbarbSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWindbarbSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWindbarbSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWindbarbSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWindbarbSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWindbarbSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsWindbarbSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWindbarbSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWindbarbSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWindbarbSonificationTracksMappingVolume)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWindbarbSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsWindbarbSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWindbarbSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWindbarbSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWindbarbSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWindbarbSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWindbarbSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWindbarbSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsWindbarbSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsWindbarbSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWindbarbSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWindbarbSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsWindbarbSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsWindbarbSonificationTracks)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsWindbarbSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWindbarbSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWindbarbSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsWindbarbSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWindbarbSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWindbarbSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWindbarbSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWindbarbSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWindbarbSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWindbarbSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWindbarbSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWindbarbSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsWindbarbSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWindbarbSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWindbarbSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWindbarbSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsWindbarbSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWindbarbSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWindbarbSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWindbarbSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWindbarbSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsWindbarbPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsWindbarbPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsWindbarbPointEvents)

        
class OptionPlotoptionsWindbarbOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsWindbarbOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsWindbarbOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsWindbarbOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsWindbarbOnpointPosition)

        
class OptionPlotoptionsWindbarbLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsWindbarbLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsWindbarbLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWindbarbDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbDatagrouping(Options):

    @property
    def anchor(self):
        """Specifies how the points should be located on the X axis inside the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(start)

    @anchor.setter
    def anchor(self, value: Any): self._config(value, js_type=False)

    @property
    def approximation(self):
        """Approximation function for the data grouping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get("windbarb")

    @approximation.setter
    def approximation(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self):
        """Datetime formats for the header of the tooltip in a stock chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(None)

    @dateTimeLabelFormats.setter
    def dateTimeLabelFormats(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Whether to enable data grouping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def firstAnchor(self):
        """Specifies how the first grouped point is positioned on the xAxis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(start)

    @firstAnchor.setter
    def firstAnchor(self, value: Any): self._config(value, js_type=False)

    @property
    def forced(self):
        """When data grouping is forced, it runs no matter how small the intervals are.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(False)

    @forced.setter
    def forced(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupAll(self):
        """By default only points within the visible range are grouped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(False)

    @groupAll.setter
    def groupAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPixelWidth(self):
        """The approximate data group width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(30)

    @groupPixelWidth.setter
    def groupPixelWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lastAnchor(self):
        """Specifies how the last grouped point is positioned on the xAxis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(start)

    @lastAnchor.setter
    def lastAnchor(self, value: Any): self._config(value, js_type=False)

    @property
    def smoothed(self):
        """Normally, a group is indexed by the start of that group, so for example when 30 daily values are grouped into one month, that month&#39;s x value will be the 1st of the month.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(False)

    @smoothed.setter
    def smoothed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def units(self):
        """An array determining what time intervals the data is allowed to be grouped to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(None)

    @units.setter
    def units(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarbDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWindbarb(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsWindbarbAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsWindbarbAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get("value")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataGrouping(self) -> 'OptionPlotoptionsWindbarbDatagrouping':
        """Data grouping options for the wind barbs. """
        return self._config_sub_data("dataGrouping", OptionPlotoptionsWindbarbDatagrouping)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsWindbarbDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsWindbarbDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsWindbarbDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsWindbarbDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsWindbarbEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsWindbarbEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsWindbarbLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsWindbarbLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the wind barb symbols.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsWindbarbOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsWindbarbOnpoint)

    @property
    def onSeries(self):
        """The id of another series in the chart that the wind barbs are projected on.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(None)

    @onSeries.setter
    def onSeries(self, text: str): self._config(text, js_type=False)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsWindbarbPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsWindbarbPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsWindbarbSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsWindbarbSonification)

    @property
    def states(self) -> 'OptionPlotoptionsWindbarbStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsWindbarbStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsWindbarbTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsWindbarbTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def vectorLength(self):
        """Pixel length of the stems.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(20)

    @vectorLength.setter
    def vectorLength(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xOffset(self):
        """Horizontal offset from the cartesian position, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(0)

    @xOffset.setter
    def xOffset(self, num: float): self._config(num, js_type=False)

    @property
    def yOffset(self):
        """Vertical offset from the cartesian position, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(-20)

    @yOffset.setter
    def yOffset(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsWindbarbZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsWindbarbZones)

        
class OptionPlotoptionsWindbarbDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWindbarbDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsWindbarbDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsWindbarbDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsWindbarbDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsWindbarbDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsWindbarbDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsWindbarbDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWindbarbAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWindbarbAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWindbarbAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsWindbarbAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsWindbarbAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsWindbarbAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsWindbarbAccessibilityPoint)

        
class OptionPlotoptionsWaterfallZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsWaterfallTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsWaterfallTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWaterfallStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsWaterfallStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWaterfallStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWaterfallStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWaterfallStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsWaterfallStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidthPlus(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsWaterfallStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsWaterfallStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsWaterfallStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsWaterfallStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsWaterfallStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsWaterfallStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsWaterfallStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsWaterfallStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsWaterfallStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsWaterfallStatesSelect)

        
class OptionPlotoptionsWaterfallSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWaterfallSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWaterfallSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWaterfallSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWaterfallSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWaterfallSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWaterfallSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWaterfallSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWaterfallSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWaterfallSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWaterfallSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsWaterfallSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWaterfallSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWaterfallSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWaterfallSonificationTracksMappingVolume)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWaterfallSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsWaterfallSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWaterfallSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWaterfallSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWaterfallSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWaterfallSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWaterfallSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWaterfallSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsWaterfallSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsWaterfallSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWaterfallSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWaterfallSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsWaterfallSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsWaterfallSonificationTracks)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsWaterfallSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWaterfallSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWaterfallSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsWaterfallSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsWaterfallSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsWaterfallSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsWaterfallSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsWaterfallSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsWaterfallSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsWaterfallSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsWaterfallSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsWaterfallSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsWaterfallSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsWaterfallSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsWaterfallSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsWaterfallSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsWaterfallSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsWaterfallSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsWaterfallSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsWaterfallSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsWaterfallSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsWaterfallPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfallPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsWaterfallPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsWaterfallPointEvents)

        
class OptionPlotoptionsWaterfallOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsWaterfallOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsWaterfallOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsWaterfallOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsWaterfallOnpointPosition)

        
class OptionPlotoptionsWaterfallLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsWaterfallLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsWaterfallLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWaterfallDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsWaterfallDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsWaterfallDragdropGuideboxDefault)

        
class OptionPlotoptionsWaterfallDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsWaterfallDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsWaterfallDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsWaterfallDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsWaterfallDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWaterfallEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsWaterfall(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsWaterfallAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsWaterfallAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border of each waterfall column.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get("#333333")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the line connecting the columns of the waterfall series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get("Dot")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsWaterfallDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsWaterfallDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsWaterfallDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsWaterfallDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsWaterfallDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsWaterfallDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsWaterfallEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsWaterfallEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsWaterfallLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsWaterfallLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the line that connects columns in a waterfall series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get("#333333")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting waterfall columns.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsWaterfallOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsWaterfallOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsWaterfallPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsWaterfallPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsWaterfallSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsWaterfallSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsWaterfallStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsWaterfallStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsWaterfallTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsWaterfallTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def upColor(self):
        """The color used specifically for positive point columns.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(None)

    @upColor.setter
    def upColor(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsWaterfallZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsWaterfallZones)

        
class OptionPlotoptionsWaterfallDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWaterfallDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsWaterfallDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsWaterfallDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsWaterfallDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsWaterfallDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsWaterfallDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsWaterfallDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsWaterfallAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsWaterfallAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsWaterfallAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsWaterfallAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsWaterfallAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsWaterfallAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsWaterfallAccessibilityPoint)

        
class OptionPlotoptionsVennTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsVennTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsVennTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("{point.name}: {point.value}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVennStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVennStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsVennStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsVennStatesSelectMarker)

        
class OptionPlotoptionsVennStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVennStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVennStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsVennStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(0.075)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsVennStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsVennStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsVennStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsVennStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsVennStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsVennStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsVennStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsVennStatesSelect)

        
class OptionPlotoptionsVennStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVennStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVennStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsVennStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsVennStatesHoverMarker)

    @property
    def opacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVennSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVennSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVennSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVennSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsVennSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVennSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVennSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsVennSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVennSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVennSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVennSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVennSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVennSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVennSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVennSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVennSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVennSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVennSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVennSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVennSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVennSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVennSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVennSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVennSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVennSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVennSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVennSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVennSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVennSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVennSonificationTracksMappingVolume)

        
class OptionPlotoptionsVennSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVennSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVennSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsVennSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVennSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVennSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVennSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVennSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVennSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVennSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsVennSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsVennSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsVennSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsVennSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVennSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVennSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsVennSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsVennSonificationTracks)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsVennSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsVennSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVennSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVennSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVennSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVennSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVennSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsVennSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVennSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVennSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsVennSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVennSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsVennSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVennSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVennSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVennSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVennSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVennSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVennSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVennSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVennSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVennSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVennSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVennSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsVennSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVennSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVennSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVennSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVennSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVennSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVennSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVennSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVennSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVennSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsVennPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsVennPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsVennPointEvents)

        
class OptionPlotoptionsVennOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsVennOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsVennOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsVennOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsVennOnpointPosition)

        
class OptionPlotoptionsVennDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennClusterEvents(Options):

    @property
    def drillToCluster(self):
        """Fires when the cluster point is clicked and <code>drillToCluster</code> is enabled.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @drillToCluster.setter
    def drillToCluster(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVennDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVenn(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsVennAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsVennAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderDashStyle(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("solid")

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def brighten(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(0)

    @brighten.setter
    def brighten(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cluster(self) -> 'OptionPlotoptionsVennCluster':
        """Options for marker clusters, the concept of sampling the data values into larger blocks in order to ease readability and increase performance of the JavaScript charts. """
        return self._config_sub_data("cluster", OptionPlotoptionsVennCluster)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsVennDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsVennDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsVennEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsVennEvents)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsVennOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsVennOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsVennPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsVennPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsVennSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsVennSonification)

    @property
    def states(self) -> 'OptionPlotoptionsVennStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsVennStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsVennTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsVennTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVennDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVennDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsVennDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsVennDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsVennDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsVennDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsVennDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsVennDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennClusterZonesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennClusterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def from_(self):
        """The value where the zone starts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsVennClusterZonesMarker':
        """Settings for the cluster marker belonging to the zone. """
        return self._config_sub_data("marker", OptionPlotoptionsVennClusterZonesMarker)

    @property
    def to(self):
        """The value where the zone ends.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennClusterStatesHover(Options):

    @property
    def fillColor(self):
        """The fill color of the cluster marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennClusterStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsVennClusterStatesHover':
        """. """
        return self._config_sub_data("hover", OptionPlotoptionsVennClusterStatesHover)

        
class OptionPlotoptionsVennClusterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVennClusterLayoutalgorithm(Options):

    @property
    def distance(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>distance</code> is a maximum distance between point and cluster center so that this point will be inside the cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(40)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def gridSize(self):
        """When <code>type</code> is set to the <code>grid</code>, <code>gridSize</code> is a size of a grid square element either as a number defining pixels, or a percentage defining a percentage of the plot area width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(50)

    @gridSize.setter
    def gridSize(self, num: float): self._config(num, js_type=False)

    @property
    def iterations(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>iterations</code> are the number of iterations that this algorithm will be repeated to find clusters positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @iterations.setter
    def iterations(self, num: float): self._config(num, js_type=False)

    @property
    def kmeansThreshold(self):
        """When <code>type</code> is set to <code>undefined</code> and there are more visible points than the kmeansThreshold the <code>grid</code> algorithm is used to find clusters, otherwise <code>kmeans</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(100)

    @kmeansThreshold.setter
    def kmeansThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used to combine points into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennCluster(Options):

    @property
    def allowOverlap(self):
        """When set to <code>false</code> prevent cluster overlapping - this option works only when <code>layoutAlgorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Options for the cluster marker animation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get({ "duration": 500 })

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsVennClusterDatalabels':
        """Options for the cluster data labels. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsVennClusterDatalabels)

    @property
    def drillToCluster(self):
        """Zoom the plot area to the cluster points range when a cluster is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @drillToCluster.setter
    def drillToCluster(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Whether to enable the marker-clusters module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsVennClusterEvents':
        """. """
        return self._config_sub_data("events", OptionPlotoptionsVennClusterEvents)

    @property
    def layoutAlgorithm(self) -> 'OptionPlotoptionsVennClusterLayoutalgorithm':
        """Options for layout algorithm. """
        return self._config_sub_data("layoutAlgorithm", OptionPlotoptionsVennClusterLayoutalgorithm)

    @property
    def marker(self) -> 'OptionPlotoptionsVennClusterMarker':
        """Options for the cluster marker. """
        return self._config_sub_data("marker", OptionPlotoptionsVennClusterMarker)

    @property
    def minimumClusterSize(self):
        """The minimum amount of points to be combined into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(2)

    @minimumClusterSize.setter
    def minimumClusterSize(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsVennClusterStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsVennClusterStates)

    @property
    def zones(self) -> 'OptionPlotoptionsVennClusterZones':
        """An array defining zones within marker clusters. """
        return self._config_sub_data("zones", OptionPlotoptionsVennClusterZones)

        
class OptionPlotoptionsVennClusterDatalabelsStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("contrast")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennClusterDatalabels(Options):

    @property
    def align(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("{point.clusterPointsAmount}")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def inside(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsVennClusterDatalabelsStyle':
        """. """
        return self._config_sub_data("style", OptionPlotoptionsVennClusterDatalabelsStyle)

    @property
    def verticalAlign(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVennAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVennAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsVennAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsVennAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsVennAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsVennAccessibilityPoint)

        
class OptionPlotoptionsVectorZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsVectorTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsVectorTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get("[{point.x}, {point.y}] Length: {point.length} Direction: {point.direction}°")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVectorStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVectorStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsVectorStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsVectorStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsVectorStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsVectorStatesSelectMarker)

        
class OptionPlotoptionsVectorStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVectorStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVectorStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsVectorStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsVectorStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsVectorStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsVectorStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsVectorStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsVectorStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsVectorStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsVectorStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsVectorStatesSelect)

        
class OptionPlotoptionsVectorStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVectorStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVectorStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsVectorStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsVectorStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """Additonal line width for the vector errors when they are hovered.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsVectorStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsVectorStatesHoverMarker)

        
class OptionPlotoptionsVectorSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVectorSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVectorSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsVectorSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVectorSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsVectorSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVectorSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVectorSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVectorSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVectorSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVectorSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVectorSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVectorSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVectorSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVectorSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVectorSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVectorSonificationTracksMappingVolume)

        
class OptionPlotoptionsVectorSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVectorSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVectorSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsVectorSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVectorSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVectorSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVectorSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVectorSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVectorSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVectorSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsVectorSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsVectorSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsVectorSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsVectorSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVectorSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVectorSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsVectorSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsVectorSonificationTracks)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsVectorSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsVectorSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVectorSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVectorSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVectorSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVectorSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVectorSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsVectorSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVectorSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVectorSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVectorSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVectorSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVectorSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVectorSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVectorSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVectorSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVectorSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVectorSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVectorSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVectorSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVectorSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVectorSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsVectorSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVectorSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVectorSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVectorSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVectorSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVectorSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVectorSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVectorSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVectorSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsVectorPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsVectorPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsVectorPointEvents)

        
class OptionPlotoptionsVectorOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsVectorOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsVectorOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsVectorOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsVectorOnpointPosition)

        
class OptionPlotoptionsVectorLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsVectorLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsVectorLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVectorDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorClusterEvents(Options):

    @property
    def drillToCluster(self):
        """Fires when the cluster point is clicked and <code>drillToCluster</code> is enabled.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @drillToCluster.setter
    def drillToCluster(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVectorDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVector(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsVectorAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsVectorAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cluster(self) -> 'OptionPlotoptionsVectorCluster':
        """Options for marker clusters, the concept of sampling the data values into larger blocks in order to ease readability and increase performance of the JavaScript charts. """
        return self._config_sub_data("cluster", OptionPlotoptionsVectorCluster)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsVectorDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsVectorDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsVectorDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsVectorDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsVectorEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsVectorEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsVectorLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsVectorLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for each vector arrow.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsVectorOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsVectorOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsVectorPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsVectorPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rotationOrigin(self):
        """What part of the vector it should be rotated around.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get("center")

    @rotationOrigin.setter
    def rotationOrigin(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsVectorSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsVectorSonification)

    @property
    def states(self) -> 'OptionPlotoptionsVectorStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsVectorStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsVectorTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsVectorTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def vectorLength(self):
        """Maximum length of the arrows in the vector plot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(20)

    @vectorLength.setter
    def vectorLength(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsVectorZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsVectorZones)

        
class OptionPlotoptionsVectorDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVectorDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsVectorDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsVectorDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsVectorDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsVectorDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsVectorDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsVectorDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorClusterZonesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorClusterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def from_(self):
        """The value where the zone starts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsVectorClusterZonesMarker':
        """Settings for the cluster marker belonging to the zone. """
        return self._config_sub_data("marker", OptionPlotoptionsVectorClusterZonesMarker)

    @property
    def to(self):
        """The value where the zone ends.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorClusterStatesHover(Options):

    @property
    def fillColor(self):
        """The fill color of the cluster marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorClusterStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsVectorClusterStatesHover':
        """. """
        return self._config_sub_data("hover", OptionPlotoptionsVectorClusterStatesHover)

        
class OptionPlotoptionsVectorClusterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVectorClusterLayoutalgorithm(Options):

    @property
    def distance(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>distance</code> is a maximum distance between point and cluster center so that this point will be inside the cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(40)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def gridSize(self):
        """When <code>type</code> is set to the <code>grid</code>, <code>gridSize</code> is a size of a grid square element either as a number defining pixels, or a percentage defining a percentage of the plot area width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(50)

    @gridSize.setter
    def gridSize(self, num: float): self._config(num, js_type=False)

    @property
    def iterations(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>iterations</code> are the number of iterations that this algorithm will be repeated to find clusters positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @iterations.setter
    def iterations(self, num: float): self._config(num, js_type=False)

    @property
    def kmeansThreshold(self):
        """When <code>type</code> is set to <code>undefined</code> and there are more visible points than the kmeansThreshold the <code>grid</code> algorithm is used to find clusters, otherwise <code>kmeans</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(100)

    @kmeansThreshold.setter
    def kmeansThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used to combine points into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorCluster(Options):

    @property
    def allowOverlap(self):
        """When set to <code>false</code> prevent cluster overlapping - this option works only when <code>layoutAlgorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Options for the cluster marker animation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get({ "duration": 500 })

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsVectorClusterDatalabels':
        """Options for the cluster data labels. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsVectorClusterDatalabels)

    @property
    def drillToCluster(self):
        """Zoom the plot area to the cluster points range when a cluster is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @drillToCluster.setter
    def drillToCluster(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Whether to enable the marker-clusters module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsVectorClusterEvents':
        """. """
        return self._config_sub_data("events", OptionPlotoptionsVectorClusterEvents)

    @property
    def layoutAlgorithm(self) -> 'OptionPlotoptionsVectorClusterLayoutalgorithm':
        """Options for layout algorithm. """
        return self._config_sub_data("layoutAlgorithm", OptionPlotoptionsVectorClusterLayoutalgorithm)

    @property
    def marker(self) -> 'OptionPlotoptionsVectorClusterMarker':
        """Options for the cluster marker. """
        return self._config_sub_data("marker", OptionPlotoptionsVectorClusterMarker)

    @property
    def minimumClusterSize(self):
        """The minimum amount of points to be combined into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(2)

    @minimumClusterSize.setter
    def minimumClusterSize(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsVectorClusterStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsVectorClusterStates)

    @property
    def zones(self) -> 'OptionPlotoptionsVectorClusterZones':
        """An array defining zones within marker clusters. """
        return self._config_sub_data("zones", OptionPlotoptionsVectorClusterZones)

        
class OptionPlotoptionsVectorClusterDatalabelsStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("contrast")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorClusterDatalabels(Options):

    @property
    def align(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("{point.clusterPointsAmount}")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def inside(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsVectorClusterDatalabelsStyle':
        """. """
        return self._config_sub_data("style", OptionPlotoptionsVectorClusterDatalabelsStyle)

    @property
    def verticalAlign(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVectorAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVectorAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsVectorAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsVectorAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsVectorAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsVectorAccessibilityPoint)

        
class OptionPlotoptionsVariwideZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsVariwideTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsVariwideTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVariwideStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVariwideStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariwideStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariwideStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVariwideStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVariwideStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariwideStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVariwideStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsVariwideStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsVariwideStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsVariwideStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsVariwideStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsVariwideStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsVariwideStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsVariwideStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsVariwideStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsVariwideStatesSelect)

        
class OptionPlotoptionsVariwideSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVariwideSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVariwideSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsVariwideSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariwideSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsVariwideSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVariwideSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVariwideSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVariwideSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVariwideSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVariwideSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariwideSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariwideSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVariwideSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariwideSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVariwideSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVariwideSonificationTracksMappingVolume)

        
class OptionPlotoptionsVariwideSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariwideSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariwideSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsVariwideSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariwideSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariwideSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariwideSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariwideSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariwideSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariwideSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsVariwideSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsVariwideSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsVariwideSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariwideSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariwideSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsVariwideSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsVariwideSonificationTracks)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsVariwideSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariwideSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariwideSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariwideSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsVariwideSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVariwideSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVariwideSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariwideSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVariwideSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVariwideSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVariwideSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVariwideSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVariwideSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariwideSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariwideSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVariwideSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariwideSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVariwideSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVariwideSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsVariwideSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariwideSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariwideSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariwideSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwideSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariwideSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariwideSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariwideSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsVariwidePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwidePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsVariwidePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsVariwidePointEvents)

        
class OptionPlotoptionsVariwideOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsVariwideOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsVariwideOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsVariwideOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsVariwideOnpointPosition)

        
class OptionPlotoptionsVariwideLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsVariwideLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsVariwideLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariwideDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsVariwideDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsVariwideDragdropGuideboxDefault)

        
class OptionPlotoptionsVariwideDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsVariwideDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsVariwideDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsVariwideDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsVariwideDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariwideEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariwide(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsVariwideAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsVariwideAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsVariwideDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsVariwideDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsVariwideDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsVariwideDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsVariwideDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsVariwideDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsVariwideEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsVariwideEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """In a variwide chart, the group padding is 0 in order to express the horizontal stacking of items.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Variwide/VariwideSeriesDefaults.ts
        """
        return self._config_get(0)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsVariwideLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsVariwideLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsVariwideOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsVariwideOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsVariwidePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsVariwidePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """In a variwide chart, the point padding is 0 in order to express the horizontal stacking of items.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Variwide/VariwideSeriesDefaults.ts
        """
        return self._config_get(0)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsVariwideSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsVariwideSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsVariwideStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsVariwideStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsVariwideTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsVariwideTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsVariwideZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsVariwideZones)

        
class OptionPlotoptionsVariwideDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariwideDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsVariwideDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsVariwideDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsVariwideDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsVariwideDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsVariwideDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsVariwideDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariwideAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariwideAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariwideAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsVariwideAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsVariwideAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsVariwideAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsVariwideAccessibilityPoint)

        
class OptionPlotoptionsVariablepieTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsVariablepieTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsVariablepieTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}<br/>Value: {point.y}<br/>Size: {point.z}<br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVariablepieStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVariablepieStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsVariablepieStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsVariablepieStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsVariablepieStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsVariablepieStatesSelectMarker)

        
class OptionPlotoptionsVariablepieStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariablepieStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVariablepieStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsVariablepieStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsVariablepieStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsVariablepieStatesHoverHalo)

        
class OptionPlotoptionsVariablepieStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsVariablepieStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsVariablepieStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsVariablepieStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsVariablepieStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsVariablepieStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsVariablepieStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsVariablepieStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsVariablepieStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsVariablepieStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsVariablepieStatesSelect)

        
class OptionPlotoptionsVariablepieSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVariablepieSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVariablepieSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariablepieSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVariablepieSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVariablepieSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVariablepieSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVariablepieSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVariablepieSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariablepieSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariablepieSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVariablepieSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariablepieSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVariablepieSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVariablepieSonificationTracksMappingVolume)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariablepieSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsVariablepieSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariablepieSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariablepieSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariablepieSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariablepieSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariablepieSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariablepieSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsVariablepieSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsVariablepieSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariablepieSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariablepieSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsVariablepieSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsVariablepieSonificationTracks)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsVariablepieSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariablepieSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariablepieSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsVariablepieSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsVariablepieSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsVariablepieSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsVariablepieSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsVariablepieSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsVariablepieSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsVariablepieSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsVariablepieSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsVariablepieSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsVariablepieSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsVariablepieSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsVariablepieSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsVariablepieSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsVariablepieSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsVariablepieSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsVariablepieSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsVariablepieSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsVariablepieSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsVariablepiePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepiePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsVariablepiePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsVariablepiePointEvents)

        
class OptionPlotoptionsVariablepieOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsVariablepieOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsVariablepieOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsVariablepieOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsVariablepieOnpointPosition)

        
class OptionPlotoptionsVariablepieDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsVariablepie(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsVariablepieAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsVariablepieAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the pie chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsVariablepieDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsVariablepieDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsVariablepieEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsVariablepieEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def innerSize(self):
        """The size of the inner diameter for the pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @innerSize.setter
    def innerSize(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def maxPointSize(self):
        """The maximum size of the points&#39; radius related to chart&#39;s <code>plotArea</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("100%")

    @maxPointSize.setter
    def maxPointSize(self, num: float): self._config(num, js_type=False)

    @property
    def minPointSize(self):
        """The minimum size of the points&#39; radius related to chart&#39;s <code>plotArea</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("10%")

    @minPointSize.setter
    def minPointSize(self, num: float): self._config(num, js_type=False)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsVariablepieOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsVariablepieOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsVariablepiePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsVariablepiePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def sizeBy(self):
        """Whether the pie slice&#39;s value should be represented by the area or the radius of the slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get(area)

    @sizeBy.setter
    def sizeBy(self, value: Any): self._config(value, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsVariablepieSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsVariablepieSonification)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsVariablepieStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsVariablepieStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsVariablepieTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsVariablepieTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zMax(self):
        """The maximum possible z value for the point&#39;s radius calculation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @zMax.setter
    def zMax(self, num: float): self._config(num, js_type=False)

    @property
    def zMin(self):
        """The minimum possible z value for the point&#39;s radius calculation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @zMin.setter
    def zMin(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariablepieDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsVariablepieDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsVariablepieDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsVariablepieDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsVariablepieDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsVariablepieDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsVariablepieDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsVariablepieAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsVariablepieAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsVariablepieAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsVariablepieAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsVariablepieAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsVariablepieAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsVariablepieAccessibilityPoint)

        
class OptionPlotoptionsTreemapZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapTraverseupbuttonPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """Horizontal offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(-10)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Vertical offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(10)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapTraverseupbutton(Options):

    @property
    def position(self) -> 'OptionPlotoptionsTreemapTraverseupbuttonPosition':
        """The position of the button. """
        return self._config_sub_data("position", OptionPlotoptionsTreemapTraverseupbuttonPosition)

        
class OptionPlotoptionsTreemapTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsTreemapTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsTreemapTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("<b>{point.name}</b>: {point.value}<br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTreemapStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTreemapStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsTreemapStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsTreemapStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTreemapStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTreemapStatesSelectMarker)

        
class OptionPlotoptionsTreemapStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreemapStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTreemapStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsTreemapStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsTreemapStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsTreemapStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsTreemapStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsTreemapStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsTreemapStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsTreemapStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsTreemapStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsTreemapStatesSelect)

        
class OptionPlotoptionsTreemapStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTreemapStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTreemapStatesHoverAnimation)

    @property
    def brightness(self):
        """Brightness for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTreemapStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTreemapStatesHoverMarker)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow option for hovered state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTreemapSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTreemapSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsTreemapSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreemapSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsTreemapSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTreemapSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTreemapSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTreemapSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTreemapSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTreemapSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreemapSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreemapSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTreemapSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreemapSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTreemapSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTreemapSonificationTracksMappingVolume)

        
class OptionPlotoptionsTreemapSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreemapSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreemapSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsTreemapSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreemapSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreemapSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreemapSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreemapSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreemapSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreemapSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsTreemapSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsTreemapSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsTreemapSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreemapSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreemapSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsTreemapSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsTreemapSonificationTracks)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsTreemapSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreemapSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreemapSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreemapSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsTreemapSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTreemapSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTreemapSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreemapSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTreemapSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTreemapSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTreemapSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTreemapSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTreemapSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreemapSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreemapSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTreemapSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreemapSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTreemapSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTreemapSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsTreemapSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreemapSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreemapSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreemapSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreemapSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreemapSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreemapSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsTreemapPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsTreemapPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsTreemapPointEvents)

        
class OptionPlotoptionsTreemapOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsTreemapOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsTreemapOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsTreemapOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsTreemapOnpointPosition)

        
class OptionPlotoptionsTreemapLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapLevelsColorvariation(Options):

    @property
    def key(self):
        """The key of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @key.setter
    def key(self, value: Any): self._config(value, js_type=False)

    @property
    def to(self):
        """The ending value of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapLevels(Options):

    @property
    def borderColor(self):
        """Can set a <code>borderColor</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderDashStyle(self):
        """Set the dash style of the border of all the point which lies on the level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set the borderWidth on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set a color on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorVariation(self) -> 'OptionPlotoptionsTreemapLevelsColorvariation':
        """A configuration object to define how the color of a child varies from the parent&#39;s color. """
        return self._config_sub_data("colorVariation", OptionPlotoptionsTreemapLevelsColorvariation)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsTreemapLevelsDatalabels':
        """Can set the options of dataLabels on each point which lies on the level. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsTreemapLevelsDatalabels)

    @property
    def layoutAlgorithm(self):
        """Can set the layoutAlgorithm option on a specific level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @layoutAlgorithm.setter
    def layoutAlgorithm(self, value: Any): self._config(value, js_type=False)

    @property
    def layoutStartingDirection(self):
        """Can set the layoutStartingDirection option on a specific level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @layoutStartingDirection.setter
    def layoutStartingDirection(self, value: Any): self._config(value, js_type=False)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreemapLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsTreemapLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsTreemapLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsTreemapLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsTreemapLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsTreemapLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsTreemapLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsTreemapLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsTreemapLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreemapDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapBreadcrumbsEvents(Options):

    @property
    def click(self):
        """Fires when clicking on the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemapDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def setRootNode(self):
        """Fires on a request for change of root node for the tree, before the update is made.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @setRootNode.setter
    def setRootNode(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreemap(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsTreemapAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsTreemapAccessibility)

    @property
    def allowDrillToNode(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowDrillToNode.setter
    def allowDrillToNode(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowTraversingTree(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowTraversingTree.setter
    def allowTraversingTree(self, flag: bool): self._config(flag, js_type=False)

    @property
    def alternateStartingDirection(self):
        """Enabling this option will make the treemap alternate the drawing direction between vertical and horizontal.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @alternateStartingDirection.setter
    def alternateStartingDirection(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderRadius(self):
        """The border radius for each treemap item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def breadcrumbs(self) -> 'OptionPlotoptionsTreemapBreadcrumbs':
        """Options for the breadcrumbs, the navigation at the top leading the way up through the traversed levels. """
        return self._config_sub_data("breadcrumbs", OptionPlotoptionsTreemapBreadcrumbs)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the <code>options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("colorValue")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsTreemapDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsTreemapDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsTreemapEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsTreemapEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Whether to ignore hidden points when the layout algorithm runs.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def interactByLeaf(self):
        """This option decides if the user can interact with the parent nodes or just the leaf nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @interactByLeaf.setter
    def interactByLeaf(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsTreemapLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsTreemapLabel)

    @property
    def layoutAlgorithm(self):
        """This option decides which algorithm is used for setting position and dimensions of the points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("sliceAndDice")

    @layoutAlgorithm.setter
    def layoutAlgorithm(self, text: str): self._config(text, js_type=False)

    @property
    def layoutStartingDirection(self):
        """Defines which direction the layout algorithm will start drawing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("vertical")

    @layoutStartingDirection.setter
    def layoutStartingDirection(self, text: str): self._config(text, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levelIsConstant(self):
        """Used together with the levels and allowTraversingTree options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @levelIsConstant.setter
    def levelIsConstant(self, flag: bool): self._config(flag, js_type=False)

    @property
    def levels(self) -> 'OptionPlotoptionsTreemapLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionPlotoptionsTreemapLevels)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsTreemapOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsTreemapOnpoint)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.15)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsTreemapPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsTreemapPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this series type or specific series item in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsTreemapSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsTreemapSonification)

    @property
    def sortIndex(self):
        """The sort index of the point inside the treemap level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @sortIndex.setter
    def sortIndex(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsTreemapStates':
        """A wrapper object for all the series options in specific states. """
        return self._config_sub_data("states", OptionPlotoptionsTreemapStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsTreemapTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsTreemapTooltip)

    @property
    def traverseUpButton(self) -> 'OptionPlotoptionsTreemapTraverseupbutton':
        """Options for the button appearing when traversing down in a treemap. """
        return self._config_sub_data("traverseUpButton", OptionPlotoptionsTreemapTraverseupbutton)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsTreemapZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsTreemapZones)

        
class OptionPlotoptionsTreemapDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreemapDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsTreemapDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsTreemapDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsTreemapDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsTreemapDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsTreemapDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsTreemapDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapBreadcrumbsSeparatorStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapBreadcrumbsSeparator(Options):

    @property
    def style(self) -> 'OptionPlotoptionsTreemapBreadcrumbsSeparatorStyle':
        """CSS styles for the breadcrumbs separator. """
        return self._config_sub_data("style", OptionPlotoptionsTreemapBreadcrumbsSeparatorStyle)

    @property
    def text(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("/")

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapBreadcrumbsPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("left")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The X offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The Y offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapBreadcrumbs(Options):

    @property
    def buttonSpacing(self):
        """The default padding for each button and separator in each direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(5)

    @buttonSpacing.setter
    def buttonSpacing(self, num: float): self._config(num, js_type=False)

    @property
    def buttonTheme(self) -> 'OptionPlotoptionsTreemapBreadcrumbsButtontheme':
        """A collection of attributes for the buttons. """
        return self._config_sub_data("buttonTheme", OptionPlotoptionsTreemapBreadcrumbsButtontheme)

    @property
    def events(self) -> 'OptionPlotoptionsTreemapBreadcrumbsEvents':
        """. """
        return self._config_sub_data("events", OptionPlotoptionsTreemapBreadcrumbsEvents)

    @property
    def floating(self):
        """When the breadcrumbs are floating, the plot area will not move to make space for it.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @floating.setter
    def floating(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format the breadcrumb text from scratch.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsTreemapBreadcrumbsPosition':
        """Positioning for the button row. """
        return self._config_sub_data("position", OptionPlotoptionsTreemapBreadcrumbsPosition)

    @property
    def relativeTo(self):
        """What box to align the button to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("plotBox")

    @relativeTo.setter
    def relativeTo(self, text: str): self._config(text, js_type=False)

    @property
    def rtl(self):
        """Whether to reverse the order of buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @rtl.setter
    def rtl(self, flag: bool): self._config(flag, js_type=False)

    @property
    def separator(self) -> 'OptionPlotoptionsTreemapBreadcrumbsSeparator':
        """Options object for Breadcrumbs separator. """
        return self._config_sub_data("separator", OptionPlotoptionsTreemapBreadcrumbsSeparator)

    @property
    def showFullPath(self):
        """Show full path or only a single button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(True)

    @showFullPath.setter
    def showFullPath(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """CSS styles for all breadcrumbs.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def useHTML(self):
        """Whether to use HTML to render the breadcrumbs items texts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """The z index of the breadcrumbs group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(7)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreemapBreadcrumbsButtonthemeStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#334eff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapBreadcrumbsButtontheme(Options):

    @property
    def style(self) -> 'OptionPlotoptionsTreemapBreadcrumbsButtonthemeStyle':
        """. """
        return self._config_sub_data("style", OptionPlotoptionsTreemapBreadcrumbsButtonthemeStyle)

        
class OptionPlotoptionsTreemapAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreemapAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreemapAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsTreemapAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsTreemapAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsTreemapAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsTreemapAccessibilityPoint)

        
class OptionPlotoptionsTreegraphTraverseupbuttonPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """Horizontal offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(-10)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Vertical offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(10)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphTraverseupbutton(Options):

    @property
    def position(self) -> 'OptionPlotoptionsTreegraphTraverseupbuttonPosition':
        """The position of the button. """
        return self._config_sub_data("position", OptionPlotoptionsTreegraphTraverseupbuttonPosition)

        
class OptionPlotoptionsTreegraphTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsTreegraphTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsTreegraphTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def linkFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.id} → {point.toNode.id}")

    @linkFormat.setter
    def linkFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("{point.id}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTreegraphStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTreegraphStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsTreegraphStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsTreegraphStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTreegraphStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTreegraphStatesSelectMarker)

        
class OptionPlotoptionsTreegraphStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTreegraphStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsTreegraphStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsTreegraphStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsTreegraphStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsTreegraphStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsTreegraphStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsTreegraphStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsTreegraphStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsTreegraphStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsTreegraphStatesSelect)

        
class OptionPlotoptionsTreegraphStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTreegraphStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTreegraphStatesHoverAnimation)

    @property
    def brightness(self):
        """Brightness for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTreegraphStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTreegraphStatesHoverMarker)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow option for hovered state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTreegraphSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTreegraphSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreegraphSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTreegraphSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTreegraphSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTreegraphSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTreegraphSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTreegraphSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreegraphSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreegraphSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTreegraphSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreegraphSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTreegraphSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTreegraphSonificationTracksMappingVolume)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreegraphSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsTreegraphSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreegraphSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreegraphSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreegraphSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreegraphSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreegraphSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreegraphSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsTreegraphSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsTreegraphSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreegraphSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreegraphSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsTreegraphSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsTreegraphSonificationTracks)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsTreegraphSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreegraphSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreegraphSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsTreegraphSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTreegraphSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTreegraphSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTreegraphSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTreegraphSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTreegraphSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTreegraphSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTreegraphSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTreegraphSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTreegraphSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTreegraphSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTreegraphSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTreegraphSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsTreegraphSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTreegraphSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTreegraphSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTreegraphSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTreegraphSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsTreegraphPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsTreegraphPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsTreegraphPointEvents)

        
class OptionPlotoptionsTreegraphOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsTreegraphOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsTreegraphOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsTreegraphOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsTreegraphOnpointPosition)

        
class OptionPlotoptionsTreegraphMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTreegraphMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsTreegraphMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsTreegraphMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsTreegraphMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsTreegraphMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsTreegraphMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsTreegraphMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsTreegraphMarkerStatesSelect)

        
class OptionPlotoptionsTreegraphMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(10)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsTreegraphMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsTreegraphMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphLink(Options):

    @property
    def color(self):
        """The color of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("default")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the links connecting nodes, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """Radius for the rounded corners of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(10)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the link shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(curved)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraphLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphLevelsColorvariation(Options):

    @property
    def key(self):
        """The key of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @key.setter
    def key(self, value: Any): self._config(value, js_type=False)

    @property
    def to(self):
        """The ending value of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphLevels(Options):

    @property
    def borderColor(self):
        """Can set a <code>borderColor</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderDashStyle(self):
        """Set the dash style of the border of all the point which lies on the level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set the borderWidth on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set a color on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorVariation(self) -> 'OptionPlotoptionsTreegraphLevelsColorvariation':
        """A configuration object to define how the color of a child varies from the parent&#39;s color. """
        return self._config_sub_data("colorVariation", OptionPlotoptionsTreegraphLevelsColorvariation)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsTreegraphLevelsDatalabels':
        """Can set the options of dataLabels on each point which lies on the level. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsTreegraphLevelsDatalabels)

    @property
    def layoutAlgorithm(self):
        """Can set the layoutAlgorithm option on a specific level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @layoutAlgorithm.setter
    def layoutAlgorithm(self, value: Any): self._config(value, js_type=False)

    @property
    def layoutStartingDirection(self):
        """Can set the layoutStartingDirection option on a specific level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @layoutStartingDirection.setter
    def layoutStartingDirection(self, value: Any): self._config(value, js_type=False)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsTreegraphLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsTreegraphLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsTreegraphLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsTreegraphLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsTreegraphLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsTreegraphLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsTreegraphLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsTreegraphLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def setRootNode(self):
        """Fires on a request for change of root node for the tree, before the update is made.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @setRootNode.setter
    def setRootNode(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTreegraph(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsTreegraphAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsTreegraphAccessibility)

    @property
    def allowDrillToNode(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowDrillToNode.setter
    def allowDrillToNode(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def collapseButton(self) -> 'OptionPlotoptionsTreegraphCollapsebutton':
        """Options applied to collapse Button. """
        return self._config_sub_data("collapseButton", OptionPlotoptionsTreegraphCollapsebutton)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the <code>options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsTreegraphDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsTreegraphDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsTreegraphEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsTreegraphEvents)

    @property
    def fillSpace(self):
        """Whether the treegraph series should fill the entire plot area in the X axis direction, even when there are collapsed points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @fillSpace.setter
    def fillSpace(self, flag: bool): self._config(flag, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsTreegraphLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsTreegraphLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionPlotoptionsTreegraphLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionPlotoptionsTreegraphLevels)

    @property
    def link(self) -> 'OptionPlotoptionsTreegraphLink':
        """. """
        return self._config_sub_data("link", OptionPlotoptionsTreegraphLink)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTreegraphMarker':
        """. """
        return self._config_sub_data("marker", OptionPlotoptionsTreegraphMarker)

    @property
    def onPoint(self) -> 'OptionPlotoptionsTreegraphOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsTreegraphOnpoint)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.15)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsTreegraphPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsTreegraphPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """Flips the positions of the nodes of a treegraph along the horizontal axis (vertical if chart is inverted).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this series type or specific series item in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsTreegraphSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsTreegraphSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsTreegraphStates':
        """A wrapper object for all the series options in specific states. """
        return self._config_sub_data("states", OptionPlotoptionsTreegraphStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsTreegraphTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsTreegraphTooltip)

    @property
    def traverseUpButton(self) -> 'OptionPlotoptionsTreegraphTraverseupbutton':
        """Options for the button appearing when traversing down in a treemap. """
        return self._config_sub_data("traverseUpButton", OptionPlotoptionsTreegraphTraverseupbutton)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphDatalabelsStyle(Options):

    @property
    def textOverflow(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("none")

    @textOverflow.setter
    def textOverflow(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphDatalabelsLinktextpathAttributes(Options):

    @property
    def startOffset(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("50%")

    @startOffset.setter
    def startOffset(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphDatalabelsLinktextpath(Options):

    @property
    def attributes(self) -> 'OptionPlotoptionsTreegraphDatalabelsLinktextpathAttributes':
        """Presentation attributes for the text path. """
        return self._config_sub_data("attributes", OptionPlotoptionsTreegraphDatalabelsLinktextpathAttributes)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsTreegraphDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsTreegraphDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsTreegraphDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsTreegraphDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionPlotoptionsTreegraphDatalabelsLinktextpath':
        """Options for a <em>link</em> label text which should follow link connection. """
        return self._config_sub_data("linkTextPath", OptionPlotoptionsTreegraphDatalabelsLinktextpath)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsTreegraphDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionPlotoptionsTreegraphDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionPlotoptionsTreegraphDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsTreegraphDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphCollapsebuttonStyle(Options):

    @property
    def cursor(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("pointer")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("1em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphCollapsebutton(Options):

    @property
    def enabled(self):
        """Whether the button should be visible.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def height(self):
        """Height of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(18)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the button in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onlyOnHover(self):
        """Whether the button should be visible only when the node is hovered.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @onlyOnHover.setter
    def onlyOnHover(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The symbol of the collapse button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("circle")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsTreegraphCollapsebuttonStyle':
        """CSS styles for the collapse button. """
        return self._config_sub_data("style", OptionPlotoptionsTreegraphCollapsebuttonStyle)

    @property
    def width(self):
        """Width of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(18)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """Offset of the button in the x direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Offset of the button in the y direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTreegraphAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTreegraphAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTreegraphAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsTreegraphAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsTreegraphAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsTreegraphAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsTreegraphAccessibilityPoint)

        
class OptionPlotoptionsTimelineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsTimelineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsTimelineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {point.key}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("{point.description}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTimelineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTimelineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsTimelineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsTimelineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTimelineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTimelineStatesSelectMarker)

        
class OptionPlotoptionsTimelineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTimelineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTimelineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsTimelineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsTimelineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsTimelineStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsTimelineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsTimelineStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsTimelineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsTimelineStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsTimelineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsTimelineStatesSelect)

        
class OptionPlotoptionsTimelineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTimelineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTimelineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsTimelineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsTimelineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTimelineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTimelineStatesHoverMarker)

        
class OptionPlotoptionsTimelineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTimelineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTimelineSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsTimelineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTimelineSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsTimelineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTimelineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTimelineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTimelineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTimelineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTimelineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTimelineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTimelineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTimelineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTimelineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTimelineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTimelineSonificationTracksMappingVolume)

        
class OptionPlotoptionsTimelineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTimelineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTimelineSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsTimelineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTimelineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTimelineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTimelineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTimelineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTimelineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTimelineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsTimelineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsTimelineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsTimelineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTimelineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTimelineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsTimelineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsTimelineSonificationTracks)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsTimelineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTimelineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTimelineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTimelineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsTimelineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTimelineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTimelineSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTimelineSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTimelineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTimelineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTimelineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTimelineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTimelineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTimelineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTimelineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTimelineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTimelineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTimelineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTimelineSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsTimelineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTimelineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTimelineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTimelineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTimelineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTimelineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTimelineSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsTimelinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimelinePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsTimelinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsTimelinePointEvents)

        
class OptionPlotoptionsTimelineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsTimelineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsTimelineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsTimelineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsTimelineOnpointPosition)

        
class OptionPlotoptionsTimelineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTimelineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTimelineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsTimelineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsTimelineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsTimelineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsTimelineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsTimelineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsTimelineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsTimelineMarkerStatesSelect)

        
class OptionPlotoptionsTimelineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(0)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(15)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(6)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsTimelineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsTimelineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("square")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsTimelineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsTimelineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTimelineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsTimelineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsTimelineDragdropGuideboxDefault)

        
class OptionPlotoptionsTimelineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsTimelineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsTimelineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsTimelineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsTimelineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTimelineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTimeline(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsTimelineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsTimelineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("x")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsTimelineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsTimelineDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsTimelineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsTimelineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsTimelineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsTimelineEvents)

    @property
    def ignoreHiddenPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsTimelineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsTimelineLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(4)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTimelineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsTimelineMarker)

    @property
    def onPoint(self) -> 'OptionPlotoptionsTimelineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsTimelineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsTimelinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsTimelinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsTimelineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsTimelineSonification)

    @property
    def states(self) -> 'OptionPlotoptionsTimelineStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsTimelineStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsTimelineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsTimelineTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTimelineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTimelineDatalabelsStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("normal")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

    @property
    def textOutline(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("none")

    @textOutline.setter
    def textOutline(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def alternate(self):
        """Whether to position data labels alternately.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @alternate.setter
    def alternate(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsTimelineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsTimelineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("#999999")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("#333333")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """A pixel value defining the distance between the data label and the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @distance.setter
    def distance(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsTimelineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsTimelineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """Shadow options for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsTimelineDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionPlotoptionsTimelineDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionPlotoptionsTimelineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsTimelineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTimelineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTimelineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTimelineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsTimelineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsTimelineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsTimelineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsTimelineAccessibilityPoint)

        
class OptionPlotoptionsTilemapZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsTilemapTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsTilemapTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("{point.x}, {point.y}: {point.value}<br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTilemapStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTilemapStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsTilemapStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsTilemapStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTilemapStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTilemapStatesSelectMarker)

        
class OptionPlotoptionsTilemapStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTilemapStatesHoverHaloAttributes(Options):

    @property
    def zIndex(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(3)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesHoverHalo(Options):

    @property
    def attributes(self) -> 'OptionPlotoptionsTilemapStatesHoverHaloAttributes':
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>. """
        return self._config_sub_data("attributes", OptionPlotoptionsTilemapStatesHoverHaloAttributes)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(0.5)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(2)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTilemapStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsTilemapStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsTilemapStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsTilemapStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsTilemapStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsTilemapStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsTilemapStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsTilemapStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsTilemapStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsTilemapStatesSelect)

        
class OptionPlotoptionsTilemapStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsTilemapStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsTilemapStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsTilemapStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsTilemapStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsTilemapStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsTilemapStatesHoverMarker)

        
class OptionPlotoptionsTilemapSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTilemapSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTilemapSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsTilemapSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTilemapSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsTilemapSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTilemapSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTilemapSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTilemapSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTilemapSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTilemapSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTilemapSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTilemapSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTilemapSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTilemapSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTilemapSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTilemapSonificationTracksMappingVolume)

        
class OptionPlotoptionsTilemapSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTilemapSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTilemapSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsTilemapSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTilemapSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTilemapSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTilemapSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTilemapSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTilemapSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTilemapSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsTilemapSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsTilemapSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsTilemapSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTilemapSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTilemapSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsTilemapSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsTilemapSonificationTracks)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsTilemapSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTilemapSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTilemapSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTilemapSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsTilemapSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsTilemapSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsTilemapSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTilemapSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsTilemapSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsTilemapSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsTilemapSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsTilemapSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsTilemapSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsTilemapSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsTilemapSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsTilemapSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsTilemapSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsTilemapSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsTilemapSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsTilemapSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsTilemapSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsTilemapSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsTilemapSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsTilemapSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsTilemapSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsTilemapSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsTilemapPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemapPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsTilemapPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsTilemapPointEvents)

        
class OptionPlotoptionsTilemapOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsTilemapOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsTilemapOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsTilemapOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsTilemapOnpointPosition)

        
class OptionPlotoptionsTilemapLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsTilemapLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsTilemapLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTilemapDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsTilemap(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsTilemapAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsTilemapAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Animation is disabled by default on the heatmap series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderRadius(self):
        """The border radius for each heatmap item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("value")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colsize(self):
        """The column size - how many X axis units each column in the tilemap should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(1)

    @colsize.setter
    def colsize(self, num: float): self._config(num, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsTilemapDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsTilemapDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsTilemapEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsTilemapEvents)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def interpolation(self):
        """Make the heatmap render its data points as an interpolated image.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @interpolation.setter
    def interpolation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsTilemapLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsTilemapLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def nullColor(self):
        """The color applied to null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("#f7f7f7")

    @nullColor.setter
    def nullColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsTilemapOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsTilemapOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsTilemapPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsTilemapPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """The padding between points in the tilemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(2)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rowsize(self):
        """The row size - how many Y axis units each tilemap row should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(1)

    @rowsize.setter
    def rowsize(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsTilemapSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsTilemapSonification)

    @property
    def states(self) -> 'OptionPlotoptionsTilemapStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsTilemapStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tileShape(self):
        """The shape of the tiles in the tilemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(hexagon)

    @tileShape.setter
    def tileShape(self, value: Any): self._config(value, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsTilemapTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsTilemapTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsTilemapZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsTilemapZones)

        
class OptionPlotoptionsTilemapDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTilemapDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsTilemapDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsTilemapDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsTilemapDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsTilemapDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsTilemapDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsTilemapDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsTilemapAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsTilemapAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsTilemapAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsTilemapAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsTilemapAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsTilemapAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsTilemapAccessibilityPoint)

        
class OptionPlotoptionsSunburstTraverseupbuttonPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """Horizontal offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(-10)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Vertical offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(10)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstTraverseupbutton(Options):

    @property
    def position(self) -> 'OptionPlotoptionsSunburstTraverseupbuttonPosition':
        """The position of the button. """
        return self._config_sub_data("position", OptionPlotoptionsSunburstTraverseupbuttonPosition)

        
class OptionPlotoptionsSunburstTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsSunburstTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsSunburstTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSunburstStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSunburstStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsSunburstStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsSunburstStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsSunburstStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsSunburstStatesSelectMarker)

        
class OptionPlotoptionsSunburstStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSunburstStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSunburstStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSunburstStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsSunburstStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsSunburstStatesHoverHalo)

        
class OptionPlotoptionsSunburstStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSunburstStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsSunburstStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsSunburstStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsSunburstStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsSunburstStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsSunburstStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsSunburstStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsSunburstStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsSunburstStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsSunburstStatesSelect)

        
class OptionPlotoptionsSunburstSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSunburstSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSunburstSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsSunburstSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSunburstSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsSunburstSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSunburstSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSunburstSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSunburstSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSunburstSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSunburstSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSunburstSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSunburstSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSunburstSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSunburstSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSunburstSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSunburstSonificationTracksMappingVolume)

        
class OptionPlotoptionsSunburstSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSunburstSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSunburstSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsSunburstSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSunburstSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSunburstSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSunburstSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSunburstSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSunburstSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSunburstSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsSunburstSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsSunburstSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsSunburstSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSunburstSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSunburstSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsSunburstSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsSunburstSonificationTracks)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsSunburstSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSunburstSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSunburstSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSunburstSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsSunburstSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSunburstSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSunburstSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSunburstSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSunburstSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSunburstSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSunburstSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSunburstSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSunburstSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSunburstSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSunburstSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSunburstSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSunburstSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSunburstSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSunburstSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsSunburstSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSunburstSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSunburstSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSunburstSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSunburstSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSunburstSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSunburstSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsSunburstPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsSunburstPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsSunburstPointEvents)

        
class OptionPlotoptionsSunburstOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsSunburstOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsSunburstOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsSunburstOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsSunburstOnpointPosition)

        
class OptionPlotoptionsSunburstLevelsize(Options):

    @property
    def unit(self):
        """How to interpret <code>levelSize.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("weight")

    @unit.setter
    def unit(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstLevelsColorvariation(Options):

    @property
    def key(self):
        """The key of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @key.setter
    def key(self, text: str): self._config(text, js_type=False)

    @property
    def to(self):
        """The ending value of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstLevels(Options):

    @property
    def borderColor(self):
        """Can set a <code>borderColor</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderDashStyle(self):
        """Can set a <code>borderDashStyle</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set a <code>borderWidth</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set a <code>color</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Determines whether the chart should receive one color per point based on this level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorVariation(self) -> 'OptionPlotoptionsSunburstLevelsColorvariation':
        """Can set a <code>colorVariation</code> on all points which lies on the same level. """
        return self._config_sub_data("colorVariation", OptionPlotoptionsSunburstLevelsColorvariation)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsSunburstLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lies on the same level. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsSunburstLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def levelSize(self):
        """Can set a <code>levelSize</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @levelSize.setter
    def levelSize(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSunburstLevelsDatalabelsStyle(Options):

    @property
    def textOverflow(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("ellipsis")

    @textOverflow.setter
    def textOverflow(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstLevelsDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsSunburstLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsSunburstLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsSunburstLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsSunburstLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def rotationMode(self):
        """Decides how the data label will be rotated relative to the perimeter of the sunburst.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(circular)

    @rotationMode.setter
    def rotationMode(self, value: Any): self._config(value, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsSunburstLevelsDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionPlotoptionsSunburstLevelsDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionPlotoptionsSunburstLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsSunburstLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstBreadcrumbsEvents(Options):

    @property
    def click(self):
        """Fires when clicking on the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburstDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSunburst(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsSunburstAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsSunburstAccessibility)

    @property
    def allowDrillToNode(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowDrillToNode.setter
    def allowDrillToNode(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowTraversingTree(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowTraversingTree.setter
    def allowTraversingTree(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def breadcrumbs(self) -> 'OptionPlotoptionsSunburstBreadcrumbs':
        """Options for the breadcrumbs, the navigation at the top leading the way up through the traversed levels. """
        return self._config_sub_data("breadcrumbs", OptionPlotoptionsSunburstBreadcrumbs)

    @property
    def center(self):
        """The center of the sunburst chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(["50%", "50%"])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsSunburstDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsSunburstDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsSunburstEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsSunburstEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levelIsConstant(self):
        """Used together with the levels and <code>allowDrillToNode</code> options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @levelIsConstant.setter
    def levelIsConstant(self, flag: bool): self._config(flag, js_type=False)

    @property
    def levels(self) -> 'OptionPlotoptionsSunburstLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionPlotoptionsSunburstLevels)

    @property
    def levelSize(self) -> 'OptionPlotoptionsSunburstLevelsize':
        """Determines the width of the ring per level. """
        return self._config_sub_data("levelSize", OptionPlotoptionsSunburstLevelsize)

    @property
    def onPoint(self) -> 'OptionPlotoptionsSunburstOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsSunburstOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsSunburstPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsSunburstPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rootId(self):
        """Which point to use as a root in the visualization.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @rootId.setter
    def rootId(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsSunburstSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsSunburstSonification)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsSunburstStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsSunburstStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsSunburstTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsSunburstTooltip)

    @property
    def traverseUpButton(self) -> 'OptionPlotoptionsSunburstTraverseupbutton':
        """Options for the button appearing when traversing down in a sunburst. """
        return self._config_sub_data("traverseUpButton", OptionPlotoptionsSunburstTraverseupbutton)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSunburstDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSunburstDatalabelsStyle(Options):

    @property
    def textOverflow(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("ellipsis")

    @textOverflow.setter
    def textOverflow(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsSunburstDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsSunburstDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsSunburstDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsSunburstDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def rotationMode(self):
        """Decides how the data label will be rotated relative to the perimeter of the sunburst.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(circular)

    @rotationMode.setter
    def rotationMode(self, value: Any): self._config(value, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsSunburstDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionPlotoptionsSunburstDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionPlotoptionsSunburstDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsSunburstDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstBreadcrumbsSeparatorStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstBreadcrumbsSeparator(Options):

    @property
    def style(self) -> 'OptionPlotoptionsSunburstBreadcrumbsSeparatorStyle':
        """CSS styles for the breadcrumbs separator. """
        return self._config_sub_data("style", OptionPlotoptionsSunburstBreadcrumbsSeparatorStyle)

    @property
    def text(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("/")

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstBreadcrumbsPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("left")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The X offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The Y offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstBreadcrumbs(Options):

    @property
    def buttonSpacing(self):
        """The default padding for each button and separator in each direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(5)

    @buttonSpacing.setter
    def buttonSpacing(self, num: float): self._config(num, js_type=False)

    @property
    def buttonTheme(self) -> 'OptionPlotoptionsSunburstBreadcrumbsButtontheme':
        """A collection of attributes for the buttons. """
        return self._config_sub_data("buttonTheme", OptionPlotoptionsSunburstBreadcrumbsButtontheme)

    @property
    def events(self) -> 'OptionPlotoptionsSunburstBreadcrumbsEvents':
        """. """
        return self._config_sub_data("events", OptionPlotoptionsSunburstBreadcrumbsEvents)

    @property
    def floating(self):
        """When the breadcrumbs are floating, the plot area will not move to make space for it.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @floating.setter
    def floating(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format the breadcrumb text from scratch.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsSunburstBreadcrumbsPosition':
        """Positioning for the button row. """
        return self._config_sub_data("position", OptionPlotoptionsSunburstBreadcrumbsPosition)

    @property
    def relativeTo(self):
        """What box to align the button to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("plotBox")

    @relativeTo.setter
    def relativeTo(self, text: str): self._config(text, js_type=False)

    @property
    def rtl(self):
        """Whether to reverse the order of buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @rtl.setter
    def rtl(self, flag: bool): self._config(flag, js_type=False)

    @property
    def separator(self) -> 'OptionPlotoptionsSunburstBreadcrumbsSeparator':
        """Options object for Breadcrumbs separator. """
        return self._config_sub_data("separator", OptionPlotoptionsSunburstBreadcrumbsSeparator)

    @property
    def showFullPath(self):
        """Show full path or only a single button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(True)

    @showFullPath.setter
    def showFullPath(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """CSS styles for all breadcrumbs.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def useHTML(self):
        """Whether to use HTML to render the breadcrumbs items texts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """The z index of the breadcrumbs group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(7)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSunburstBreadcrumbsButtonthemeStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#334eff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstBreadcrumbsButtontheme(Options):

    @property
    def style(self) -> 'OptionPlotoptionsSunburstBreadcrumbsButtonthemeStyle':
        """. """
        return self._config_sub_data("style", OptionPlotoptionsSunburstBreadcrumbsButtonthemeStyle)

        
class OptionPlotoptionsSunburstAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSunburstAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSunburstAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsSunburstAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsSunburstAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsSunburstAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsSunburstAccessibilityPoint)

        
class OptionPlotoptionsStreamgraphZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsStreamgraphTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsStreamgraphTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsStreamgraphStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsStreamgraphStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsStreamgraphStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsStreamgraphStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsStreamgraphStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsStreamgraphStatesSelectMarker)

        
class OptionPlotoptionsStreamgraphStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsStreamgraphStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsStreamgraphStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsStreamgraphStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsStreamgraphStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsStreamgraphStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsStreamgraphStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsStreamgraphStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsStreamgraphStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsStreamgraphStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsStreamgraphStatesSelect)

        
class OptionPlotoptionsStreamgraphStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsStreamgraphStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsStreamgraphStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsStreamgraphStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsStreamgraphStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsStreamgraphStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsStreamgraphStatesHoverMarker)

        
class OptionPlotoptionsStreamgraphSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsStreamgraphSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsStreamgraphSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsStreamgraphSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsStreamgraphSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsStreamgraphSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsStreamgraphSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsStreamgraphSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsStreamgraphSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsStreamgraphSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsStreamgraphSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsStreamgraphSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsStreamgraphSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsStreamgraphSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsStreamgraphSonificationTracksMappingVolume)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsStreamgraphSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsStreamgraphSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsStreamgraphSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsStreamgraphSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsStreamgraphSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsStreamgraphSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsStreamgraphSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsStreamgraphSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsStreamgraphSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsStreamgraphSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsStreamgraphSonificationTracks)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsStreamgraphSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsStreamgraphSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsStreamgraphSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsStreamgraphSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsStreamgraphSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsStreamgraphSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsStreamgraphSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsStreamgraphSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsStreamgraphSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsStreamgraphSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsStreamgraphSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsStreamgraphSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsStreamgraphSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsStreamgraphSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsStreamgraphSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsStreamgraphSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsStreamgraphSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsStreamgraphPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraphPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsStreamgraphPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsStreamgraphPointEvents)

        
class OptionPlotoptionsStreamgraphOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsStreamgraphOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsStreamgraphOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsStreamgraphOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsStreamgraphOnpointPosition)

        
class OptionPlotoptionsStreamgraphMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsStreamgraphMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsStreamgraphMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsStreamgraphMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsStreamgraphMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsStreamgraphMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsStreamgraphMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsStreamgraphMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsStreamgraphMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsStreamgraphMarkerStatesSelect)

        
class OptionPlotoptionsStreamgraphMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsStreamgraphMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsStreamgraphMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsStreamgraphLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsStreamgraphLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsStreamgraphDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsStreamgraphDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsStreamgraphDragdropGuideboxDefault)

        
class OptionPlotoptionsStreamgraphDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsStreamgraphDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsStreamgraphDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsStreamgraphDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsStreamgraphDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsStreamgraphEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsStreamgraph(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsStreamgraphAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsStreamgraphAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsStreamgraphDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsStreamgraphDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsStreamgraphDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsStreamgraphDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsStreamgraphDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsStreamgraphDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsStreamgraphEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsStreamgraphEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsStreamgraphLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsStreamgraphLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsStreamgraphMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsStreamgraphMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsStreamgraphOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsStreamgraphOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsStreamgraphPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsStreamgraphPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsStreamgraphSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsStreamgraphSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get("stream")

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsStreamgraphStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsStreamgraphStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsStreamgraphTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsStreamgraphTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsStreamgraphZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsStreamgraphZones)

        
class OptionPlotoptionsStreamgraphDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsStreamgraphDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsStreamgraphDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsStreamgraphDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsStreamgraphDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsStreamgraphDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsStreamgraphDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsStreamgraphDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsStreamgraphAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsStreamgraphAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsStreamgraphAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsStreamgraphAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsStreamgraphAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsStreamgraphAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsStreamgraphAccessibilityPoint)

        
class OptionPlotoptionsSplineZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsSplineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsSplineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSplineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSplineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsSplineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsSplineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsSplineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsSplineStatesSelectMarker)

        
class OptionPlotoptionsSplineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSplineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSplineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsSplineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsSplineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsSplineStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsSplineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsSplineStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsSplineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsSplineStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsSplineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsSplineStatesSelect)

        
class OptionPlotoptionsSplineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSplineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSplineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsSplineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsSplineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsSplineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsSplineStatesHoverMarker)

        
class OptionPlotoptionsSplineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSplineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSplineSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsSplineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSplineSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsSplineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSplineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSplineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSplineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSplineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSplineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSplineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSplineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSplineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSplineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSplineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSplineSonificationTracksMappingVolume)

        
class OptionPlotoptionsSplineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSplineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSplineSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsSplineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSplineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSplineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSplineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSplineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSplineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSplineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsSplineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsSplineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsSplineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsSplineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSplineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSplineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsSplineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsSplineSonificationTracks)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsSplineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsSplineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSplineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSplineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSplineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSplineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSplineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsSplineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSplineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSplineSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSplineSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSplineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSplineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSplineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSplineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSplineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSplineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSplineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSplineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSplineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSplineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSplineSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsSplineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSplineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSplineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSplineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSplineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSplineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSplineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSplineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSplineSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsSplinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSplinePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsSplinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsSplinePointEvents)

        
class OptionPlotoptionsSplineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsSplineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsSplineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsSplineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsSplineOnpointPosition)

        
class OptionPlotoptionsSplineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSplineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSplineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsSplineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsSplineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsSplineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsSplineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsSplineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsSplineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsSplineMarkerStatesSelect)

        
class OptionPlotoptionsSplineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsSplineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsSplineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsSplineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsSplineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSplineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsSplineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsSplineDragdropGuideboxDefault)

        
class OptionPlotoptionsSplineDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsSplineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsSplineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsSplineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsSplineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSplineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSpline(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsSplineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsSplineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsSplineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsSplineDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsSplineDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsSplineDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsSplineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsSplineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsSplineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsSplineEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsSplineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsSplineLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsSplineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsSplineMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsSplineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsSplineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsSplinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsSplinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsSplineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsSplineSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsSplineStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsSplineStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsSplineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsSplineTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsSplineZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsSplineZones)

        
class OptionPlotoptionsSplineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSplineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsSplineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsSplineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsSplineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsSplineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsSplineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsSplineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSplineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSplineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSplineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsSplineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsSplineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsSplineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsSplineAccessibilityPoint)

        
class OptionPlotoptionsSolidgaugeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsSolidgaugeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsSolidgaugeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSolidgaugeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSolidgaugeSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSolidgaugeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSolidgaugeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSolidgaugeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSolidgaugeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSolidgaugeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSolidgaugeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSolidgaugeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSolidgaugeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSolidgaugeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSolidgaugeSonificationTracksMappingVolume)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSolidgaugeSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsSolidgaugeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSolidgaugeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSolidgaugeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSolidgaugeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsSolidgaugeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSolidgaugeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSolidgaugeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsSolidgaugeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsSolidgaugeSonificationTracks)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSolidgaugeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSolidgaugeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSolidgaugeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSolidgaugeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSolidgaugeSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsSolidgaugePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgaugePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsSolidgaugePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsSolidgaugePointEvents)

        
class OptionPlotoptionsSolidgaugeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSolidgaugeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSolidgaugeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsSolidgaugeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsSolidgaugeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsSolidgaugeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsSolidgaugeOnpointPosition)

        
class OptionPlotoptionsSolidgaugeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsSolidgaugeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsSolidgaugeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSolidgaugeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSolidgaugeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSolidgauge(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsSolidgaugeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsSolidgaugeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Whether to give each point an individual color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsSolidgaugeDatalabels':
        """Data labels for the gauge. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsSolidgaugeDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsSolidgaugeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsSolidgaugeEvents)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def innerRadius(self):
        """The inner radius for points in a solid gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get('"60%"')

    @innerRadius.setter
    def innerRadius(self, text: str): self._config(text, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsSolidgaugeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsSolidgaugeLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """Whether the strokes of the solid gauge should be <code>round</code> or <code>square</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsSolidgaugeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsSolidgaugeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def overshoot(self):
        """Allow the gauge to overshoot the end of the perimeter axis by this many degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(0)

    @overshoot.setter
    def overshoot(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsSolidgaugePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsSolidgaugePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The outer radius for points in a solid gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get('"100%"')

    @radius.setter
    def radius(self, text: str): self._config(text, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rounded(self):
        """Whether to draw rounded edges on the gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(False)

    @rounded.setter
    def rounded(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsSolidgaugeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsSolidgaugeSonification)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold or base level for the gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsSolidgaugeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsSolidgaugeTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSolidgaugeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSolidgaugeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsSolidgaugeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsSolidgaugeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsSolidgaugeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsSolidgaugeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsSolidgaugeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsSolidgaugeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(2)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSolidgaugeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSolidgaugeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSolidgaugeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsSolidgaugeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsSolidgaugeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsSolidgaugeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsSolidgaugeAccessibilityPoint)

        
class OptionPlotoptionsSeriesZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsSeriesTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsSeriesTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSeriesStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSeriesStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsSeriesStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsSeriesStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsSeriesStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsSeriesStatesSelectMarker)

        
class OptionPlotoptionsSeriesStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSeriesStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSeriesStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsSeriesStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsSeriesStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsSeriesStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsSeriesStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsSeriesStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsSeriesStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsSeriesStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsSeriesStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsSeriesStatesSelect)

        
class OptionPlotoptionsSeriesStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSeriesStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSeriesStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsSeriesStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsSeriesStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsSeriesStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsSeriesStatesHoverMarker)

        
class OptionPlotoptionsSeriesSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSeriesSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSeriesSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsSeriesSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSeriesSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsSeriesSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSeriesSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSeriesSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSeriesSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSeriesSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSeriesSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSeriesSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSeriesSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSeriesSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSeriesSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSeriesSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSeriesSonificationTracksMappingVolume)

        
class OptionPlotoptionsSeriesSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSeriesSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSeriesSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsSeriesSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSeriesSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSeriesSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSeriesSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSeriesSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSeriesSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSeriesSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsSeriesSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsSeriesSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsSeriesSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSeriesSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSeriesSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsSeriesSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsSeriesSonificationTracks)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsSeriesSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSeriesSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSeriesSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSeriesSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsSeriesSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSeriesSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSeriesSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSeriesSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSeriesSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSeriesSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSeriesSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSeriesSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSeriesSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSeriesSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSeriesSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSeriesSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSeriesSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSeriesSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSeriesSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsSeriesSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSeriesSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSeriesSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSeriesSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeriesSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSeriesSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSeriesSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSeriesSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsSeriesPointEvents(Options):

    def click(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)
        
    def drag(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def dragStart(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def drop(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def mouseOut(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def mouseOver(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def remove(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def select(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def unselect(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    def update(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

        
class OptionPlotoptionsSeriesPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsSeriesPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsSeriesPointEvents)

        
class OptionPlotoptionsSeriesOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsSeriesOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsSeriesOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsSeriesOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsSeriesOnpointPosition)

        
class OptionPlotoptionsSeriesMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSeriesMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSeriesMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsSeriesMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsSeriesMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsSeriesMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsSeriesMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsSeriesMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsSeriesMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsSeriesMarkerStatesSelect)

        
class OptionPlotoptionsSeriesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsSeriesMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsSeriesMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsSeriesLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsSeriesLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSeriesDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsSeriesDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsSeriesDragdropGuideboxDefault)

        
class OptionPlotoptionsSeriesDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsSeriesDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsSeriesDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsSeriesDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsSeriesDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSeriesEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSeries(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsSeriesAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsSeriesAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsSeriesDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsSeriesDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsSeriesDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsSeriesDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsSeriesDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsSeriesDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsSeriesEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsSeriesEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsSeriesLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsSeriesLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsSeriesMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsSeriesMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsSeriesOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsSeriesOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsSeriesPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsSeriesPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsSeriesSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsSeriesSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsSeriesStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsSeriesStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsSeriesTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsSeriesTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsSeriesZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsSeriesZones)

        
class OptionPlotoptionsSeriesDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSeriesDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsSeriesDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsSeriesDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsSeriesDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsSeriesDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsSeriesDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsSeriesDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSeriesAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSeriesAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSeriesAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsSeriesAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsSeriesAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsSeriesAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsSeriesAccessibilityPoint)

        
class OptionPlotoptionsScatter3dZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsScatter3dTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsScatter3dTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter3D/Scatter3DSeriesDefaults.ts
        """
        return self._config_get("x: <b>{point.x}</b><br/>y: <b>{point.y}</b><br/>z: <b>{point.z}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatter3dStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsScatter3dStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsScatter3dStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsScatter3dStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsScatter3dStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsScatter3dStatesSelectMarker)

        
class OptionPlotoptionsScatter3dStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatter3dStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatter3dStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsScatter3dStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsScatter3dStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsScatter3dStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsScatter3dStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsScatter3dStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsScatter3dStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsScatter3dStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsScatter3dStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsScatter3dStatesSelect)

        
class OptionPlotoptionsScatter3dStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatter3dStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsScatter3dStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsScatter3dStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsScatter3dStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsScatter3dStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsScatter3dStatesHoverMarker)

        
class OptionPlotoptionsScatter3dSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsScatter3dSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsScatter3dSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatter3dSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsScatter3dSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsScatter3dSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsScatter3dSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsScatter3dSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsScatter3dSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatter3dSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatter3dSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsScatter3dSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatter3dSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsScatter3dSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsScatter3dSonificationTracksMappingVolume)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatter3dSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsScatter3dSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatter3dSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatter3dSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatter3dSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatter3dSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatter3dSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatter3dSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsScatter3dSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsScatter3dSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatter3dSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatter3dSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsScatter3dSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsScatter3dSonificationTracks)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsScatter3dSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatter3dSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatter3dSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsScatter3dSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsScatter3dSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsScatter3dSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsScatter3dSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsScatter3dSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsScatter3dSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsScatter3dSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatter3dSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatter3dSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsScatter3dSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatter3dSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsScatter3dSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsScatter3dSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsScatter3dSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatter3dSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatter3dSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatter3dSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatter3dSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsScatter3dPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsScatter3dPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsScatter3dPointEvents)

        
class OptionPlotoptionsScatter3dOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsScatter3dOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsScatter3dOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsScatter3dOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsScatter3dOnpointPosition)

        
class OptionPlotoptionsScatter3dMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatter3dMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatter3dMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsScatter3dMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsScatter3dMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsScatter3dMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsScatter3dMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsScatter3dMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsScatter3dMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsScatter3dMarkerStatesSelect)

        
class OptionPlotoptionsScatter3dMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsScatter3dMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsScatter3dMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsScatter3dLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsScatter3dLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatter3dDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatter3dJitter(Options):

    @property
    def x(self):
        """The maximal X offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The maximal Y offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3d(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsScatter3dAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsScatter3dAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsScatter3dDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsScatter3dDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsScatter3dDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsScatter3dDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsScatter3dEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsScatter3dEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def jitter(self) -> 'OptionPlotoptionsScatter3dJitter':
        """Apply a jitter effect for the rendered markers. """
        return self._config_sub_data("jitter", OptionPlotoptionsScatter3dJitter)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsScatter3dLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsScatter3dLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsScatter3dMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsScatter3dMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsScatter3dOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsScatter3dOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsScatter3dPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsScatter3dPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsScatter3dSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsScatter3dSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsScatter3dStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsScatter3dStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsScatter3dTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsScatter3dTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsScatter3dZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsScatter3dZones)

        
class OptionPlotoptionsScatter3dDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatter3dDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsScatter3dDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsScatter3dDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsScatter3dDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsScatter3dDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsScatter3dDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsScatter3dDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter3dAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatter3dAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatter3dAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsScatter3dAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsScatter3dAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsScatter3dAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsScatter3dAccessibilityPoint)

        
class OptionPlotoptionsScatterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsScatterTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsScatterTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("x: <b>{point.x}</b><br/>y: <b>{point.y}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatterStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsScatterStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsScatterStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsScatterStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsScatterStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsScatterStatesSelectMarker)

        
class OptionPlotoptionsScatterStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatterStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatterStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsScatterStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsScatterStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsScatterStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsScatterStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsScatterStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsScatterStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsScatterStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsScatterStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsScatterStatesSelect)

        
class OptionPlotoptionsScatterStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatterStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsScatterStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsScatterStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsScatterStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsScatterStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsScatterStatesHoverMarker)

        
class OptionPlotoptionsScatterSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsScatterSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsScatterSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsScatterSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatterSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsScatterSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsScatterSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsScatterSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsScatterSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsScatterSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsScatterSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatterSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatterSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsScatterSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatterSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsScatterSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsScatterSonificationTracksMappingVolume)

        
class OptionPlotoptionsScatterSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatterSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatterSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsScatterSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatterSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatterSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatterSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatterSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatterSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatterSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsScatterSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsScatterSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsScatterSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsScatterSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatterSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatterSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsScatterSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsScatterSonificationTracks)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsScatterSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsScatterSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatterSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatterSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatterSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatterSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatterSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsScatterSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsScatterSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsScatterSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatterSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsScatterSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsScatterSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsScatterSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsScatterSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsScatterSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsScatterSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsScatterSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsScatterSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsScatterSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsScatterSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsScatterSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsScatterSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsScatterSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsScatterSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsScatterSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsScatterSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsScatterSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsScatterSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsScatterSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsScatterSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsScatterPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsScatterPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsScatterPointEvents)

        
class OptionPlotoptionsScatterOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsScatterOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsScatterOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsScatterOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsScatterOnpointPosition)

        
class OptionPlotoptionsScatterMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatterMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsScatterMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsScatterMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsScatterMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsScatterMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsScatterMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsScatterMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsScatterMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsScatterMarkerStatesSelect)

        
class OptionPlotoptionsScatterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsScatterMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsScatterMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsScatterLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsScatterLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatterDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterClusterEvents(Options):

    @property
    def drillToCluster(self):
        """Fires when the cluster point is clicked and <code>drillToCluster</code> is enabled.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @drillToCluster.setter
    def drillToCluster(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsScatterDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsScatterDragdropGuideboxDefault)

        
class OptionPlotoptionsScatterDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsScatterDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsScatterDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsScatterDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsScatterDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatterEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsScatterJitter(Options):

    @property
    def x(self):
        """The maximal X offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The maximal Y offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatter(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsScatterAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsScatterAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cluster(self) -> 'OptionPlotoptionsScatterCluster':
        """Options for marker clusters, the concept of sampling the data values into larger blocks in order to ease readability and increase performance of the JavaScript charts. """
        return self._config_sub_data("cluster", OptionPlotoptionsScatterCluster)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsScatterDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsScatterDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsScatterDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsScatterDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsScatterDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsScatterDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsScatterEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsScatterEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def jitter(self) -> 'OptionPlotoptionsScatterJitter':
        """Apply a jitter effect for the rendered markers. """
        return self._config_sub_data("jitter", OptionPlotoptionsScatterJitter)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsScatterLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsScatterLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsScatterMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsScatterMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsScatterOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsScatterOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsScatterPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsScatterPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsScatterSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsScatterSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsScatterStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsScatterStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsScatterTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsScatterTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsScatterZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsScatterZones)

        
class OptionPlotoptionsScatterDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatterDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsScatterDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsScatterDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsScatterDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsScatterDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsScatterDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsScatterDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterClusterZonesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterClusterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def from_(self):
        """The value where the zone starts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsScatterClusterZonesMarker':
        """Settings for the cluster marker belonging to the zone. """
        return self._config_sub_data("marker", OptionPlotoptionsScatterClusterZonesMarker)

    @property
    def to(self):
        """The value where the zone ends.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterClusterStatesHover(Options):

    @property
    def fillColor(self):
        """The fill color of the cluster marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterClusterStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsScatterClusterStatesHover':
        """. """
        return self._config_sub_data("hover", OptionPlotoptionsScatterClusterStatesHover)

        
class OptionPlotoptionsScatterClusterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsScatterClusterLayoutalgorithm(Options):

    @property
    def distance(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>distance</code> is a maximum distance between point and cluster center so that this point will be inside the cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(40)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def gridSize(self):
        """When <code>type</code> is set to the <code>grid</code>, <code>gridSize</code> is a size of a grid square element either as a number defining pixels, or a percentage defining a percentage of the plot area width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(50)

    @gridSize.setter
    def gridSize(self, num: float): self._config(num, js_type=False)

    @property
    def iterations(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>iterations</code> are the number of iterations that this algorithm will be repeated to find clusters positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @iterations.setter
    def iterations(self, num: float): self._config(num, js_type=False)

    @property
    def kmeansThreshold(self):
        """When <code>type</code> is set to <code>undefined</code> and there are more visible points than the kmeansThreshold the <code>grid</code> algorithm is used to find clusters, otherwise <code>kmeans</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(100)

    @kmeansThreshold.setter
    def kmeansThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used to combine points into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterCluster(Options):

    @property
    def allowOverlap(self):
        """When set to <code>false</code> prevent cluster overlapping - this option works only when <code>layoutAlgorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Options for the cluster marker animation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get({ "duration": 500 })

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsScatterClusterDatalabels':
        """Options for the cluster data labels. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsScatterClusterDatalabels)

    @property
    def drillToCluster(self):
        """Zoom the plot area to the cluster points range when a cluster is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @drillToCluster.setter
    def drillToCluster(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Whether to enable the marker-clusters module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsScatterClusterEvents':
        """. """
        return self._config_sub_data("events", OptionPlotoptionsScatterClusterEvents)

    @property
    def layoutAlgorithm(self) -> 'OptionPlotoptionsScatterClusterLayoutalgorithm':
        """Options for layout algorithm. """
        return self._config_sub_data("layoutAlgorithm", OptionPlotoptionsScatterClusterLayoutalgorithm)

    @property
    def marker(self) -> 'OptionPlotoptionsScatterClusterMarker':
        """Options for the cluster marker. """
        return self._config_sub_data("marker", OptionPlotoptionsScatterClusterMarker)

    @property
    def minimumClusterSize(self):
        """The minimum amount of points to be combined into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(2)

    @minimumClusterSize.setter
    def minimumClusterSize(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsScatterClusterStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsScatterClusterStates)

    @property
    def zones(self) -> 'OptionPlotoptionsScatterClusterZones':
        """An array defining zones within marker clusters. """
        return self._config_sub_data("zones", OptionPlotoptionsScatterClusterZones)

        
class OptionPlotoptionsScatterClusterDatalabelsStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("contrast")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterClusterDatalabels(Options):

    @property
    def align(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("{point.clusterPointsAmount}")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def inside(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsScatterClusterDatalabelsStyle':
        """. """
        return self._config_sub_data("style", OptionPlotoptionsScatterClusterDatalabelsStyle)

    @property
    def verticalAlign(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsScatterAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsScatterAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsScatterAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsScatterAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsScatterAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsScatterAccessibilityPoint)

        
class OptionPlotoptionsSankeyTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeyTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsSankeyTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsSankeyTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.name}: <b>{point.sum}</b><br/>")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeyStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsSankeyStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsSankeyStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsSankeyStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsSankeyStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsSankeyStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsSankeyStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsSankeyStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsSankeyStatesSelect)

        
class OptionPlotoptionsSankeySonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSankeySonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSankeySonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsSankeySonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSankeySonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsSankeySonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSankeySonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSankeySonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSankeySonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSankeySonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSankeySonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSankeySonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSankeySonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSankeySonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSankeySonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSankeySonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSankeySonificationTracksMappingVolume)

        
class OptionPlotoptionsSankeySonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSankeySonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSankeySonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsSankeySonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSankeySonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSankeySonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSankeySonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSankeySonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSankeySonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSankeySonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsSankeySonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsSankeySonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsSankeySonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsSankeySonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSankeySonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSankeySonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsSankeySonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsSankeySonificationTracks)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsSankeySonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsSankeySonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSankeySonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSankeySonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSankeySonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSankeySonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSankeySonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsSankeySonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsSankeySonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsSankeySonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSankeySonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsSankeySonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsSankeySonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsSankeySonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsSankeySonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsSankeySonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsSankeySonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsSankeySonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsSankeySonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsSankeySonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsSankeySonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsSankeySonificationContexttracksMappingVolume)

        
class OptionPlotoptionsSankeySonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsSankeySonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsSankeySonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsSankeySonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsSankeySonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsSankeySonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeySonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsSankeySonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsSankeySonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsSankeySonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsSankeyPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankeyPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsSankeyPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsSankeyPointEvents)

        
class OptionPlotoptionsSankeyOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsSankeyOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsSankeyOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsSankeyOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsSankeyOnpointPosition)

        
class OptionPlotoptionsSankeyLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeyLevelsStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsSankeyLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsSankeyLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsSankeyLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsSankeyLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsSankeyLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsSankeyLevelsStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsSankeyLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsSankeyLevelsStatesSelect)

        
class OptionPlotoptionsSankeyLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsSankeyLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsSankeyLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsSankeyLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionPlotoptionsSankeyLevelsStates)

        
class OptionPlotoptionsSankeyLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsSankeyLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsSankeyLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsSankeyLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsSankeyLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeyLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsSankeyLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsSankeyLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeyEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsSankey(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsSankeyAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsSankeyAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def curveFactor(self):
        """Higher numbers makes the links in a sankey diagram or dependency wheelrender more curved.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.33)

    @curveFactor.setter
    def curveFactor(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsSankeyDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsSankeyDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsSankeyEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsSankeyEvents)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsSankeyLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsSankeyLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionPlotoptionsSankeyLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionPlotoptionsSankeyLevels)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def nodeAlignment(self):
        """Determines which side of the chart the nodes are to be aligned to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeAlignment.setter
    def nodeAlignment(self, value: Any): self._config(value, js_type=False)

    @property
    def nodePadding(self):
        """The padding between nodes in a sankey diagram or dependency wheel, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(10)

    @nodePadding.setter
    def nodePadding(self, num: float): self._config(num, js_type=False)

    @property
    def nodeWidth(self):
        """The pixel width of each node in a sankey diagram or dependency wheel, or the height in case the chart is inverted.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(20)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsSankeyOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsSankeyOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsSankeyPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsSankeyPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsSankeySonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsSankeySonification)

    @property
    def states(self) -> 'OptionPlotoptionsSankeyStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsSankeyStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsSankeyTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsSankeyTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsSankeyDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsSankeyDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsSankeyDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsSankeyDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsSankeyDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsSankeyDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsSankeyAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsSankeyAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsSankeyAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsSankeyAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsSankeyAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsSankeyAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsSankeyAccessibilityPoint)

        
class OptionPlotoptionsPyramid3dZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsPyramid3dTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsPyramid3dTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPyramid3dStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramid3dStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramid3dStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramid3dStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPyramid3dStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramid3dStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramid3dStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPyramid3dStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramid3dStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPyramid3dStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsPyramid3dStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsPyramid3dStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsPyramid3dStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsPyramid3dStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsPyramid3dStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPyramid3dStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsPyramid3dStatesSelect)

        
class OptionPlotoptionsPyramid3dSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPyramid3dSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPyramid3dSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramid3dSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPyramid3dSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPyramid3dSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPyramid3dSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPyramid3dSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPyramid3dSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramid3dSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramid3dSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPyramid3dSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramid3dSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPyramid3dSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramid3dSonificationTracksMappingVolume)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramid3dSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsPyramid3dSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramid3dSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramid3dSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramid3dSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramid3dSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsPyramid3dSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramid3dSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramid3dSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsPyramid3dSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsPyramid3dSonificationTracks)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsPyramid3dSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramid3dSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPyramid3dSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPyramid3dSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPyramid3dSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPyramid3dSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramid3dSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramid3dSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPyramid3dSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramid3dSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPyramid3dSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramid3dSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsPyramid3dSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramid3dSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramid3dSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramid3dSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramid3dSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsPyramid3dPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3dPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsPyramid3dPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsPyramid3dPointEvents)

        
class OptionPlotoptionsPyramid3dOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsPyramid3dOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsPyramid3dOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsPyramid3dOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsPyramid3dOnpointPosition)

        
class OptionPlotoptionsPyramid3dLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsPyramid3dLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsPyramid3dLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramid3dDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsPyramid3dDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsPyramid3dDragdropGuideboxDefault)

        
class OptionPlotoptionsPyramid3dDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsPyramid3dDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsPyramid3dDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsPyramid3dDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsPyramid3dDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramid3dEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid3d(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsPyramid3dAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsPyramid3dAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsPyramid3dDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsPyramid3dDatalabels)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsPyramid3dDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsPyramid3dDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(0)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsPyramid3dEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsPyramid3dEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def gradientForSides(self):
        """By deafult sides fill is set to a gradient through this option being set to <code>true</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @gradientForSides.setter
    def gradientForSides(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """The height of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsPyramid3dLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsPyramid3dLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsPyramid3dOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsPyramid3dOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsPyramid3dPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsPyramid3dPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed pyramid3d is funnel3d, but the latter supports neck related options: neckHeight and neckWidth.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pyramid3D/Pyramid3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsPyramid3dSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsPyramid3dSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPyramid3dStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsPyramid3dStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsPyramid3dTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsPyramid3dTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The max width of the series compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsPyramid3dZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsPyramid3dZones)

        
class OptionPlotoptionsPyramid3dDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramid3dDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsPyramid3dDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramid3dDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsPyramid3dDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsPyramid3dDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("allow")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsPyramid3dDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsPyramid3dDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pyramid3D/Pyramid3DSeriesDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramid3dAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramid3dAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramid3dAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsPyramid3dAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsPyramid3dAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsPyramid3dAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsPyramid3dAccessibilityPoint)

        
class OptionPlotoptionsPyramidTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsPyramidTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsPyramidTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPyramidStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramidStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramidStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramidStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPyramidStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramidStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramidStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPyramidStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramidStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPyramidStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsPyramidStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsPyramidStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsPyramidStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsPyramidStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsPyramidStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPyramidStatesSelect':
        """Options for a selected funnel item. """
        return self._config_sub_data("select", OptionPlotoptionsPyramidStatesSelect)

        
class OptionPlotoptionsPyramidSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPyramidSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPyramidSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsPyramidSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramidSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsPyramidSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPyramidSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPyramidSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPyramidSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPyramidSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPyramidSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramidSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramidSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPyramidSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramidSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPyramidSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramidSonificationTracksMappingVolume)

        
class OptionPlotoptionsPyramidSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramidSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramidSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsPyramidSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramidSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramidSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramidSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramidSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramidSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramidSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsPyramidSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsPyramidSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsPyramidSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramidSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramidSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsPyramidSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsPyramidSonificationTracks)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsPyramidSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramidSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramidSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsPyramidSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPyramidSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPyramidSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramidSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPyramidSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPyramidSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPyramidSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPyramidSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPyramidSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPyramidSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPyramidSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPyramidSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPyramidSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPyramidSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPyramidSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsPyramidSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPyramidSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPyramidSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPyramidSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPyramidSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPyramidSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPyramidSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsPyramidPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramidPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsPyramidPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsPyramidPointEvents)

        
class OptionPlotoptionsPyramidOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsPyramidOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsPyramidOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsPyramidOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsPyramidOnpointPosition)

        
class OptionPlotoptionsPyramidDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPyramid(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsPyramidAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsPyramidAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Initial animation is by default disabled for the funnel chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding all points or series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(["50%", "50%"])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsPyramidDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsPyramidDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsPyramidEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsPyramidEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """The height of the funnel or pyramid.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def neckHeight(self):
        """The height of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("25%")

    @neckHeight.setter
    def neckHeight(self, num: float): self._config(num, js_type=False)

    @property
    def neckWidth(self):
        """The width of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("30%")

    @neckWidth.setter
    def neckWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsPyramidOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsPyramidOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsPyramidPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsPyramidPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed funnel has the widest area down.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsPyramidSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsPyramidSonification)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPyramidStates':
        """Options for the series states. """
        return self._config_sub_data("states", OptionPlotoptionsPyramidStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsPyramidTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsPyramidTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The width of the funnel compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramidDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsPyramidDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsPyramidDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsPyramidDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsPyramidDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsPyramidDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsPyramidDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPyramidAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPyramidAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPyramidAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsPyramidAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsPyramidAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsPyramidAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsPyramidAccessibilityPoint)

        
class OptionPlotoptionsPolygonZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsPolygonTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsPolygonTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get("")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPolygonStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPolygonStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsPolygonStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsPolygonStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPolygonStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsPolygonStatesSelectMarker)

        
class OptionPlotoptionsPolygonStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPolygonStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPolygonStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPolygonStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPolygonStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsPolygonStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsPolygonStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsPolygonStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsPolygonStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsPolygonStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPolygonStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsPolygonStatesSelect)

        
class OptionPlotoptionsPolygonStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPolygonStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPolygonStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsPolygonStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsPolygonStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPolygonStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsPolygonStatesHoverMarker)

        
class OptionPlotoptionsPolygonSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPolygonSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPolygonSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsPolygonSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPolygonSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsPolygonSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPolygonSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPolygonSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPolygonSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPolygonSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPolygonSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPolygonSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPolygonSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPolygonSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPolygonSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPolygonSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPolygonSonificationTracksMappingVolume)

        
class OptionPlotoptionsPolygonSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPolygonSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPolygonSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsPolygonSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPolygonSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPolygonSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPolygonSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPolygonSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPolygonSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPolygonSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsPolygonSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsPolygonSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsPolygonSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPolygonSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPolygonSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsPolygonSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsPolygonSonificationTracks)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsPolygonSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPolygonSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPolygonSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPolygonSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsPolygonSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPolygonSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPolygonSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPolygonSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPolygonSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPolygonSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPolygonSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPolygonSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPolygonSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPolygonSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPolygonSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPolygonSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPolygonSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPolygonSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPolygonSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsPolygonSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPolygonSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPolygonSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPolygonSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPolygonSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPolygonSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPolygonSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsPolygonPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygonPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsPolygonPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsPolygonPointEvents)

        
class OptionPlotoptionsPolygonOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsPolygonOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsPolygonOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsPolygonOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsPolygonOnpointPosition)

        
class OptionPlotoptionsPolygonMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPolygonMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPolygonMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPolygonMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPolygonMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsPolygonMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsPolygonMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsPolygonMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPolygonMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsPolygonMarkerStatesSelect)

        
class OptionPlotoptionsPolygonMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPolygonMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsPolygonMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsPolygonLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsPolygonLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPolygonDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsPolygonDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsPolygonDragdropGuideboxDefault)

        
class OptionPlotoptionsPolygonDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsPolygonDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsPolygonDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsPolygonDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsPolygonDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPolygonEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPolygon(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsPolygonAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsPolygonAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsPolygonDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsPolygonDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsPolygonDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsPolygonDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsPolygonDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsPolygonDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsPolygonEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsPolygonEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsPolygonLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsPolygonLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPolygonMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsPolygonMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsPolygonOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsPolygonOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsPolygonPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsPolygonPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsPolygonSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsPolygonSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPolygonStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsPolygonStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsPolygonTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsPolygonTooltip)

    @property
    def trackByArea(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(True)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsPolygonZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsPolygonZones)

        
class OptionPlotoptionsPolygonDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPolygonDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsPolygonDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsPolygonDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsPolygonDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsPolygonDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsPolygonDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsPolygonDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPolygonAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPolygonAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPolygonAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsPolygonAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsPolygonAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsPolygonAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsPolygonAccessibilityPoint)

        
class OptionPlotoptionsPieTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsPieTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsPieTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPieStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPieStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsPieStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsPieStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPieStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsPieStatesSelectMarker)

        
class OptionPlotoptionsPieStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPieStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPieStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPieStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsPieStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsPieStatesHoverHalo)

        
class OptionPlotoptionsPieStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPieStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPieStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPieStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsPieStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsPieStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsPieStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsPieStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsPieStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPieStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsPieStatesSelect)

        
class OptionPlotoptionsPieSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPieSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPieSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPieSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPieSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsPieSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPieSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPieSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsPieSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPieSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPieSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPieSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPieSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPieSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPieSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPieSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPieSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPieSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPieSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPieSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPieSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPieSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPieSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPieSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPieSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPieSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPieSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPieSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPieSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPieSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPieSonificationTracksMappingVolume)

        
class OptionPlotoptionsPieSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPieSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPieSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsPieSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPieSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPieSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPieSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPieSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPieSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPieSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsPieSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsPieSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsPieSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsPieSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPieSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPieSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsPieSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsPieSonificationTracks)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsPieSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsPieSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPieSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPieSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPieSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPieSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPieSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsPieSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPieSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPieSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsPieSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPieSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsPieSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPieSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPieSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPieSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPieSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPieSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPieSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPieSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPieSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPieSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPieSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPieSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsPieSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPieSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPieSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPieSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPieSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPieSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPieSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPieSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPieSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPieSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPieSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsPiePointEvents(Options):

    def click(self, js_funcs: etypes.JS_FUNCS_TYPES, profile: etypes.PROFILE_TYPE = None, func_ref: bool = False):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        if not isinstance(js_funcs, list):
            js_funcs = [js_funcs]
        str_func = JsUtils.jsConvertFncs(js_funcs, toStr=True, profile=profile)
        if not str_func.startswith("function(event)") and not func_ref:
            str_func = "function(event){%s}" % str_func
        self._config(str_func, js_type=True)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPiePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsPiePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsPiePointEvents)

        
class OptionPlotoptionsPieOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsPieOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsPieOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsPieOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsPieOnpointPosition)

        
class OptionPlotoptionsPieDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPie(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsPieAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsPieAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the pie chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsPieDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsPieDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsPieEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsPieEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def innerSize(self):
        """The size of the inner diameter for the pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @innerSize.setter
    def innerSize(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsPieOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsPieOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsPiePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsPiePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsPieSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsPieSonification)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPieStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsPieStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsPieTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsPieTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPieDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPieDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsPieDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsPieDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsPieDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsPieDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsPieDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsPieDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPieAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPieAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPieAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsPieAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsPieAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsPieAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsPieAccessibilityPoint)

        
class OptionPlotoptionsPictorialZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsPictorialTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsPictorialTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPictorialStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPictorialStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPictorialStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPictorialStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPictorialStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPictorialStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPictorialStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPictorialStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPictorialStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPictorialStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsPictorialStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsPictorialStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsPictorialStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsPictorialStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsPictorialStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPictorialStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsPictorialStatesSelect)

        
class OptionPlotoptionsPictorialSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPictorialSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPictorialSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsPictorialSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPictorialSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsPictorialSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPictorialSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPictorialSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPictorialSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPictorialSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPictorialSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPictorialSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPictorialSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPictorialSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPictorialSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPictorialSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPictorialSonificationTracksMappingVolume)

        
class OptionPlotoptionsPictorialSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPictorialSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPictorialSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsPictorialSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPictorialSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPictorialSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPictorialSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPictorialSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPictorialSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPictorialSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsPictorialSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsPictorialSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsPictorialSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPictorialSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPictorialSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsPictorialSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsPictorialSonificationTracks)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsPictorialSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPictorialSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPictorialSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPictorialSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsPictorialSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPictorialSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPictorialSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPictorialSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPictorialSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPictorialSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPictorialSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPictorialSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPictorialSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPictorialSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPictorialSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPictorialSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPictorialSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPictorialSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPictorialSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsPictorialSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPictorialSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPictorialSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPictorialSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPictorialSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPictorialSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPictorialSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsPictorialPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorialPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsPictorialPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsPictorialPointEvents)

        
class OptionPlotoptionsPictorialLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsPictorialLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsPictorialLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPictorialDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsPictorialDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsPictorialDragdropGuideboxDefault)

        
class OptionPlotoptionsPictorialDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsPictorialDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsPictorialDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsPictorialDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsPictorialDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPictorialEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPictorial(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsPictorialAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsPictorialAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pictorial/PictorialSeries.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsPictorialDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsPictorialDatalabels)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsPictorialDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsPictorialDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsPictorialEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsPictorialEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsPictorialLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsPictorialLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsPictorialPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsPictorialPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsPictorialSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsPictorialSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPictorialStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsPictorialStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsPictorialTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsPictorialTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsPictorialZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsPictorialZones)

        
class OptionPlotoptionsPictorialDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPictorialDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsPictorialDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsPictorialDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsPictorialDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsPictorialDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsPictorialDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsPictorialDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPictorialAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPictorialAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPictorialAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsPictorialAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsPictorialAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsPictorialAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsPictorialAccessibilityPoint)

        
class OptionPlotoptionsParetoTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsParetoTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsParetoTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsParetoStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsParetoStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsParetoStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsParetoStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsParetoStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsParetoStatesSelectMarker)

        
class OptionPlotoptionsParetoStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsParetoStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsParetoStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsParetoStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsParetoStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsParetoStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsParetoStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsParetoStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsParetoStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsParetoStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsParetoStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsParetoStatesSelect)

        
class OptionPlotoptionsParetoStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsParetoStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsParetoStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsParetoStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsParetoStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsParetoStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsParetoStatesHoverMarker)

        
class OptionPlotoptionsParetoSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsParetoSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsParetoSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsParetoSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsParetoSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsParetoSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsParetoSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsParetoSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsParetoSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsParetoSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsParetoSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsParetoSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsParetoSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsParetoSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsParetoSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsParetoSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsParetoSonificationTracksMappingVolume)

        
class OptionPlotoptionsParetoSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsParetoSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsParetoSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsParetoSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsParetoSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsParetoSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsParetoSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsParetoSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsParetoSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsParetoSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsParetoSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsParetoSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsParetoSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsParetoSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsParetoSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsParetoSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsParetoSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsParetoSonificationTracks)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsParetoSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsParetoSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsParetoSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsParetoSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsParetoSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsParetoSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsParetoSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsParetoSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsParetoSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsParetoSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsParetoSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsParetoSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsParetoSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsParetoSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsParetoSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsParetoSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsParetoSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsParetoSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsParetoSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsParetoSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsParetoSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsParetoSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsParetoSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsParetoSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsParetoSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsParetoSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsParetoSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsParetoSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsParetoSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsParetoSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsParetoSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsParetoPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsParetoPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsParetoPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsParetoPointEvents)

        
class OptionPlotoptionsParetoOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsParetoOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsParetoOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsParetoOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsParetoOnpointPosition)

        
class OptionPlotoptionsParetoMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsParetoMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsParetoMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsParetoMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsParetoMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsParetoMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsParetoMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsParetoMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsParetoMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsParetoMarkerStatesSelect)

        
class OptionPlotoptionsParetoMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsParetoMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsParetoMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsParetoLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsParetoLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsParetoDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPareto(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsParetoAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsParetoAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsParetoDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsParetoDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsParetoDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsParetoDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsParetoEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsParetoEvents)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsParetoLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsParetoLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsParetoMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsParetoMarker)

    @property
    def onPoint(self) -> 'OptionPlotoptionsParetoOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsParetoOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsParetoPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsParetoPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsParetoSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsParetoSonification)

    @property
    def states(self) -> 'OptionPlotoptionsParetoStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsParetoStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsParetoTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsParetoTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsParetoDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsParetoDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsParetoDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsParetoDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsParetoDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsParetoDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsParetoDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsParetoDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsParetoAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsParetoAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsParetoAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsParetoAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsParetoAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsParetoAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsParetoAccessibilityPoint)

        
class OptionPlotoptionsPackedbubbleZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsPackedbubbleTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsPackedbubbleTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("Value: {point.value}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPackedbubbleStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPackedbubbleStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsPackedbubbleStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsPackedbubbleStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPackedbubbleStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsPackedbubbleStatesSelectMarker)

        
class OptionPlotoptionsPackedbubbleStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(5)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPackedbubbleStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPackedbubbleStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPackedbubbleStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsPackedbubbleStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsPackedbubbleStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsPackedbubbleStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsPackedbubbleStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsPackedbubbleStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPackedbubbleStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsPackedbubbleStatesSelect)

        
class OptionPlotoptionsPackedbubbleStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPackedbubbleStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsPackedbubbleStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsPackedbubbleStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsPackedbubbleStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPackedbubbleStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsPackedbubbleStatesHoverMarker)

        
class OptionPlotoptionsPackedbubbleSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPackedbubbleSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPackedbubbleSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPackedbubbleSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPackedbubbleSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPackedbubbleSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPackedbubbleSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPackedbubbleSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPackedbubbleSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPackedbubbleSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPackedbubbleSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPackedbubbleSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPackedbubbleSonificationTracksMappingVolume)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPackedbubbleSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsPackedbubbleSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPackedbubbleSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPackedbubbleSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPackedbubbleSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsPackedbubbleSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPackedbubbleSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPackedbubbleSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsPackedbubbleSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsPackedbubbleSonificationTracks)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPackedbubbleSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsPackedbubbleSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsPackedbubbleSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsPackedbubbleSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsPackedbubbleSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsPackedbubblePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubblePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsPackedbubblePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsPackedbubblePointEvents)

        
class OptionPlotoptionsPackedbubbleParentnode(Options):

    @property
    def allowPointSelect(self):
        """Allow this series&#39; parent nodes to be selected by clicking on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPackedbubbleOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsPackedbubbleOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsPackedbubbleOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsPackedbubbleOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsPackedbubbleOnpointPosition)

        
class OptionPlotoptionsPackedbubbleMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPackedbubbleMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsPackedbubbleMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsPackedbubbleMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsPackedbubbleMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsPackedbubbleMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsPackedbubbleMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsPackedbubbleMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsPackedbubbleMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsPackedbubbleMarkerStatesSelect)

        
class OptionPlotoptionsPackedbubbleMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """The fill opacity of the bubble markers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0.5)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPackedbubbleMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsPackedbubbleMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleLayoutalgorithmParentnodeoptionsMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, value: Any): self._config(value, js_type=False)

    @property
    def fillOpacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, value: Any): self._config(value, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleLayoutalgorithmParentnodeoptions(Options):

    @property
    def friction(self):
        """Friction applied on forces to prevent nodes rushing to fast to the desired positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(-0.981)

    @friction.setter
    def friction(self, num: float): self._config(num, js_type=False)

    @property
    def gravitationalConstant(self):
        """Gravitational const used in the barycenter force of the algorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(0.03)

    @gravitationalConstant.setter
    def gravitationalConstant(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositionRadius(self):
        """When <code>initialPositions</code> are set to &#39;circle&#39;, <code>initialPositionRadius</code> is a distance from the center of circle, in which nodes are created.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(100)

    @initialPositionRadius.setter
    def initialPositionRadius(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositions(self):
        """Initial layout algorithm for positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(circle)

    @initialPositions.setter
    def initialPositions(self, value: Any): self._config(value, js_type=False)

    @property
    def integration(self):
        """Integration type.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(euler)

    @integration.setter
    def integration(self, value: Any): self._config(value, js_type=False)

    @property
    def linkLength(self):
        """Ideal length (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkLength.setter
    def linkLength(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPackedbubbleLayoutalgorithmParentnodeoptionsMarker':
        """Styling options for parentNodes markers. """
        return self._config_sub_data("marker", OptionPlotoptionsPackedbubbleLayoutalgorithmParentnodeoptionsMarker)

    @property
    def maxIterations(self):
        """Max number of iterations before algorithm will stop.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(400)

    @maxIterations.setter
    def maxIterations(self, num: float): self._config(num, js_type=False)

    @property
    def maxSpeed(self):
        """Verlet integration only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(50)

    @maxSpeed.setter
    def maxSpeed(self, num: float): self._config(num, js_type=False)

    @property
    def seriesInteraction(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @seriesInteraction.setter
    def seriesInteraction(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used when positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(reingold-fruchterman)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleLayoutalgorithm(Options):

    @property
    def bubblePadding(self):
        """The distance between two bubbles, when the algorithm starts to treat two bubbles as overlapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(5)

    @bubblePadding.setter
    def bubblePadding(self, num: float): self._config(num, js_type=False)

    @property
    def dragBetweenSeries(self):
        """In case of split series, this option allows user to drag and drop points between series, for changing point related series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @dragBetweenSeries.setter
    def dragBetweenSeries(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enableSimulation(self):
        """Experimental.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @enableSimulation.setter
    def enableSimulation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def friction(self):
        """Friction applied on forces to prevent nodes rushing to fast to the desired positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(-0.981)

    @friction.setter
    def friction(self, num: float): self._config(num, js_type=False)

    @property
    def gravitationalConstant(self):
        """Gravitational const used in the barycenter force of the algorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(0.01)

    @gravitationalConstant.setter
    def gravitationalConstant(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositionRadius(self):
        """When <code>initialPositions</code> are set to &#39;circle&#39;, <code>initialPositionRadius</code> is a distance from the center of circle, in which nodes are created.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(20)

    @initialPositionRadius.setter
    def initialPositionRadius(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositions(self):
        """Initial layout algorithm for positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(circle)

    @initialPositions.setter
    def initialPositions(self, value: Any): self._config(value, js_type=False)

    @property
    def integration(self):
        """Integration type.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(euler)

    @integration.setter
    def integration(self, value: Any): self._config(value, js_type=False)

    @property
    def linkLength(self):
        """Ideal length (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkLength.setter
    def linkLength(self, num: float): self._config(num, js_type=False)

    @property
    def maxIterations(self):
        """Max number of iterations before algorithm will stop.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(1000)

    @maxIterations.setter
    def maxIterations(self, num: float): self._config(num, js_type=False)

    @property
    def maxSpeed(self):
        """Max speed that node can get in one iteration.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(5)

    @maxSpeed.setter
    def maxSpeed(self, num: float): self._config(num, js_type=False)

    @property
    def parentNodeLimit(self):
        """Whether bubbles should interact with their parentNode to keep them inside.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @parentNodeLimit.setter
    def parentNodeLimit(self, flag: bool): self._config(flag, js_type=False)

    @property
    def parentNodeOptions(self) -> 'OptionPlotoptionsPackedbubbleLayoutalgorithmParentnodeoptions':
        """Layout algorithm options for parent nodes. """
        return self._config_sub_data("parentNodeOptions", OptionPlotoptionsPackedbubbleLayoutalgorithmParentnodeoptions)

    @property
    def seriesInteraction(self):
        """Whether series should interact with each other or not.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @seriesInteraction.setter
    def seriesInteraction(self, flag: bool): self._config(flag, js_type=False)

    @property
    def splitSeries(self):
        """Whether to split series into individual groups or to mix all series together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @splitSeries.setter
    def splitSeries(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used when positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(reingold-fruchterman)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubbleLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsPackedbubbleLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsPackedbubbleLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPackedbubbleDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsPackedbubble(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsPackedbubbleAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsPackedbubbleAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """If there are more points in the series than the <code>animationLimit</code>, the animation won&#39;t run.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("z")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsPackedbubbleDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsPackedbubbleDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def displayNegative(self):
        """Whether to display negative sized bubbles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @displayNegative.setter
    def displayNegative(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggable(self):
        """Flag to determine if nodes are draggable or not.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @draggable.setter
    def draggable(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsPackedbubbleEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsPackedbubbleEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsPackedbubbleLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsPackedbubbleLabel)

    @property
    def layoutAlgorithm(self) -> 'OptionPlotoptionsPackedbubbleLayoutalgorithm':
        """Options for layout algorithm when simulation is enabled. """
        return self._config_sub_data("layoutAlgorithm", OptionPlotoptionsPackedbubbleLayoutalgorithm)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsPackedbubbleMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsPackedbubbleMarker)

    @property
    def maxSize(self):
        """Maximum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("50%")

    @maxSize.setter
    def maxSize(self, num: float): self._config(num, js_type=False)

    @property
    def minSize(self):
        """Minimum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("10%")

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """When a point&#39;s Z value is below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsPackedbubbleOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsPackedbubbleOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def parentNode(self) -> 'OptionPlotoptionsPackedbubbleParentnode':
        """Series options for parent nodes. """
        return self._config_sub_data("parentNode", OptionPlotoptionsPackedbubbleParentnode)

    @property
    def point(self) -> 'OptionPlotoptionsPackedbubblePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsPackedbubblePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sizeBy(self):
        """Whether the bubble&#39;s value should be represented by the area or the width of the bubble.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("area")

    @sizeBy.setter
    def sizeBy(self, text: str): self._config(text, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(False)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsPackedbubbleSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsPackedbubbleSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsPackedbubbleStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsPackedbubbleStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsPackedbubbleTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsPackedbubbleTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def useSimulation(self):
        """An option is giving a possibility to choose between using simulation for calculating bubble positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @useSimulation.setter
    def useSimulation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsPackedbubbleZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsPackedbubbleZones)

    @property
    def zThreshold(self):
        """When <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @zThreshold.setter
    def zThreshold(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPackedbubbleDatalabelsStyle(Options):

    @property
    def transition(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("opacity 2000ms")

    @transition.setter
    def transition(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleDatalabelsParentnodetextpath(Options):

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPackedbubbleDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsPackedbubbleDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsPackedbubbleDatalabelsAnimation)

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsPackedbubbleDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsPackedbubbleDatalabelsFilter)

    @property
    def format(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label for a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(0)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def parentNodeFormat(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @parentNodeFormat.setter
    def parentNodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def parentNodeFormatter(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @parentNodeFormatter.setter
    def parentNodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def parentNodeTextPath(self) -> 'OptionPlotoptionsPackedbubbleDatalabelsParentnodetextpath':
        """. """
        return self._config_sub_data("parentNodeTextPath", OptionPlotoptionsPackedbubbleDatalabelsParentnodetextpath)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsPackedbubbleDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionPlotoptionsPackedbubbleDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionPlotoptionsPackedbubbleDatalabelsTextpath':
        """Options for a <em>node</em> label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsPackedbubbleDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsPackedbubbleAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsPackedbubbleAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsPackedbubbleAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsPackedbubbleAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsPackedbubbleAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsPackedbubbleAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsPackedbubbleAccessibilityPoint)

        
class OptionPlotoptionsOrganizationTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsOrganizationTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsOrganizationTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("{point.name}<br>{point.title}<br>{point.description}")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsOrganizationStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsOrganizationStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsOrganizationStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsOrganizationStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsOrganizationStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsOrganizationStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsOrganizationStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsOrganizationStatesSelect)

        
class OptionPlotoptionsOrganizationSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsOrganizationSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsOrganizationSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsOrganizationSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsOrganizationSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsOrganizationSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsOrganizationSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsOrganizationSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsOrganizationSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsOrganizationSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsOrganizationSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsOrganizationSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsOrganizationSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsOrganizationSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsOrganizationSonificationTracksMappingVolume)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsOrganizationSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsOrganizationSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsOrganizationSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsOrganizationSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsOrganizationSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsOrganizationSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsOrganizationSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsOrganizationSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsOrganizationSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsOrganizationSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsOrganizationSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsOrganizationSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsOrganizationSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsOrganizationSonificationTracks)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsOrganizationSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsOrganizationSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsOrganizationSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsOrganizationSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsOrganizationSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsOrganizationSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsOrganizationSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsOrganizationSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsOrganizationSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsOrganizationSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsOrganizationSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsOrganizationSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsOrganizationSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsOrganizationSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsOrganizationSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsOrganizationSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsOrganizationSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsOrganizationSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsOrganizationSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsOrganizationSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsOrganizationSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsOrganizationPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsOrganizationPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsOrganizationPointEvents)

        
class OptionPlotoptionsOrganizationOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsOrganizationOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsOrganizationOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsOrganizationOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsOrganizationOnpointPosition)

        
class OptionPlotoptionsOrganizationLink(Options):

    @property
    def color(self):
        """The color of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the links connecting nodes, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """Radius for the rounded corners of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(10)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the link shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get('default')

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsOrganizationLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsOrganizationLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsOrganizationLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsOrganizationLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsOrganizationLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsOrganizationLevelsStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsOrganizationLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsOrganizationLevelsStatesSelect)

        
class OptionPlotoptionsOrganizationLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsOrganizationLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsOrganizationLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsOrganizationLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionPlotoptionsOrganizationLevelsStates)

        
class OptionPlotoptionsOrganizationLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsOrganizationLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsOrganizationLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsOrganizationLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsOrganizationLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsOrganizationLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsOrganizationLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsOrganization(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsOrganizationAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsOrganizationAccessibility)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The border color of the node cards.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("#666666")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius of the node cards.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsOrganizationDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsOrganizationDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsOrganizationEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsOrganizationEvents)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def hangingIndent(self):
        """The indentation in pixels of hanging nodes, nodes which parent has <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(20)

    @hangingIndent.setter
    def hangingIndent(self, num: float): self._config(num, js_type=False)

    @property
    def hangingIndentTranslation(self):
        """Defines the indentation of a <code>hanging</code> layout parent&#39;s children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(inherit)

    @hangingIndentTranslation.setter
    def hangingIndentTranslation(self, value: Any): self._config(value, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsOrganizationLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsOrganizationLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionPlotoptionsOrganizationLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionPlotoptionsOrganizationLevels)

    @property
    def link(self) -> 'OptionPlotoptionsOrganizationLink':
        """Link Styling options. """
        return self._config_sub_data("link", OptionPlotoptionsOrganizationLink)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minNodeLength(self):
        """In a horizontal chart, the minimum width of the <strong>hanging</strong> nodes only, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(10)

    @minNodeLength.setter
    def minNodeLength(self, num: float): self._config(num, js_type=False)

    @property
    def nodeAlignment(self):
        """Determines which side of the chart the nodes are to be aligned to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeAlignment.setter
    def nodeAlignment(self, value: Any): self._config(value, js_type=False)

    @property
    def nodePadding(self):
        """The padding between nodes in a sankey diagram or dependency wheel, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(10)

    @nodePadding.setter
    def nodePadding(self, num: float): self._config(num, js_type=False)

    @property
    def nodeWidth(self):
        """In a horizontal chart, the width of the nodes in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(50)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsOrganizationOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsOrganizationOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsOrganizationPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsOrganizationPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsOrganizationSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsOrganizationSonification)

    @property
    def states(self) -> 'OptionPlotoptionsOrganizationStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsOrganizationStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsOrganizationTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsOrganizationTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationDatalabelsStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("0.9em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("normal")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationDatalabelsLinktextpathAttributes(Options):

    @property
    def startOffset(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("95%")

    @startOffset.setter
    def startOffset(self, num: float): self._config(num, js_type=False)

    @property
    def textAnchor(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("end")

    @textAnchor.setter
    def textAnchor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationDatalabelsLinktextpath(Options):

    @property
    def attributes(self) -> 'OptionPlotoptionsOrganizationDatalabelsLinktextpathAttributes':
        """. """
        return self._config_sub_data("attributes", OptionPlotoptionsOrganizationDatalabelsLinktextpathAttributes)

        
class OptionPlotoptionsOrganizationDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsOrganizationDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsOrganizationDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsOrganizationDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsOrganizationDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionPlotoptionsOrganizationDatalabelsLinktextpath':
        """. """
        return self._config_sub_data("linkTextPath", OptionPlotoptionsOrganizationDatalabelsLinktextpath)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the organization chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsOrganizationDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionPlotoptionsOrganizationDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionPlotoptionsOrganizationDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsOrganizationDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(True)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsOrganizationAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsOrganizationAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsOrganizationAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsOrganizationAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsOrganizationAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsOrganizationAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsOrganizationAccessibilityPoint)

        
class OptionPlotoptionsNetworkgraphZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsNetworkgraphTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsNetworkgraphTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsNetworkgraphStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsNetworkgraphStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsNetworkgraphStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsNetworkgraphStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsNetworkgraphStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsNetworkgraphStatesSelectMarker)

        
class OptionPlotoptionsNetworkgraphStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(50)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsNetworkgraphStatesInactiveAnimation':
        """Animation when not hovering over the node. """
        return self._config_sub_data("animation", OptionPlotoptionsNetworkgraphStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity of inactive links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.3)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsNetworkgraphStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsNetworkgraphStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsNetworkgraphStatesInactive':
        """The opposite state of a hover for a single point link. """
        return self._config_sub_data("inactive", OptionPlotoptionsNetworkgraphStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsNetworkgraphStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsNetworkgraphStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsNetworkgraphStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsNetworkgraphStatesSelect)

        
class OptionPlotoptionsNetworkgraphStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsNetworkgraphStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsNetworkgraphStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsNetworkgraphStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsNetworkgraphStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsNetworkgraphStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsNetworkgraphStatesHoverMarker)

        
class OptionPlotoptionsNetworkgraphSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsNetworkgraphSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsNetworkgraphSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsNetworkgraphSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsNetworkgraphSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsNetworkgraphSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsNetworkgraphSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsNetworkgraphSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsNetworkgraphSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsNetworkgraphSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsNetworkgraphSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsNetworkgraphSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsNetworkgraphSonificationTracksMappingVolume)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsNetworkgraphSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsNetworkgraphSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsNetworkgraphSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsNetworkgraphSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsNetworkgraphSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsNetworkgraphSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsNetworkgraphSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsNetworkgraphSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsNetworkgraphSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsNetworkgraphSonificationTracks)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsNetworkgraphSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsNetworkgraphSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsNetworkgraphSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsNetworkgraphSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsNetworkgraphSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsNetworkgraphPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsNetworkgraphPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsNetworkgraphPointEvents)

        
class OptionPlotoptionsNetworkgraphOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsNetworkgraphOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsNetworkgraphOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsNetworkgraphOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsNetworkgraphOnpointPosition)

        
class OptionPlotoptionsNetworkgraphMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsNetworkgraphMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphMarkerStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(50)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsNetworkgraphMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsNetworkgraphMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphMarkerStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsNetworkgraphMarkerStatesInactiveAnimation':
        """Animation when not hovering over the node. """
        return self._config_sub_data("animation", OptionPlotoptionsNetworkgraphMarkerStatesInactiveAnimation)

    @property
    def opacity(self):
        """Opacity of inactive markers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.3)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsNetworkgraphMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsNetworkgraphMarkerStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsNetworkgraphMarkerStatesInactive':
        """The opposite state of a hover for a single point node. """
        return self._config_sub_data("inactive", OptionPlotoptionsNetworkgraphMarkerStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsNetworkgraphMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsNetworkgraphMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsNetworkgraphMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsNetworkgraphMarkerStatesSelect)

        
class OptionPlotoptionsNetworkgraphMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsNetworkgraphMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsNetworkgraphMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphLink(Options):

    @property
    def color(self):
        """Color of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("rgba(100, 100, 100, 0.5)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def opacity(self):
        """Opacity of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Width (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphLayoutalgorithm(Options):

    @property
    def approximation(self):
        """Approximation used to calculate repulsive forces affecting nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(none)

    @approximation.setter
    def approximation(self, value: Any): self._config(value, js_type=False)

    @property
    def attractiveForce(self):
        """Attraction force applied on a node which is conected to another node by a link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("function (d, k) { return k * k / d; }")

    @attractiveForce.setter
    def attractiveForce(self, text: str): self._config(text, js_type=True)

    @property
    def enableSimulation(self):
        """Experimental.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @enableSimulation.setter
    def enableSimulation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def friction(self):
        """Friction applied on forces to prevent nodes rushing to fast to the desired positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(-0.981)

    @friction.setter
    def friction(self, num: float): self._config(num, js_type=False)

    @property
    def gravitationalConstant(self):
        """Gravitational const used in the barycenter force of the algorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.0625)

    @gravitationalConstant.setter
    def gravitationalConstant(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositionRadius(self):
        """When <code>initialPositions</code> are set to &#39;circle&#39;, <code>initialPositionRadius</code> is a distance from the center of circle, in which nodes are created.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @initialPositionRadius.setter
    def initialPositionRadius(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositions(self):
        """Initial layout algorithm for positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(circle)

    @initialPositions.setter
    def initialPositions(self, value: Any): self._config(value, js_type=False)

    @property
    def integration(self):
        """Integration type.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(euler)

    @integration.setter
    def integration(self, value: Any): self._config(value, js_type=False)

    @property
    def linkLength(self):
        """Ideal length (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkLength.setter
    def linkLength(self, num: float): self._config(num, js_type=False)

    @property
    def maxIterations(self):
        """Max number of iterations before algorithm will stop.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1000)

    @maxIterations.setter
    def maxIterations(self, num: float): self._config(num, js_type=False)

    @property
    def maxSpeed(self):
        """Verlet integration only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(10)

    @maxSpeed.setter
    def maxSpeed(self, num: float): self._config(num, js_type=False)

    @property
    def repulsiveForce(self):
        """Repulsive force applied on a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("function (d, k) { return k * k / d; }")

    @repulsiveForce.setter
    def repulsiveForce(self, text: str): self._config(text, js_type=True)

    @property
    def theta(self):
        """Barnes-Hut approximation only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.5)

    @theta.setter
    def theta(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used when positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(reingold-fruchterman)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraphDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1000)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsNetworkgraph(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsNetworkgraphAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsNetworkgraphAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsNetworkgraphDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsNetworkgraphDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def draggable(self):
        """Flag to determine if nodes are draggable or not.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @draggable.setter
    def draggable(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsNetworkgraphEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsNetworkgraphEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def layoutAlgorithm(self) -> 'OptionPlotoptionsNetworkgraphLayoutalgorithm':
        """. """
        return self._config_sub_data("layoutAlgorithm", OptionPlotoptionsNetworkgraphLayoutalgorithm)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def link(self) -> 'OptionPlotoptionsNetworkgraphLink':
        """Link style options. """
        return self._config_sub_data("link", OptionPlotoptionsNetworkgraphLink)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsNetworkgraphMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsNetworkgraphMarker)

    @property
    def onPoint(self) -> 'OptionPlotoptionsNetworkgraphOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsNetworkgraphOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsNetworkgraphPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsNetworkgraphPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsNetworkgraphSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsNetworkgraphSonification)

    @property
    def states(self) -> 'OptionPlotoptionsNetworkgraphStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsNetworkgraphStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsNetworkgraphTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsNetworkgraphTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsNetworkgraphZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsNetworkgraphZones)

        
class OptionPlotoptionsNetworkgraphDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsNetworkgraphDatalabelsStyle(Options):

    @property
    def transition(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("opacity 2000ms")

    @transition.setter
    def transition(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphDatalabelsLinktextpath(Options):

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsNetworkgraphDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsNetworkgraphDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsNetworkgraphDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsNetworkgraphDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsNetworkgraphDatalabelsFilter)

    @property
    def format(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label for a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkFormat.setter
    def linkFormat(self, text: str): self._config(text, js_type=False)

    @property
    def linkFormatter(self):
        """Callback to format data labels for <em>links</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkFormatter.setter
    def linkFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionPlotoptionsNetworkgraphDatalabelsLinktextpath':
        """Options for a <em>link</em> label text which should follow link connection. """
        return self._config_sub_data("linkTextPath", OptionPlotoptionsNetworkgraphDatalabelsLinktextpath)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsNetworkgraphDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionPlotoptionsNetworkgraphDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionPlotoptionsNetworkgraphDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsNetworkgraphDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsNetworkgraphAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsNetworkgraphAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsNetworkgraphAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsNetworkgraphAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsNetworkgraphAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsNetworkgraphAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsNetworkgraphAccessibilityPoint)

        
class OptionPlotoptionsLollipopZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsLollipopTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsLollipopTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLollipopStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsLollipopStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsLollipopStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsLollipopStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsLollipopStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsLollipopStatesSelectMarker)

        
class OptionPlotoptionsLollipopStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLollipopStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLollipopStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsLollipopStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsLollipopStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsLollipopStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsLollipopStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsLollipopStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsLollipopStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsLollipopStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsLollipopStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsLollipopStatesSelect)

        
class OptionPlotoptionsLollipopStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLollipopStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsLollipopStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsLollipopStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsLollipopStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsLollipopStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsLollipopStatesHoverMarker)

        
class OptionPlotoptionsLollipopSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsLollipopSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsLollipopSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsLollipopSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLollipopSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsLollipopSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsLollipopSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsLollipopSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsLollipopSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsLollipopSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsLollipopSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsLollipopSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLollipopSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsLollipopSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLollipopSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsLollipopSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsLollipopSonificationTracksMappingVolume)

        
class OptionPlotoptionsLollipopSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLollipopSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLollipopSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsLollipopSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLollipopSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLollipopSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLollipopSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLollipopSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLollipopSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLollipopSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsLollipopSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsLollipopSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsLollipopSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLollipopSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLollipopSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsLollipopSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsLollipopSonificationTracks)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsLollipopSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLollipopSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLollipopSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLollipopSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsLollipopSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsLollipopSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsLollipopSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLollipopSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsLollipopSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsLollipopSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsLollipopSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsLollipopSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsLollipopSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsLollipopSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLollipopSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsLollipopSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLollipopSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsLollipopSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsLollipopSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsLollipopSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLollipopSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLollipopSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLollipopSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLollipopSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLollipopSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLollipopSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsLollipopPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipopPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsLollipopPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsLollipopPointEvents)

        
class OptionPlotoptionsLollipopOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsLollipopOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsLollipopOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsLollipopOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsLollipopOnpointPosition)

        
class OptionPlotoptionsLollipopMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLollipopMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLollipopMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsLollipopMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsLollipopMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsLollipopMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsLollipopMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsLollipopMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsLollipopMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsLollipopMarkerStatesSelect)

        
class OptionPlotoptionsLollipopMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsLollipopMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsLollipopMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLollipopLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLollipopLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsLollipopLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsLollipopLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsLollipopLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsLollipopLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsLollipopLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsLollipopLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsLollipopLowmarkerStatesSelect)

        
class OptionPlotoptionsLollipopLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsLollipopLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsLollipopLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsLollipopLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsLollipopLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLollipopDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsLollipopDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsLollipopDragdropGuideboxDefault)

        
class OptionPlotoptionsLollipopDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsLollipopDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsLollipopDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsLollipopDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsLollipopDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLollipopEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLollipop(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsLollipopAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsLollipopAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorColor(self):
        """Color of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsLollipopDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsLollipopDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsLollipopDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsLollipopDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsLollipopDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsLollipopDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsLollipopEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsLollipopEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked lollipop points or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Lollipop/LollipopSeries.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsLollipopLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsLollipopLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionPlotoptionsLollipopLowmarker':
        """Options for the lower markers of the dumbbell-like series. """
        return self._config_sub_data("lowMarker", OptionPlotoptionsLollipopLowmarker)

    @property
    def marker(self) -> 'OptionPlotoptionsLollipopMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsLollipopMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsLollipopOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsLollipopOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsLollipopPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsLollipopPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsLollipopSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsLollipopSonification)

    @property
    def states(self) -> 'OptionPlotoptionsLollipopStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsLollipopStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsLollipopTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsLollipopTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsLollipopZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsLollipopZones)

        
class OptionPlotoptionsLollipopDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLollipopDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Lollipop/LollipopSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsLollipopDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsLollipopDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsLollipopDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsLollipopDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsLollipopDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsLollipopDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Lollipop/LollipopSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLollipopAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLollipopAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLollipopAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsLollipopAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsLollipopAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsLollipopAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsLollipopAccessibilityPoint)

        
class OptionPlotoptionsLineZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsLineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsLineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsLineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsLineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsLineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsLineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsLineStatesSelectMarker)

        
class OptionPlotoptionsLineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsLineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsLineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsLineStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsLineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsLineStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsLineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsLineStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsLineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsLineStatesSelect)

        
class OptionPlotoptionsLineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsLineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsLineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsLineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsLineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsLineStatesHoverMarker)

        
class OptionPlotoptionsLineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsLineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsLineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsLineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsLineSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsLineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLineSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsLineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsLineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsLineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsLineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsLineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsLineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsLineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsLineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsLineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsLineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsLineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsLineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsLineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsLineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsLineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsLineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsLineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsLineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsLineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsLineSonificationTracksMappingVolume)

        
class OptionPlotoptionsLineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLineSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsLineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsLineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsLineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsLineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsLineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsLineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsLineSonificationTracks)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsLineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsLineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsLineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsLineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsLineSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsLineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLineSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsLineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsLineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsLineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsLineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsLineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsLineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsLineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsLineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsLineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsLineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsLineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsLineSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsLineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsLineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsLineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsLineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsLineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsLineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsLineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsLineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsLineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsLineSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsLinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLinePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsLinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsLinePointEvents)

        
class OptionPlotoptionsLineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsLineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsLineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsLineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsLineOnpointPosition)

        
class OptionPlotoptionsLineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsLineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsLineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsLineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsLineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsLineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsLineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsLineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsLineMarkerStatesSelect)

        
class OptionPlotoptionsLineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsLineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsLineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsLineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsLineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsLineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsLineDragdropGuideboxDefault)

        
class OptionPlotoptionsLineDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsLineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsLineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsLineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsLineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLine(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsLineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsLineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsLineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsLineDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsLineDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsLineDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsLineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsLineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsLineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsLineEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsLineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsLineLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsLineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsLineMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsLineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsLineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsLinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsLinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsLineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsLineSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsLineStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsLineStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsLineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsLineTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsLineZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsLineZones)

        
class OptionPlotoptionsLineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsLineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsLineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsLineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsLineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsLineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsLineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsLineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsLineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsLineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsLineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsLineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsLineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsLineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsLineAccessibilityPoint)

        
class OptionPlotoptionsArearangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsArearangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsArearangeDragdropGuideboxDefault)

        
class OptionPlotoptionsArearangeDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsArearangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsArearangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsArearangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsArearangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreaDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsAreaDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsAreaDragdropGuideboxDefault)

        
class OptionPlotoptionsAreaDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsAreaDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsAreaDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsAreaDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsAreaDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreaEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsAreasplinerangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsAreasplinerangeDragdropGuideboxDefault)

        
class OptionPlotoptionsAreasplinerangeDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsAreasplinerangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsAreasplinerangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsAreasplinerangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsAreasplinerangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsAreasplineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsAreasplineDragdropGuideboxDefault)

        
class OptionPlotoptionsAreasplineDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsAreasplineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsAreasplineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsAreasplineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsAreasplineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsBarDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsBarDragdropGuideboxDefault)

        
class OptionPlotoptionsBarDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsBarDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsBarDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsBarDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsBarDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBarEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsBubbleDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsBubbleDragdropGuideboxDefault)

        
class OptionPlotoptionsBubbleDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsBubbleDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsBubbleDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsBubbleDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsBubbleDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBubbleEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBoxplotDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBoxplotDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBoxplotDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsBoxplotDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsBoxplotDragdropGuideboxDefault)

        
class OptionPlotoptionsBoxplotDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ1(self):
        """Allow Q1 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ1.setter
    def draggableQ1(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ3(self):
        """Allow Q3 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ3.setter
    def draggableQ3(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsBoxplotDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsBoxplotDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsBoxplotDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsBoxplotDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBoxplotEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleJitter(Options):

    @property
    def x(self):
        """The maximal X offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The maximal Y offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsColumnDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsColumnDragdropGuideboxDefault)

        
class OptionPlotoptionsColumnDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsColumnDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsColumnDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsColumnDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsColumnDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBulletDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsBulletDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsBulletDragdropGuideboxDefault)

        
class OptionPlotoptionsBulletDragdrop(Options):

    @property
    def draggableTarget(self):
        """Allow target value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableTarget.setter
    def draggableTarget(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsBulletDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsBulletDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsBulletDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsBulletDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBulletEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeBorderradius(Options):

    @property
    def where(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ColumnRange/ColumnRangeSeries.ts
        """
        return self._config_get("all")

    @where.setter
    def where(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsColumnrangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsColumnrangeDragdropGuideboxDefault)

        
class OptionPlotoptionsColumnrangeDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsColumnrangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsColumnrangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsColumnrangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsColumnrangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsColumnpyramidDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsColumnpyramidDragdropGuideboxDefault)

        
class OptionPlotoptionsColumnpyramidDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsColumnpyramidDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsColumnpyramidDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsColumnpyramidDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsColumnpyramidDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsErrorbarDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsErrorbarDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsErrorbarDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsErrorbarDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsErrorbarDragdropGuideboxDefault)

        
class OptionPlotoptionsErrorbarDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ1(self):
        """Allow Q1 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ1.setter
    def draggableQ1(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ3(self):
        """Allow Q3 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ3.setter
    def draggableQ3(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsErrorbarDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsErrorbarDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsErrorbarDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsErrorbarDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbellDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsDumbbellDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsDumbbellDragdropGuideboxDefault)

        
class OptionPlotoptionsDumbbellDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsDumbbellDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsDumbbellDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsDumbbellDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsDumbbellDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbellEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionPlotoptionsFunnel3dDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionPlotoptionsFunnel3dDragdropGuideboxDefault)

        
class OptionPlotoptionsFunnel3dDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionPlotoptionsFunnel3dDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionPlotoptionsFunnel3dDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionPlotoptionsFunnel3dDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionPlotoptionsFunnel3dDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnelDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsGaugeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeDial(Options):

    @property
    def backgroundColor(self):
        """The background or fill color of the gauge&#39;s dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#000000")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def baseLength(self):
        """The length of the dial&#39;s base part, relative to the total radius or length of the dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("70%")

    @baseLength.setter
    def baseLength(self, text: str): self._config(text, js_type=False)

    @property
    def baseWidth(self):
        """The pixel width of the base of the gauge dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(3)

    @baseWidth.setter
    def baseWidth(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The border color or stroke of the gauge&#39;s dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the gauge dial border in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def path(self):
        """An array with an SVG path for the custom dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(None)

    @path.setter
    def path(self, value: Any): self._config(value, js_type=False)

    @property
    def radius(self):
        """The radius or length of the dial, in percentages relative to the radius of the gauge itself.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("80%")

    @radius.setter
    def radius(self, text: str): self._config(text, js_type=False)

    @property
    def rearLength(self):
        """The length of the dial&#39;s rear end, the part that extends out on the other side of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("10%")

    @rearLength.setter
    def rearLength(self, text: str): self._config(text, js_type=False)

    @property
    def topWidth(self):
        """The width of the top of the dial, closest to the perimeter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(1)

    @topWidth.setter
    def topWidth(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsGaugeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptions(Options):

    @property
    def arcdiagram(self) -> 'OptionPlotoptionsArcdiagram':
        """Arc diagram series is a chart drawing style in which the vertices of the chart are positioned along a line on the Euclidean plane and the edges are drawn as a semicircle in one of the two half-planes delimited by the line, or as smooth curves formed by sequences of semicircles. """
        return self._config_sub_data("arcdiagram", OptionPlotoptionsArcdiagram)

    @property
    def area(self) -> 'OptionPlotoptionsArea':
        """The area series type. """
        return self._config_sub_data("area", OptionPlotoptionsArea)

    @property
    def arearange(self) -> 'OptionPlotoptionsArearange':
        """The area range series is a carteseian series with higher and lower values for each point along an X axis, where the area between the values is shaded. """
        return self._config_sub_data("arearange", OptionPlotoptionsArearange)

    @property
    def areaspline(self) -> 'OptionPlotoptionsAreaspline':
        """The area spline series is an area series where the graph between the points is smoothed into a spline. """
        return self._config_sub_data("areaspline", OptionPlotoptionsAreaspline)

    @property
    def areasplinerange(self) -> 'OptionPlotoptionsAreasplinerange':
        """The area spline range is a cartesian series type with higher and lower Y values along an X axis. """
        return self._config_sub_data("areasplinerange", OptionPlotoptionsAreasplinerange)

    @property
    def bar(self) -> 'OptionPlotoptionsBar':
        """A bar series is a special type of column series where the columns are horizontal. """
        return self._config_sub_data("bar", OptionPlotoptionsBar)

    @property
    def bellcurve(self) -> 'OptionPlotoptionsBellcurve':
        """A bell curve is an areaspline series which represents the probability density function of the normal distribution. """
        return self._config_sub_data("bellcurve", OptionPlotoptionsBellcurve)

    @property
    def boxplot(self) -> 'OptionPlotoptionsBoxplot':
        """A box plot is a convenient way of depicting groups of data through their five-number summaries: the smallest observation (sample minimum), lower quartile (Q1), median (Q2), upper quartile (Q3), and largest observation (sample maximum). """
        return self._config_sub_data("boxplot", OptionPlotoptionsBoxplot)

    @property
    def bubble(self) -> 'OptionPlotoptionsBubble':
        """A bubble series is a three dimensional series type where each point renders an X, Y and Z value. """
        return self._config_sub_data("bubble", OptionPlotoptionsBubble)

    @property
    def bullet(self) -> 'OptionPlotoptionsBullet':
        """A bullet graph is a variation of a bar graph. """
        return self._config_sub_data("bullet", OptionPlotoptionsBullet)

    @property
    def column(self) -> 'OptionPlotoptionsColumn':
        """Column series display one column per value along an X axis. """
        return self._config_sub_data("column", OptionPlotoptionsColumn)

    @property
    def columnpyramid(self) -> 'OptionPlotoptionsColumnpyramid':
        """Column pyramid series display one pyramid per value along an X axis. """
        return self._config_sub_data("columnpyramid", OptionPlotoptionsColumnpyramid)

    @property
    def columnrange(self) -> 'OptionPlotoptionsColumnrange':
        """The column range is a cartesian series type with higher and lower Y values along an X axis. """
        return self._config_sub_data("columnrange", OptionPlotoptionsColumnrange)

    @property
    def cylinder(self) -> 'OptionPlotoptionsCylinder':
        """A cylinder graph is a variation of a 3d column graph. """
        return self._config_sub_data("cylinder", OptionPlotoptionsCylinder)

    @property
    def dependencywheel(self) -> 'OptionPlotoptionsDependencywheel':
        """A dependency wheel chart is a type of flow diagram, where all nodes are laid out in a circle, and the flow between the are drawn as link bands. """
        return self._config_sub_data("dependencywheel", OptionPlotoptionsDependencywheel)

    @property
    def dumbbell(self) -> 'OptionPlotoptionsDumbbell':
        """The dumbbell series is a cartesian series with higher and lower values for each point along an X axis, connected with a line between the values. """
        return self._config_sub_data("dumbbell", OptionPlotoptionsDumbbell)

    @property
    def errorbar(self) -> 'OptionPlotoptionsErrorbar':
        """Error bars are a graphical representation of the variability of data and are used on graphs to indicate the error, or uncertainty in a reported measurement. """
        return self._config_sub_data("errorbar", OptionPlotoptionsErrorbar)

    @property
    def funnel(self) -> 'OptionPlotoptionsFunnel':
        """Funnel charts are a type of chart often used to visualize stages in a sales project, where the top are the initial stages with the most clients. """
        return self._config_sub_data("funnel", OptionPlotoptionsFunnel)

    @property
    def funnel3d(self) -> 'OptionPlotoptionsFunnel3d':
        """A funnel3d is a 3d version of funnel series type. """
        return self._config_sub_data("funnel3d", OptionPlotoptionsFunnel3d)

    @property
    def gauge(self) -> 'OptionPlotoptionsGauge':
        """Gauges are circular plots displaying one or more values with a dial pointing to values along the perimeter. """
        return self._config_sub_data("gauge", OptionPlotoptionsGauge)

    @property
    def heatmap(self) -> 'OptionPlotoptionsHeatmap':
        """A heatmap is a graphical representation of data where the individual values contained in a matrix are represented as colors. """
        return self._config_sub_data("heatmap", OptionPlotoptionsHeatmap)

    @property
    def histogram(self) -> 'OptionPlotoptionsHistogram':
        """A histogram is a column series which represents the distribution of the data set in the base series. """
        return self._config_sub_data("histogram", OptionPlotoptionsHistogram)

    @property
    def item(self) -> 'OptionPlotoptionsItem':
        """An item chart is an infographic chart where a number of items are laid out in either a rectangular or circular pattern. """
        return self._config_sub_data("item", OptionPlotoptionsItem)

    @property
    def line(self) -> 'OptionPlotoptionsLine':
        """A line series displays information as a series of data points connected by straight line segments. """
        return self._config_sub_data("line", OptionPlotoptionsLine)

    @property
    def lollipop(self) -> 'OptionPlotoptionsLollipop':
        """The lollipop series is a carteseian series with a line anchored from the x axis and a dot at the end to mark the value. """
        return self._config_sub_data("lollipop", OptionPlotoptionsLollipop)

    @property
    def networkgraph(self) -> 'OptionPlotoptionsNetworkgraph':
        """A networkgraph is a type of relationship chart, where connnections (links) attracts nodes (points) and other nodes repulse each other. """
        return self._config_sub_data("networkgraph", OptionPlotoptionsNetworkgraph)

    @property
    def organization(self) -> 'OptionPlotoptionsOrganization':
        """An organization chart is a diagram that shows the structure of an organization and the relationships and relative ranks of its parts and positions. """
        return self._config_sub_data("organization", OptionPlotoptionsOrganization)

    @property
    def packedbubble(self) -> 'OptionPlotoptionsPackedbubble':
        """A packed bubble series is a two dimensional series type, where each point renders a value in X, Y position. """
        return self._config_sub_data("packedbubble", OptionPlotoptionsPackedbubble)

    @property
    def pareto(self) -> 'OptionPlotoptionsPareto':
        """A pareto diagram is a type of chart that contains both bars and a line graph, where individual values are represented in descending order by bars, and the cumulative total is represented by the line. """
        return self._config_sub_data("pareto", OptionPlotoptionsPareto)

    @property
    def pictorial(self) -> 'OptionPlotoptionsPictorial':
        """A pictorial chart uses vector images to represents the data. """
        return self._config_sub_data("pictorial", OptionPlotoptionsPictorial)

    @property
    def pie(self) -> 'OptionPlotoptionsPie':
        """A pie chart is a circular graphic which is divided into slices to illustrate numerical proportion. """
        return self._config_sub_data("pie", OptionPlotoptionsPie)

    @property
    def polygon(self) -> 'OptionPlotoptionsPolygon':
        """A polygon series can be used to draw any freeform shape in the cartesian coordinate system. """
        return self._config_sub_data("polygon", OptionPlotoptionsPolygon)

    @property
    def pyramid(self) -> 'OptionPlotoptionsPyramid':
        """A pyramid series is a special type of funnel, without neck and reversed by default. """
        return self._config_sub_data("pyramid", OptionPlotoptionsPyramid)

    @property
    def pyramid3d(self) -> 'OptionPlotoptionsPyramid3d':
        """A pyramid3d is a 3d version of pyramid series type. """
        return self._config_sub_data("pyramid3d", OptionPlotoptionsPyramid3d)

    @property
    def sankey(self) -> 'OptionPlotoptionsSankey':
        """A sankey diagram is a type of flow diagram, in which the width of the link between two nodes is shown proportionally to the flow quantity. """
        return self._config_sub_data("sankey", OptionPlotoptionsSankey)

    @property
    def scatter(self) -> 'OptionPlotoptionsScatter':
        """A scatter plot uses cartesian coordinates to display values for two variables for a set of data. """
        return self._config_sub_data("scatter", OptionPlotoptionsScatter)

    @property
    def scatter3d(self) -> 'OptionPlotoptionsScatter3d':
        """A 3D scatter plot uses x, y and z coordinates to display values for three variables for a set of data. """
        return self._config_sub_data("scatter3d", OptionPlotoptionsScatter3d)

    @property
    def series(self) -> 'OptionPlotoptionsSeries':
        """General options for all series types. """
        return self._config_sub_data("series", OptionPlotoptionsSeries)

    @property
    def solidgauge(self) -> 'OptionPlotoptionsSolidgauge':
        """A solid gauge is a circular gauge where the value is indicated by a filled arc, and the color of the arc may variate with the value. """
        return self._config_sub_data("solidgauge", OptionPlotoptionsSolidgauge)

    @property
    def spline(self) -> 'OptionPlotoptionsSpline':
        """A spline series is a special type of line series, where the segments between the data points are smoothed. """
        return self._config_sub_data("spline", OptionPlotoptionsSpline)

    @property
    def streamgraph(self) -> 'OptionPlotoptionsStreamgraph':
        """A streamgraph is a type of stacked area graph which is displaced around a central axis, resulting in a flowing, organic shape. """
        return self._config_sub_data("streamgraph", OptionPlotoptionsStreamgraph)

    @property
    def sunburst(self) -> 'OptionPlotoptionsSunburst':
        """A Sunburst displays hierarchical data, where a level in the hierarchy is represented by a circle. """
        return self._config_sub_data("sunburst", OptionPlotoptionsSunburst)

    @property
    def tilemap(self) -> 'OptionPlotoptionsTilemap':
        """A tilemap series is a type of heatmap where the tile shapes are configurable. """
        return self._config_sub_data("tilemap", OptionPlotoptionsTilemap)

    @property
    def timeline(self) -> 'OptionPlotoptionsTimeline':
        """The timeline series presents given events along a drawn line. """
        return self._config_sub_data("timeline", OptionPlotoptionsTimeline)

    @property
    def treegraph(self) -> 'OptionPlotoptionsTreegraph':
        """A treegraph series is a diagram, which shows a relation between ancestors and descendants with a clear parent - child relation. """
        return self._config_sub_data("treegraph", OptionPlotoptionsTreegraph)

    @property
    def treemap(self) -> 'OptionPlotoptionsTreemap':
        """A treemap displays hierarchical data using nested rectangles. """
        return self._config_sub_data("treemap", OptionPlotoptionsTreemap)

    @property
    def variablepie(self) -> 'OptionPlotoptionsVariablepie':
        """A variable pie series is a two dimensional series type, where each point renders an Y and Z value. """
        return self._config_sub_data("variablepie", OptionPlotoptionsVariablepie)

    @property
    def variwide(self) -> 'OptionPlotoptionsVariwide':
        """A variwide chart (related to marimekko chart) is a column chart with a variable width expressing a third dimension. """
        return self._config_sub_data("variwide", OptionPlotoptionsVariwide)

    @property
    def vector(self) -> 'OptionPlotoptionsVector':
        """A vector plot is a type of cartesian chart where each point has an X and Y position, a length and a direction. """
        return self._config_sub_data("vector", OptionPlotoptionsVector)

    @property
    def venn(self) -> 'OptionPlotoptionsVenn':
        """A Venn diagram displays all possible logical relations between a collection of different sets. """
        return self._config_sub_data("venn", OptionPlotoptionsVenn)

    @property
    def waterfall(self) -> 'OptionPlotoptionsWaterfall':
        """A waterfall chart displays sequentially introduced positive or negative values in cumulative columns. """
        return self._config_sub_data("waterfall", OptionPlotoptionsWaterfall)

    @property
    def windbarb(self) -> 'OptionPlotoptionsWindbarb':
        """Wind barbs are a convenient way to represent wind speed and direction in one graphical form. """
        return self._config_sub_data("windbarb", OptionPlotoptionsWindbarb)

    @property
    def wordcloud(self) -> 'OptionPlotoptionsWordcloud':
        """A word cloud is a visualization of a set of words, where the size and placement of a word is determined by how it is weighted. """
        return self._config_sub_data("wordcloud", OptionPlotoptionsWordcloud)

    @property
    def xrange(self) -> 'OptionPlotoptionsXrange':
        """The X-range series displays ranges on the X axis, typically time intervals with a start and end date. """
        return self._config_sub_data("xrange", OptionPlotoptionsXrange)

        
class OptionPlotoptionsItemTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsItemTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsItemTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsItemStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsItemStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsItemStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsItemStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsItemStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsItemStatesSelectMarker)

        
class OptionPlotoptionsItemStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsItemStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsItemStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsItemStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsItemStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsItemStatesHoverHalo)

        
class OptionPlotoptionsItemStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsItemStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsItemStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsItemStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsItemStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsItemStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsItemStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsItemStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsItemStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsItemStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsItemStatesSelect)

        
class OptionPlotoptionsItemSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsItemSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsItemSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsItemSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsItemSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsItemSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsItemSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsItemSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsItemSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsItemSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsItemSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsItemSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsItemSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsItemSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsItemSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsItemSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsItemSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsItemSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsItemSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsItemSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsItemSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsItemSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsItemSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsItemSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsItemSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsItemSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsItemSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsItemSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsItemSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsItemSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsItemSonificationTracksMappingVolume)

        
class OptionPlotoptionsItemSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsItemSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsItemSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsItemSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsItemSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsItemSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsItemSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsItemSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsItemSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsItemSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsItemSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsItemSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsItemSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsItemSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsItemSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsItemSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsItemSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsItemSonificationTracks)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsItemSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsItemSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsItemSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsItemSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsItemSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsItemSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsItemSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsItemSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsItemSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsItemSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsItemSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsItemSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsItemSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsItemSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsItemSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsItemSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsItemSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsItemSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsItemSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsItemSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsItemSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsItemSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsItemSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsItemSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsItemSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsItemSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsItemSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsItemSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsItemSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsItemSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsItemSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsItemSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsItemSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsItemSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsItemPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsItemPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsItemPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsItemPointEvents)

        
class OptionPlotoptionsItemOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsItemOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsItemOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsItemOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsItemOnpointPosition)

        
class OptionPlotoptionsItemMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsItemMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsItemMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsItemMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsItemMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsItemMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsItemMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsItemMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsItemMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsItemMarkerStatesSelect)

        
class OptionPlotoptionsItemMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsItemMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsItemMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItem(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsItemAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsItemAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the pie chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(False)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsItemDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsItemDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """In circular view, the end angle of the item layout, in degrees where 0 is up.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @endAngle.setter
    def endAngle(self, value: Any): self._config(value, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsItemEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsItemEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def innerSize(self):
        """In circular view, the size of the inner diameter of the circle.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("40%")

    @innerSize.setter
    def innerSize(self, text: str): self._config(text, js_type=False)

    @property
    def itemPadding(self):
        """The padding between the items, given in relative size where the size of the item is 1.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @itemPadding.setter
    def itemPadding(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def layout(self):
        """The layout of the items in rectangular view.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("vertical")

    @layout.setter
    def layout(self, text: str): self._config(text, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsItemMarker':
        """. """
        return self._config_sub_data("marker", OptionPlotoptionsItemMarker)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsItemOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsItemOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsItemPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsItemPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rows(self):
        """The number of rows to display in the rectangular or circular view.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @rows.setter
    def rows(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(True)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsItemSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsItemSonification)

    @property
    def startAngle(self):
        """In circular view, the start angle of the item layout, in degrees where 0 is up.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @startAngle.setter
    def startAngle(self, value: Any): self._config(value, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsItemStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsItemStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsItemTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsItemTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsItemDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsItemDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsItemDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsItemDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsItemDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsItemDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsItemDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsItemDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsItemAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsItemAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsItemAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsItemAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsItemAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsItemAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsItemAccessibilityPoint)

        
class OptionPlotoptionsHistogramZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsHistogramTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsHistogramTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{point.x} - {point.x2}</span><br/><span style="color:{point.color}">●</span> {series.name} <b>{point.y}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsHistogramStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsHistogramStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHistogramStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHistogramStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsHistogramStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsHistogramStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHistogramStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsHistogramStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsHistogramStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsHistogramStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsHistogramStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsHistogramStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsHistogramStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsHistogramStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsHistogramStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsHistogramStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsHistogramStatesSelect)

        
class OptionPlotoptionsHistogramSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsHistogramSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsHistogramSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsHistogramSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHistogramSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsHistogramSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsHistogramSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsHistogramSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsHistogramSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsHistogramSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsHistogramSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsHistogramSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHistogramSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsHistogramSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHistogramSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsHistogramSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsHistogramSonificationTracksMappingVolume)

        
class OptionPlotoptionsHistogramSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHistogramSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHistogramSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsHistogramSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHistogramSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHistogramSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHistogramSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHistogramSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHistogramSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHistogramSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsHistogramSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsHistogramSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsHistogramSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHistogramSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHistogramSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsHistogramSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsHistogramSonificationTracks)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsHistogramSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHistogramSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHistogramSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHistogramSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsHistogramSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsHistogramSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsHistogramSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHistogramSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsHistogramSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsHistogramSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsHistogramSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsHistogramSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsHistogramSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsHistogramSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHistogramSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsHistogramSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHistogramSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsHistogramSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsHistogramSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsHistogramSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHistogramSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHistogramSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHistogramSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHistogramSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHistogramSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHistogramSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsHistogramPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHistogramPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsHistogramPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsHistogramPointEvents)

        
class OptionPlotoptionsHistogramOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsHistogramOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsHistogramOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsHistogramOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsHistogramOnpointPosition)

        
class OptionPlotoptionsHistogramLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsHistogramLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsHistogramLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHistogram(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsHistogramAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsHistogramAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def binsNumber(self):
        """A preferable number of bins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(square-root)

    @binsNumber.setter
    def binsNumber(self, value: Any): self._config(value, js_type=False)

    @property
    def binWidth(self):
        """Width of each bin.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @binWidth.setter
    def binWidth(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsHistogramDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsHistogramDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsHistogramDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsHistogramDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsHistogramEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsHistogramEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(False)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(0)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsHistogramLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsHistogramLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsHistogramOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsHistogramOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsHistogramPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsHistogramPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(0)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get("between")

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsHistogramSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsHistogramSonification)

    @property
    def states(self) -> 'OptionPlotoptionsHistogramStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsHistogramStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsHistogramTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsHistogramTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsHistogramZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsHistogramZones)

        
class OptionPlotoptionsHistogramDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHistogramDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsHistogramDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsHistogramDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsHistogramDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsHistogramDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsHistogramDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsHistogramDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHistogramAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHistogramAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHistogramAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsHistogramAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsHistogramAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsHistogramAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsHistogramAccessibilityPoint)

        
class OptionPlotoptionsHeatmapZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsHeatmapTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsHeatmapTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("{point.x}, {point.y}: {point.value}<br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsHeatmapStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsHeatmapStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsHeatmapStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsHeatmapStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsHeatmapStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsHeatmapStatesSelectMarker)

        
class OptionPlotoptionsHeatmapStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHeatmapStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsHeatmapStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsHeatmapStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsHeatmapStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsHeatmapStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsHeatmapStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsHeatmapStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsHeatmapStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsHeatmapStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsHeatmapStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsHeatmapStatesSelect)

        
class OptionPlotoptionsHeatmapStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsHeatmapStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsHeatmapStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsHeatmapStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsHeatmapStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsHeatmapStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsHeatmapStatesHoverMarker)

        
class OptionPlotoptionsHeatmapSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsHeatmapSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsHeatmapSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHeatmapSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsHeatmapSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsHeatmapSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsHeatmapSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsHeatmapSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsHeatmapSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsHeatmapSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHeatmapSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsHeatmapSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHeatmapSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsHeatmapSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsHeatmapSonificationTracksMappingVolume)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHeatmapSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsHeatmapSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHeatmapSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHeatmapSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHeatmapSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHeatmapSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHeatmapSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHeatmapSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsHeatmapSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsHeatmapSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHeatmapSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHeatmapSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsHeatmapSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsHeatmapSonificationTracks)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsHeatmapSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHeatmapSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHeatmapSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsHeatmapSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsHeatmapSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsHeatmapSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsHeatmapSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsHeatmapSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsHeatmapSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsHeatmapSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsHeatmapSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsHeatmapSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsHeatmapSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsHeatmapSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsHeatmapSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsHeatmapSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsHeatmapSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsHeatmapSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsHeatmapSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsHeatmapSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsHeatmapSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsHeatmapPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsHeatmapPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsHeatmapPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsHeatmapPointEvents)

        
class OptionPlotoptionsHeatmapOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsHeatmapOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsHeatmapOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsHeatmapOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsHeatmapOnpointPosition)

        
class OptionPlotoptionsHeatmapMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHeatmapMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsHeatmapMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsHeatmapMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsHeatmapMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsHeatmapMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsHeatmapMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsHeatmapMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsHeatmapMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsHeatmapMarkerStatesSelect)

        
class OptionPlotoptionsHeatmapMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsHeatmapMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsHeatmapMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("rect")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsHeatmapLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsHeatmapLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHeatmap(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsHeatmapAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsHeatmapAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Animation is disabled by default on the heatmap series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderRadius(self):
        """The border radius for each heatmap item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("value")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colsize(self):
        """The column size - how many X axis units each column in the heatmap should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(1)

    @colsize.setter
    def colsize(self, num: float): self._config(num, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsHeatmapDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsHeatmapDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsHeatmapDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsHeatmapDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsHeatmapEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsHeatmapEvents)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def interpolation(self):
        """Make the heatmap render its data points as an interpolated image.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @interpolation.setter
    def interpolation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsHeatmapLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsHeatmapLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsHeatmapMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsHeatmapMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def nullColor(self):
        """The color applied to null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("#f7f7f7")

    @nullColor.setter
    def nullColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsHeatmapOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsHeatmapOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsHeatmapPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsHeatmapPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between the points in the heatmap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rowsize(self):
        """The row size - how many Y axis units each heatmap row should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(1)

    @rowsize.setter
    def rowsize(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsHeatmapSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsHeatmapSonification)

    @property
    def states(self) -> 'OptionPlotoptionsHeatmapStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsHeatmapStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsHeatmapTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsHeatmapTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsHeatmapZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsHeatmapZones)

        
class OptionPlotoptionsHeatmapDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHeatmapDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsHeatmapDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsHeatmapDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsHeatmapDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsHeatmapDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsHeatmapDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsHeatmapDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsHeatmapAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsHeatmapAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsHeatmapAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsHeatmapAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsHeatmapAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsHeatmapAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsHeatmapAccessibilityPoint)

        
class OptionPlotoptionsGaugeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsGaugeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsGaugeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsGaugeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsGaugeSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsGaugeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsGaugeSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsGaugeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsGaugeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsGaugeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsGaugeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsGaugeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsGaugeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsGaugeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsGaugeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsGaugeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsGaugeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsGaugeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsGaugeSonificationTracksMappingVolume)

        
class OptionPlotoptionsGaugeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsGaugeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsGaugeSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsGaugeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsGaugeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsGaugeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsGaugeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsGaugeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsGaugeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsGaugeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsGaugeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsGaugeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsGaugeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsGaugeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsGaugeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsGaugeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsGaugeSonificationTracks)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsGaugeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsGaugeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsGaugeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsGaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsGaugeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsGaugeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsGaugeSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsGaugeSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsGaugeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsGaugeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsGaugeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsGaugeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsGaugeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsGaugeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsGaugeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsGaugeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsGaugeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsGaugeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsGaugeSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsGaugeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsGaugeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsGaugeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsGaugeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsGaugeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsGaugeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsGaugeSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsGaugePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsGaugePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsGaugePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsGaugePointEvents)

        
class OptionPlotoptionsGaugePivot(Options):

    @property
    def backgroundColor(self):
        """The background color or fill of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#000000")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border or stroke color of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The border or stroke width of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The pixel radius of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(5)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsGaugeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsGaugeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsGaugeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsGaugeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsGaugeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsGaugeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsGaugeOnpointPosition)

        
class OptionPlotoptionsGaugeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsGaugeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsGaugeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsGauge(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsGaugeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsGaugeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsGaugeDatalabels':
        """Data labels for the gauge. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsGaugeDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dial(self) -> 'OptionPlotoptionsGaugeDial':
        """Options for the dial or arrow pointer of the gauge. """
        return self._config_sub_data("dial", OptionPlotoptionsGaugeDial)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsGaugeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsGaugeEvents)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsGaugeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsGaugeLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsGaugeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsGaugeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def overshoot(self):
        """Allow the dial to overshoot the end of the perimeter axis by this many degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(None)

    @overshoot.setter
    def overshoot(self, num: float): self._config(num, js_type=False)

    @property
    def pivot(self) -> 'OptionPlotoptionsGaugePivot':
        """Options for the pivot or the center point of the gauge. """
        return self._config_sub_data("pivot", OptionPlotoptionsGaugePivot)

    @property
    def point(self) -> 'OptionPlotoptionsGaugePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsGaugePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsGaugeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsGaugeSonification)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsGaugeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsGaugeTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def wrap(self):
        """When this option is <code>true</code>, the dial will wrap around the axes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(True)

    @wrap.setter
    def wrap(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsGaugeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsGaugeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsGaugeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsGaugeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsGaugeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsGaugeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsGaugeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsGaugeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(15)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(2)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsGaugeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsGaugeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsGaugeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsGaugeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsGaugeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsGaugeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsGaugeAccessibilityPoint)

        
class OptionPlotoptionsFunnel3dZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsFunnel3dTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsFunnel3dTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsFunnel3dStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnel3dStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnel3dStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnel3dStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsFunnel3dStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnel3dStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnel3dStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsFunnel3dStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnel3dStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsFunnel3dStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsFunnel3dStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsFunnel3dStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsFunnel3dStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsFunnel3dStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsFunnel3dStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsFunnel3dStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsFunnel3dStatesSelect)

        
class OptionPlotoptionsFunnel3dSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsFunnel3dSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsFunnel3dSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnel3dSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsFunnel3dSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsFunnel3dSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsFunnel3dSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsFunnel3dSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsFunnel3dSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnel3dSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnel3dSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsFunnel3dSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnel3dSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsFunnel3dSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnel3dSonificationTracksMappingVolume)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnel3dSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsFunnel3dSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnel3dSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnel3dSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnel3dSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnel3dSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsFunnel3dSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnel3dSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnel3dSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsFunnel3dSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsFunnel3dSonificationTracks)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsFunnel3dSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnel3dSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsFunnel3dSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsFunnel3dSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsFunnel3dSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsFunnel3dSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnel3dSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnel3dSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsFunnel3dSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnel3dSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsFunnel3dSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnel3dSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsFunnel3dSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnel3dSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnel3dSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnel3dSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnel3dSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsFunnel3dPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnel3dPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsFunnel3dPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsFunnel3dPointEvents)

        
class OptionPlotoptionsFunnel3dOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsFunnel3dOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsFunnel3dOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsFunnel3dOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsFunnel3dOnpointPosition)

        
class OptionPlotoptionsFunnel3dLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsFunnel3dLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsFunnel3dLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnel3d(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsFunnel3dAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsFunnel3dAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsFunnel3dDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsFunnel3dDatalabels)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsFunnel3dDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsFunnel3dDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(0)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsFunnel3dEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsFunnel3dEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def gradientForSides(self):
        """By deafult sides fill is set to a gradient through this option being set to <code>true</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @gradientForSides.setter
    def gradientForSides(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """The height of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsFunnel3dLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsFunnel3dLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def neckHeight(self):
        """The height of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("25%")

    @neckHeight.setter
    def neckHeight(self, num: float): self._config(num, js_type=False)

    @property
    def neckWidth(self):
        """The width of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("30%")

    @neckWidth.setter
    def neckWidth(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsFunnel3dOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsFunnel3dOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsFunnel3dPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsFunnel3dPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed funnel has the widest area down.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsFunnel3dSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsFunnel3dSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsFunnel3dStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsFunnel3dStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsFunnel3dTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsFunnel3dTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The max width of the series compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsFunnel3dZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsFunnel3dZones)

        
class OptionPlotoptionsFunnel3dDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnel3dDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsFunnel3dDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnel3dDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsFunnel3dDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsFunnel3dDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("allow")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsFunnel3dDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsFunnel3dDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnel3dAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnel3dAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnel3dAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsFunnel3dAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsFunnel3dAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsFunnel3dAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsFunnel3dAccessibilityPoint)

        
class OptionPlotoptionsFunnelTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsFunnelTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsFunnelTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsFunnelStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnelStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnelStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnelStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsFunnelStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnelStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnelStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsFunnelStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnelStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsFunnelStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsFunnelStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsFunnelStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsFunnelStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsFunnelStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsFunnelStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsFunnelStatesSelect':
        """Options for a selected funnel item. """
        return self._config_sub_data("select", OptionPlotoptionsFunnelStatesSelect)

        
class OptionPlotoptionsFunnelSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsFunnelSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsFunnelSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsFunnelSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnelSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsFunnelSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsFunnelSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsFunnelSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsFunnelSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsFunnelSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsFunnelSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnelSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnelSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsFunnelSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnelSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsFunnelSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnelSonificationTracksMappingVolume)

        
class OptionPlotoptionsFunnelSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnelSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnelSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsFunnelSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnelSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnelSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnelSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnelSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnelSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnelSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsFunnelSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsFunnelSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsFunnelSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnelSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnelSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsFunnelSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsFunnelSonificationTracks)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsFunnelSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnelSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnelSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnelSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsFunnelSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsFunnelSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsFunnelSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnelSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsFunnelSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsFunnelSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsFunnelSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsFunnelSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsFunnelSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsFunnelSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsFunnelSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsFunnelSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsFunnelSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsFunnelSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsFunnelSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsFunnelSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsFunnelSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsFunnelSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsFunnelSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsFunnelSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsFunnelSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsFunnelSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsFunnelPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsFunnelPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsFunnelPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsFunnelPointEvents)

        
class OptionPlotoptionsFunnelOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsFunnelOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsFunnelOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsFunnelOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsFunnelOnpointPosition)

        
class OptionPlotoptionsFunnel(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsFunnelAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsFunnelAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Initial animation is by default disabled for the funnel chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding all points or series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(["50%", "50%"])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsFunnelDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsFunnelDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsFunnelEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsFunnelEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """The height of the funnel or pyramid.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def neckHeight(self):
        """The height of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("25%")

    @neckHeight.setter
    def neckHeight(self, num: float): self._config(num, js_type=False)

    @property
    def neckWidth(self):
        """The width of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("30%")

    @neckWidth.setter
    def neckWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsFunnelOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsFunnelOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsFunnelPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsFunnelPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed funnel has the widest area down.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsFunnelSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsFunnelSonification)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsFunnelStates':
        """Options for the series states. """
        return self._config_sub_data("states", OptionPlotoptionsFunnelStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsFunnelTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsFunnelTooltip)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The width of the funnel compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnelDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsFunnelDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsFunnelDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsFunnelDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsFunnelDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsFunnelDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsFunnelDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsFunnelAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsFunnelAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsFunnelAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsFunnelAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsFunnelAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsFunnelAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsFunnelAccessibilityPoint)

        
class OptionPlotoptionsErrorbarZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsErrorbarTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsErrorbarTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsErrorbarSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsErrorbarSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsErrorbarSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsErrorbarSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsErrorbarSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsErrorbarSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsErrorbarSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsErrorbarSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsErrorbarSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsErrorbarSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsErrorbarSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsErrorbarSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsErrorbarSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsErrorbarSonificationTracksMappingVolume)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsErrorbarSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsErrorbarSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsErrorbarSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsErrorbarSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsErrorbarSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsErrorbarSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsErrorbarSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsErrorbarSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsErrorbarSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsErrorbarSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsErrorbarSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsErrorbarSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsErrorbarSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsErrorbarSonificationTracks)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsErrorbarSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsErrorbarSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsErrorbarSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsErrorbarSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsErrorbarSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsErrorbarSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsErrorbarSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsErrorbarSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsErrorbarSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsErrorbarSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsErrorbarSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsErrorbarSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsErrorbarSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsErrorbarSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsErrorbarSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsErrorbarSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsErrorbarSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsErrorbarSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsErrorbarSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsErrorbarSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsErrorbarSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsErrorbarPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsErrorbarPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsErrorbarPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsErrorbarPointEvents)

        
class OptionPlotoptionsErrorbarOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsErrorbarOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsErrorbarOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsErrorbarOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsErrorbarOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsErrorbarOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsErrorbarOnpointPosition)

        
class OptionPlotoptionsErrorbarLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsErrorbarLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsErrorbarLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsErrorbar(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsErrorbarAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsErrorbarAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boxDashStyle(self):
        """The dash style of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @boxDashStyle.setter
    def boxDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the bars.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("high")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsErrorbarDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsErrorbarDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsErrorbarDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsErrorbarDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsErrorbarDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsErrorbarDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsErrorbarEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsErrorbarEvents)

    @property
    def fillColor(self):
        """The fill color of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get(False)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsErrorbarLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsErrorbarLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line surrounding the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The parent series of the error bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get(":previous")

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def medianColor(self):
        """The color of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @medianColor.setter
    def medianColor(self, text: str): self._config(text, js_type=False)

    @property
    def medianDashStyle(self):
        """The dash style of the median.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @medianDashStyle.setter
    def medianDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def medianWidth(self):
        """The pixel width of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(2)

    @medianWidth.setter
    def medianWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsErrorbarOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsErrorbarOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsErrorbarPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsErrorbarPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsErrorbarSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsErrorbarSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def stemColor(self):
        """The color of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemColor.setter
    def stemColor(self, text: str): self._config(text, js_type=False)

    @property
    def stemDashStyle(self):
        """The dash style of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @stemDashStyle.setter
    def stemDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def stemWidth(self):
        """The width of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemWidth.setter
    def stemWidth(self, num: float): self._config(num, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsErrorbarTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsErrorbarTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def whiskerColor(self):
        """The color of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @whiskerColor.setter
    def whiskerColor(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerDashStyle(self):
        """The dash style of the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @whiskerDashStyle.setter
    def whiskerDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerLength(self):
        """The length of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("50%")

    @whiskerLength.setter
    def whiskerLength(self, num: float): self._config(num, js_type=False)

    @property
    def whiskerWidth(self):
        """The line width of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get(None)

    @whiskerWidth.setter
    def whiskerWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsErrorbarZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsErrorbarZones)

        
class OptionPlotoptionsErrorbarDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsErrorbarDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsErrorbarDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsErrorbarDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsErrorbarDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsErrorbarDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsErrorbarDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsErrorbarDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsErrorbarAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsErrorbarAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsErrorbarAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsErrorbarAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsErrorbarAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsErrorbarAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsErrorbarAccessibilityPoint)

        
class OptionPlotoptionsDumbbellZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsDumbbellTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsDumbbellTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDumbbellStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsDumbbellStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsDumbbellStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsDumbbellStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsDumbbellStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsDumbbellStatesSelectMarker)

        
class OptionPlotoptionsDumbbellStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbellStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDumbbellStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsDumbbellStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsDumbbellStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsDumbbellStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsDumbbellStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsDumbbellStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsDumbbellStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsDumbbellStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsDumbbellStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsDumbbellStatesSelect)

        
class OptionPlotoptionsDumbbellStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDumbbellStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsDumbbellStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsDumbbellStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsDumbbellStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsDumbbellStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsDumbbellStatesHoverMarker)

        
class OptionPlotoptionsDumbbellSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsDumbbellSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsDumbbellSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDumbbellSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsDumbbellSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsDumbbellSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsDumbbellSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsDumbbellSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsDumbbellSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsDumbbellSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDumbbellSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsDumbbellSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDumbbellSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsDumbbellSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsDumbbellSonificationTracksMappingVolume)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDumbbellSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsDumbbellSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDumbbellSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDumbbellSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDumbbellSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDumbbellSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDumbbellSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDumbbellSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsDumbbellSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsDumbbellSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDumbbellSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDumbbellSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsDumbbellSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsDumbbellSonificationTracks)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsDumbbellSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDumbbellSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDumbbellSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsDumbbellSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsDumbbellSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsDumbbellSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsDumbbellSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsDumbbellSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsDumbbellSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsDumbbellSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsDumbbellSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDumbbellSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsDumbbellSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDumbbellSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsDumbbellSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsDumbbellSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsDumbbellSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDumbbellSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDumbbellSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDumbbellSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDumbbellSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsDumbbellPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDumbbellPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsDumbbellPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsDumbbellPointEvents)

        
class OptionPlotoptionsDumbbellOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsDumbbellOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsDumbbellOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsDumbbellOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsDumbbellOnpointPosition)

        
class OptionPlotoptionsDumbbellMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbellMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDumbbellMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsDumbbellMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsDumbbellMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsDumbbellMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsDumbbellMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsDumbbellMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsDumbbellMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsDumbbellMarkerStatesSelect)

        
class OptionPlotoptionsDumbbellMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsDumbbellMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsDumbbellMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbellLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDumbbellLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsDumbbellLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsDumbbellLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsDumbbellLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsDumbbellLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsDumbbellLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsDumbbellLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsDumbbellLowmarkerStatesSelect)

        
class OptionPlotoptionsDumbbellLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsDumbbellLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsDumbbellLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsDumbbellLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsDumbbellLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbell(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsDumbbellAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsDumbbellAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorColor(self):
        """Color of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsDumbbellDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsDumbbellDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsDumbbellDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsDumbbellDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsDumbbellDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsDumbbellDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsDumbbellEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsDumbbellEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsDumbbellLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsDumbbellLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionPlotoptionsDumbbellLowmarker':
        """Options for the lower markers of the dumbbell-like series. """
        return self._config_sub_data("lowMarker", OptionPlotoptionsDumbbellLowmarker)

    @property
    def marker(self) -> 'OptionPlotoptionsDumbbellMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsDumbbellMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsDumbbellOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsDumbbellOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsDumbbellPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsDumbbellPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsDumbbellSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsDumbbellSonification)

    @property
    def states(self) -> 'OptionPlotoptionsDumbbellStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsDumbbellStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsDumbbellTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsDumbbellTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsDumbbellZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsDumbbellZones)

        
class OptionPlotoptionsDumbbellDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbellDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsDumbbellDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsDumbbellDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsDumbbellDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsDumbbellDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsDumbbellDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsDumbbellDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDumbbellAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDumbbellAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDumbbellAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsDumbbellAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsDumbbellAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsDumbbellAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsDumbbellAccessibilityPoint)

        
class OptionPlotoptionsDependencywheelTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsDependencywheelTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsDependencywheelTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.name}: <b>{point.sum}</b><br/>")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsDependencywheelStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsDependencywheelStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsDependencywheelStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsDependencywheelStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsDependencywheelStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsDependencywheelStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsDependencywheelStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsDependencywheelStatesSelect)

        
class OptionPlotoptionsDependencywheelSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsDependencywheelSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsDependencywheelSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDependencywheelSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsDependencywheelSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsDependencywheelSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsDependencywheelSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsDependencywheelSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsDependencywheelSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsDependencywheelSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDependencywheelSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsDependencywheelSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDependencywheelSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsDependencywheelSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsDependencywheelSonificationTracksMappingVolume)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDependencywheelSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsDependencywheelSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDependencywheelSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDependencywheelSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDependencywheelSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDependencywheelSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsDependencywheelSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDependencywheelSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDependencywheelSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsDependencywheelSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsDependencywheelSonificationTracks)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsDependencywheelSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDependencywheelSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsDependencywheelSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsDependencywheelSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsDependencywheelSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsDependencywheelSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsDependencywheelSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsDependencywheelSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsDependencywheelSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsDependencywheelSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsDependencywheelSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsDependencywheelSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsDependencywheelSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsDependencywheelSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsDependencywheelSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsDependencywheelSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsDependencywheelSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsDependencywheelPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsDependencywheelPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsDependencywheelPointEvents)

        
class OptionPlotoptionsDependencywheelOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsDependencywheelOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsDependencywheelOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsDependencywheelOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsDependencywheelOnpointPosition)

        
class OptionPlotoptionsDependencywheelLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsDependencywheelLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsDependencywheelLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsDependencywheelLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsDependencywheelLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsDependencywheelLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsDependencywheelLevelsStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsDependencywheelLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsDependencywheelLevelsStatesSelect)

        
class OptionPlotoptionsDependencywheelLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsDependencywheelLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsDependencywheelLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsDependencywheelLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionPlotoptionsDependencywheelLevelsStates)

        
class OptionPlotoptionsDependencywheelLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsDependencywheelLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsDependencywheelLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsDependencywheelLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsDependencywheelLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsDependencywheelLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsDependencywheelLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheel(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsDependencywheelAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsDependencywheelAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the wheel relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def curveFactor(self):
        """Higher numbers makes the links in a sankey diagram or dependency wheelrender more curved.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(0.6)

    @curveFactor.setter
    def curveFactor(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsDependencywheelDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsDependencywheelDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsDependencywheelEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsDependencywheelEvents)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsDependencywheelLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsDependencywheelLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionPlotoptionsDependencywheelLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionPlotoptionsDependencywheelLevels)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def nodePadding(self):
        """The padding between nodes in a sankey diagram or dependency wheel, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(10)

    @nodePadding.setter
    def nodePadding(self, num: float): self._config(num, js_type=False)

    @property
    def nodeWidth(self):
        """The pixel width of each node in a sankey diagram or dependency wheel, or the height in case the chart is inverted.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(20)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsDependencywheelOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsDependencywheelOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsDependencywheelPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsDependencywheelPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """Size of the wheel in pixel or percent relative to the canvas space.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get("100%")

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsDependencywheelSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsDependencywheelSonification)

    @property
    def startAngle(self):
        """The start angle of the dependency wheel, in degrees where 0 is up.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsDependencywheelStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsDependencywheelStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsDependencywheelTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsDependencywheelTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelDatalabelsTextpathAttributes(Options):

    @property
    def dy(self):
        """Text path shift along its y-axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(5)

    @dy.setter
    def dy(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsDependencywheelDatalabelsTextpath(Options):

    @property
    def attributes(self) -> 'OptionPlotoptionsDependencywheelDatalabelsTextpathAttributes':
        """Presentation attributes for the text path. """
        return self._config_sub_data("attributes", OptionPlotoptionsDependencywheelDatalabelsTextpathAttributes)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsDependencywheelDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsDependencywheelDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """Distance between the data label and the center of the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(0)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsDependencywheelDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsDependencywheelDatalabelsFilter)

    @property
    def format(self):
        """A format string for data labels of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback to format data labels of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The format string specifying what to show for nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels of nodes in the dependency wheel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsDependencywheelDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsDependencywheelDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsDependencywheelAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsDependencywheelAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsDependencywheelAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsDependencywheelAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsDependencywheelAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsDependencywheelAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsDependencywheelAccessibilityPoint)

        
class OptionPlotoptionsCylinderZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsCylinderTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsCylinderTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsCylinderStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsCylinderStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsCylinderStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsCylinderStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsCylinderStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsCylinderStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsCylinderStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsCylinderStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsCylinderStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsCylinderStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsCylinderStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsCylinderStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsCylinderStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsCylinderStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsCylinderStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsCylinderStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsCylinderStatesSelect)

        
class OptionPlotoptionsCylinderSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsCylinderSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsCylinderSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsCylinderSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsCylinderSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsCylinderSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsCylinderSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsCylinderSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsCylinderSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsCylinderSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsCylinderSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsCylinderSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsCylinderSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsCylinderSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsCylinderSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsCylinderSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsCylinderSonificationTracksMappingVolume)

        
class OptionPlotoptionsCylinderSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsCylinderSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsCylinderSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsCylinderSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsCylinderSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsCylinderSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsCylinderSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsCylinderSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsCylinderSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsCylinderSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsCylinderSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsCylinderSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsCylinderSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsCylinderSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsCylinderSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsCylinderSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsCylinderSonificationTracks)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsCylinderSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsCylinderSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsCylinderSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsCylinderSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsCylinderSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsCylinderSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsCylinderSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsCylinderSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsCylinderSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsCylinderSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsCylinderSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsCylinderSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsCylinderSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsCylinderSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsCylinderSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsCylinderSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsCylinderSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsCylinderSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsCylinderSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsCylinderSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsCylinderSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsCylinderSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsCylinderSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsCylinderSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsCylinderSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsCylinderSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsCylinderPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsCylinderPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsCylinderPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsCylinderPointEvents)

        
class OptionPlotoptionsCylinderOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsCylinderOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsCylinderOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsCylinderOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsCylinderOnpointPosition)

        
class OptionPlotoptionsCylinderLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsCylinderLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsCylinderLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsCylinder(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsCylinderAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsCylinderAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsCylinderDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsCylinderDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsCylinderDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsCylinderDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsCylinderEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsCylinderEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsCylinderLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsCylinderLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsCylinderOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsCylinderOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsCylinderPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsCylinderPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsCylinderSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsCylinderSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsCylinderStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsCylinderStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsCylinderTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsCylinderTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsCylinderZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsCylinderZones)

        
class OptionPlotoptionsCylinderDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsCylinderDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsCylinderDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsCylinderDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsCylinderDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsCylinderDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsCylinderDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsCylinderDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsCylinderAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsCylinderAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsCylinderAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsCylinderAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsCylinderAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsCylinderAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsCylinderAccessibilityPoint)

        
class OptionPlotoptionsColumnrangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsColumnrangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsColumnrangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnrangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnrangeStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnrangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnrangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnrangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnrangeStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnrangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnrangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnrangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsColumnrangeStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsColumnrangeStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsColumnrangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsColumnrangeStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsColumnrangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsColumnrangeStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsColumnrangeStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsColumnrangeStatesSelect)

        
class OptionPlotoptionsColumnrangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnrangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnrangeSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnrangeSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnrangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnrangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnrangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnrangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnrangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnrangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnrangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnrangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnrangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnrangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnrangeSonificationTracksMappingVolume)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnrangeSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsColumnrangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnrangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnrangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnrangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnrangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsColumnrangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnrangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnrangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsColumnrangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsColumnrangeSonificationTracks)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsColumnrangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnrangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnrangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnrangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnrangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnrangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnrangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnrangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnrangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnrangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnrangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnrangeSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsColumnrangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnrangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnrangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnrangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnrangeSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsColumnrangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnrangePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsColumnrangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsColumnrangePointEvents)

        
class OptionPlotoptionsColumnrangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsColumnrangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsColumnrangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsColumnrangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsColumnrangeOnpointPosition)

        
class OptionPlotoptionsColumnrangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsColumnrangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsColumnrangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnrange(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsColumnrangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsColumnrangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self) -> 'OptionPlotoptionsColumnrangeBorderradius':
        """The corner radius of the border surrounding each column or bar. """
        return self._config_sub_data("borderRadius", OptionPlotoptionsColumnrangeBorderradius)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsColumnrangeDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsColumnrangeDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsColumnrangeDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsColumnrangeDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsColumnrangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsColumnrangeDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsColumnrangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsColumnrangeEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsColumnrangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsColumnrangeLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsColumnrangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsColumnrangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsColumnrangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsColumnrangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ColumnRange/ColumnRangeSeries.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsColumnrangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsColumnrangeSonification)

    @property
    def states(self) -> 'OptionPlotoptionsColumnrangeStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsColumnrangeStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsColumnrangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsColumnrangeTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsColumnrangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsColumnrangeZones)

        
class OptionPlotoptionsColumnrangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnrangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsColumnrangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnrangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsColumnrangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsColumnrangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsColumnrangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsColumnrangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnrangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnrangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnrangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsColumnrangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsColumnrangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsColumnrangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsColumnrangeAccessibilityPoint)

        
class OptionPlotoptionsColumnpyramidTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsColumnpyramidTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsColumnpyramidTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnpyramidStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnpyramidStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnpyramidStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnpyramidStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnpyramidStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnpyramidStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsColumnpyramidStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsColumnpyramidStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsColumnpyramidStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsColumnpyramidStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsColumnpyramidStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsColumnpyramidStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsColumnpyramidStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsColumnpyramidStatesSelect)

        
class OptionPlotoptionsColumnpyramidSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnpyramidSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnpyramidSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnpyramidSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnpyramidSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnpyramidSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnpyramidSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnpyramidSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnpyramidSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnpyramidSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnpyramidSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnpyramidSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnpyramidSonificationTracksMappingVolume)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnpyramidSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsColumnpyramidSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnpyramidSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnpyramidSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnpyramidSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsColumnpyramidSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnpyramidSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnpyramidSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsColumnpyramidSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsColumnpyramidSonificationTracks)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnpyramidSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnpyramidSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnpyramidSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnpyramidSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnpyramidSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsColumnpyramidPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnpyramidPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsColumnpyramidPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsColumnpyramidPointEvents)

        
class OptionPlotoptionsColumnpyramidOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsColumnpyramidOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsColumnpyramidOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsColumnpyramidOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsColumnpyramidOnpointPosition)

        
class OptionPlotoptionsColumnpyramidLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsColumnpyramidLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsColumnpyramidLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramid(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsColumnpyramidAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsColumnpyramidAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsColumnpyramidDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsColumnpyramidDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsColumnpyramidDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsColumnpyramidDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsColumnpyramidDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsColumnpyramidDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsColumnpyramidEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsColumnpyramidEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsColumnpyramidLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsColumnpyramidLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsColumnpyramidOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsColumnpyramidOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsColumnpyramidPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsColumnpyramidPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsColumnpyramidSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsColumnpyramidSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsColumnpyramidStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsColumnpyramidStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsColumnpyramidTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsColumnpyramidTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsColumnpyramidDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnpyramidDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsColumnpyramidDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsColumnpyramidDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsColumnpyramidDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsColumnpyramidDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnpyramidAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnpyramidAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnpyramidAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsColumnpyramidAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsColumnpyramidAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsColumnpyramidAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsColumnpyramidAccessibilityPoint)

        
class OptionPlotoptionsColumnZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsColumnTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsColumnTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsColumnStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsColumnStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsColumnStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsColumnStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsColumnStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsColumnStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsColumnStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsColumnStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsColumnStatesSelect)

        
class OptionPlotoptionsColumnSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsColumnSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsColumnSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnSonificationTracksMappingVolume)

        
class OptionPlotoptionsColumnSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsColumnSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsColumnSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsColumnSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsColumnSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsColumnSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsColumnSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsColumnSonificationTracks)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsColumnSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsColumnSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsColumnSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsColumnSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsColumnSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsColumnSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsColumnSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsColumnSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsColumnSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsColumnSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsColumnSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsColumnSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsColumnSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsColumnSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsColumnSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsColumnSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsColumnSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsColumnSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsColumnSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsColumnSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsColumnSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsColumnSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsColumnSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsColumnSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsColumnPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsColumnPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsColumnPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsColumnPointEvents)

        
class OptionPlotoptionsColumnOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsColumnOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsColumnOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsColumnOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsColumnOnpointPosition)

        
class OptionPlotoptionsColumnLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsColumnLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsColumnLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumn(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsColumnAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsColumnAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsColumnDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsColumnDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsColumnDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsColumnDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsColumnDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsColumnDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsColumnEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsColumnEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsColumnLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsColumnLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsColumnOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsColumnOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsColumnPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsColumnPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsColumnSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsColumnSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsColumnStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsColumnStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsColumnTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsColumnTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsColumnZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsColumnZones)

        
class OptionPlotoptionsColumnDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsColumnDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsColumnDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsColumnDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsColumnDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsColumnDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsColumnDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsColumnAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsColumnAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsColumnAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsColumnAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsColumnAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsColumnAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsColumnAccessibilityPoint)

        
class OptionPlotoptionsBulletZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsBulletTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsBulletTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.y}</b>. Target: <b>{point.target}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletTargetoptions(Options):

    @property
    def borderColor(self):
        """The border color of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """The color of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """The height of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(3)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """The width of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get("140%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBulletStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBulletStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBulletStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBulletStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBulletStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBulletStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBulletStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBulletStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsBulletStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsBulletStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsBulletStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsBulletStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsBulletStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsBulletStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsBulletStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsBulletStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsBulletStatesSelect)

        
class OptionPlotoptionsBulletSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBulletSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBulletSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsBulletSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBulletSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsBulletSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBulletSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBulletSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBulletSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBulletSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBulletSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBulletSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBulletSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBulletSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBulletSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBulletSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBulletSonificationTracksMappingVolume)

        
class OptionPlotoptionsBulletSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBulletSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBulletSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsBulletSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBulletSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBulletSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBulletSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBulletSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBulletSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBulletSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsBulletSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsBulletSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsBulletSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsBulletSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBulletSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBulletSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsBulletSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsBulletSonificationTracks)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsBulletSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsBulletSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBulletSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBulletSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBulletSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBulletSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBulletSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsBulletSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBulletSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBulletSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBulletSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBulletSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBulletSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBulletSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBulletSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBulletSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBulletSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBulletSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBulletSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBulletSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBulletSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBulletSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsBulletSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBulletSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBulletSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBulletSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBulletSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBulletSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBulletSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBulletSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBulletSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsBulletPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBulletPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsBulletPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsBulletPointEvents)

        
class OptionPlotoptionsBulletOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsBulletOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsBulletOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsBulletOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsBulletOnpointPosition)

        
class OptionPlotoptionsBulletLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsBulletLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsBulletLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBullet(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsBulletAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsBulletAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsBulletDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsBulletDatalabels)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsBulletDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsBulletDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsBulletEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsBulletEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsBulletLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsBulletLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsBulletOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsBulletOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsBulletPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsBulletPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsBulletSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsBulletSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsBulletStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsBulletStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def targetOptions(self) -> 'OptionPlotoptionsBulletTargetoptions':
        """All options related with look and positiong of targets. """
        return self._config_sub_data("targetOptions", OptionPlotoptionsBulletTargetoptions)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsBulletTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsBulletTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsBulletZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsBulletZones)

        
class OptionPlotoptionsBulletDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBulletDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsBulletDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsBulletDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsBulletDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsBulletDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsBulletDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsBulletDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBulletAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBulletAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBulletAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsBulletAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsBulletAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsBulletAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsBulletAccessibilityPoint)

        
class OptionPlotoptionsBubbleZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsBubbleTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsBubbleTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("({point.x}, {point.y}), Size: {point.z}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBubbleStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBubbleStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsBubbleStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsBubbleStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsBubbleStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsBubbleStatesSelectMarker)

        
class OptionPlotoptionsBubbleStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBubbleStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(5)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBubbleStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsBubbleStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsBubbleStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsBubbleStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsBubbleStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsBubbleStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsBubbleStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsBubbleStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsBubbleStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsBubbleStatesSelect)

        
class OptionPlotoptionsBubbleStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBubbleStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBubbleStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsBubbleStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsBubbleStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsBubbleStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsBubbleStatesHoverMarker)

        
class OptionPlotoptionsBubbleSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBubbleSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBubbleSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsBubbleSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBubbleSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsBubbleSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBubbleSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBubbleSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBubbleSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBubbleSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBubbleSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBubbleSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBubbleSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBubbleSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBubbleSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBubbleSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBubbleSonificationTracksMappingVolume)

        
class OptionPlotoptionsBubbleSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBubbleSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBubbleSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsBubbleSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBubbleSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBubbleSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBubbleSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBubbleSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBubbleSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBubbleSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsBubbleSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsBubbleSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsBubbleSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBubbleSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBubbleSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsBubbleSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsBubbleSonificationTracks)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsBubbleSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBubbleSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBubbleSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsBubbleSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBubbleSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBubbleSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBubbleSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBubbleSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBubbleSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBubbleSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBubbleSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBubbleSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBubbleSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBubbleSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBubbleSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBubbleSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBubbleSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBubbleSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsBubbleSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBubbleSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBubbleSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBubbleSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubbleSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBubbleSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBubbleSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBubbleSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsBubblePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBubblePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsBubblePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsBubblePointEvents)

        
class OptionPlotoptionsBubbleOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsBubbleOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsBubbleOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsBubbleOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsBubbleOnpointPosition)

        
class OptionPlotoptionsBubbleMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBubbleMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBubbleMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsBubbleMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsBubbleMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsBubbleMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsBubbleMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsBubbleMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsBubbleMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsBubbleMarkerStatesSelect)

        
class OptionPlotoptionsBubbleMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """The fill opacity of the bubble markers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0.5)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsBubbleMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsBubbleMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsBubbleLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsBubbleLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBubble(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsBubbleAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsBubbleAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """If there are more points in the series than the <code>animationLimit</code>, the animation won&#39;t run.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("z")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsBubbleDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsBubbleDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsBubbleDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsBubbleDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def displayNegative(self):
        """Whether to display negative sized bubbles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @displayNegative.setter
    def displayNegative(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsBubbleDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsBubbleDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsBubbleEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsBubbleEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def jitter(self) -> 'OptionPlotoptionsBubbleJitter':
        """Apply a jitter effect for the rendered markers. """
        return self._config_sub_data("jitter", OptionPlotoptionsBubbleJitter)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsBubbleLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsBubbleLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsBubbleMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsBubbleMarker)

    @property
    def maxSize(self):
        """Maximum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("20%")

    @maxSize.setter
    def maxSize(self, num: float): self._config(num, js_type=False)

    @property
    def minSize(self):
        """Minimum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(8)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """When a point&#39;s Z value is below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsBubbleOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsBubbleOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsBubblePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsBubblePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sizeBy(self):
        """Whether the bubble&#39;s value should be represented by the area or the width of the bubble.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("area")

    @sizeBy.setter
    def sizeBy(self, text: str): self._config(text, js_type=False)

    @property
    def sizeByAbsoluteValue(self):
        """When this is true, the absolute value of z determines the size of the bubble.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(False)

    @sizeByAbsoluteValue.setter
    def sizeByAbsoluteValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(False)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsBubbleSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsBubbleSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsBubbleStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsBubbleStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsBubbleTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsBubbleTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zMax(self):
        """The minimum for the Z value range.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @zMax.setter
    def zMax(self, num: float): self._config(num, js_type=False)

    @property
    def zMin(self):
        """The minimum for the Z value range.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @zMin.setter
    def zMin(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("z")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsBubbleZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsBubbleZones)

    @property
    def zThreshold(self):
        """When <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @zThreshold.setter
    def zThreshold(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBubbleDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsBubbleDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsBubbleDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsBubbleDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsBubbleDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsBubbleDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsBubbleDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBubbleAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBubbleAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBubbleAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsBubbleAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsBubbleAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsBubbleAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsBubbleAccessibilityPoint)

        
class OptionPlotoptionsBoxplotZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsBoxplotTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsBoxplotTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <b>{series.name}</b><br/>Maximum: {point.high}<br/>Upper quartile: {point.q3}<br/>Median: {point.median}<br/>Lower quartile: {point.q1}<br/>Minimum: {point.low}<br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBoxplotSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBoxplotSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBoxplotSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBoxplotSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBoxplotSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBoxplotSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBoxplotSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBoxplotSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBoxplotSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBoxplotSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBoxplotSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBoxplotSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBoxplotSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBoxplotSonificationTracksMappingVolume)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBoxplotSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsBoxplotSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBoxplotSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBoxplotSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBoxplotSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBoxplotSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBoxplotSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBoxplotSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsBoxplotSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsBoxplotSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBoxplotSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBoxplotSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsBoxplotSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsBoxplotSonificationTracks)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsBoxplotSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBoxplotSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBoxplotSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsBoxplotSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBoxplotSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBoxplotSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBoxplotSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBoxplotSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBoxplotSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBoxplotSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBoxplotSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBoxplotSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBoxplotSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBoxplotSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBoxplotSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBoxplotSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsBoxplotSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBoxplotSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBoxplotSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBoxplotSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBoxplotSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsBoxplotPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBoxplotPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsBoxplotPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsBoxplotPointEvents)

        
class OptionPlotoptionsBoxplotOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBoxplotOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBoxplotOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsBoxplotOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsBoxplotOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsBoxplotOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsBoxplotOnpointPosition)

        
class OptionPlotoptionsBoxplotLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsBoxplotLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsBoxplotLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBoxplot(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsBoxplotAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsBoxplotAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boxDashStyle(self):
        """The dash style of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @boxDashStyle.setter
    def boxDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("high")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsBoxplotDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsBoxplotDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsBoxplotDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsBoxplotDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsBoxplotDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsBoxplotDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsBoxplotEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsBoxplotEvents)

    @property
    def fillColor(self):
        """The fill color of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsBoxplotLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsBoxplotLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line surrounding the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def medianColor(self):
        """The color of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @medianColor.setter
    def medianColor(self, text: str): self._config(text, js_type=False)

    @property
    def medianDashStyle(self):
        """The dash style of the median.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @medianDashStyle.setter
    def medianDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def medianWidth(self):
        """The pixel width of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(2)

    @medianWidth.setter
    def medianWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsBoxplotOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsBoxplotOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsBoxplotPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsBoxplotPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsBoxplotSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsBoxplotSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def stemColor(self):
        """The color of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemColor.setter
    def stemColor(self, text: str): self._config(text, js_type=False)

    @property
    def stemDashStyle(self):
        """The dash style of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @stemDashStyle.setter
    def stemDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def stemWidth(self):
        """The width of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemWidth.setter
    def stemWidth(self, num: float): self._config(num, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsBoxplotTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsBoxplotTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def whiskerColor(self):
        """The color of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @whiskerColor.setter
    def whiskerColor(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerDashStyle(self):
        """The dash style of the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @whiskerDashStyle.setter
    def whiskerDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerLength(self):
        """The length of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("50%")

    @whiskerLength.setter
    def whiskerLength(self, num: float): self._config(num, js_type=False)

    @property
    def whiskerWidth(self):
        """The line width of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(2)

    @whiskerWidth.setter
    def whiskerWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsBoxplotZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsBoxplotZones)

        
class OptionPlotoptionsBoxplotDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBoxplotDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsBoxplotDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsBoxplotDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsBoxplotDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsBoxplotDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsBoxplotDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsBoxplotDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBoxplotAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBoxplotAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBoxplotAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsBoxplotAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsBoxplotAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsBoxplotAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsBoxplotAccessibilityPoint)

        
class OptionPlotoptionsBellcurveZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsBellcurveTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsBellcurveTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBellcurveStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBellcurveStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsBellcurveStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsBellcurveStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsBellcurveStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsBellcurveStatesSelectMarker)

        
class OptionPlotoptionsBellcurveStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBellcurveStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBellcurveStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsBellcurveStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsBellcurveStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsBellcurveStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsBellcurveStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsBellcurveStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsBellcurveStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsBellcurveStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsBellcurveStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsBellcurveStatesSelect)

        
class OptionPlotoptionsBellcurveStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBellcurveStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBellcurveStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsBellcurveStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsBellcurveStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsBellcurveStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsBellcurveStatesHoverMarker)

        
class OptionPlotoptionsBellcurveSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBellcurveSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBellcurveSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBellcurveSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBellcurveSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBellcurveSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBellcurveSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBellcurveSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBellcurveSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBellcurveSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBellcurveSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBellcurveSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBellcurveSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBellcurveSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBellcurveSonificationTracksMappingVolume)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBellcurveSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsBellcurveSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBellcurveSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBellcurveSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBellcurveSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBellcurveSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBellcurveSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBellcurveSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsBellcurveSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsBellcurveSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBellcurveSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBellcurveSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsBellcurveSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsBellcurveSonificationTracks)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsBellcurveSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBellcurveSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBellcurveSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsBellcurveSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBellcurveSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBellcurveSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBellcurveSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBellcurveSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBellcurveSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBellcurveSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBellcurveSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBellcurveSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBellcurveSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBellcurveSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBellcurveSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBellcurveSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsBellcurveSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBellcurveSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBellcurveSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBellcurveSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBellcurveSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsBellcurvePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBellcurvePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsBellcurvePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsBellcurvePointEvents)

        
class OptionPlotoptionsBellcurveOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsBellcurveOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsBellcurveOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsBellcurveOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsBellcurveOnpointPosition)

        
class OptionPlotoptionsBellcurveMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBellcurveMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBellcurveMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsBellcurveMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsBellcurveMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsBellcurveMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsBellcurveMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsBellcurveMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsBellcurveMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsBellcurveMarkerStatesSelect)

        
class OptionPlotoptionsBellcurveMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsBellcurveMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsBellcurveMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsBellcurveLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsBellcurveLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBellcurve(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsBellcurveAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsBellcurveAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsBellcurveDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsBellcurveDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsBellcurveDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsBellcurveDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsBellcurveEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsBellcurveEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def intervals(self):
        """This option allows to define the length of the bell curve.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(3)

    @intervals.setter
    def intervals(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsBellcurveLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsBellcurveLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsBellcurveMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsBellcurveMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsBellcurveOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsBellcurveOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsBellcurvePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsBellcurvePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointsInInterval(self):
        """Defines how many points should be plotted within 1 interval.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(3)

    @pointsInInterval.setter
    def pointsInInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsBellcurveSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsBellcurveSonification)

    @property
    def states(self) -> 'OptionPlotoptionsBellcurveStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsBellcurveStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsBellcurveTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsBellcurveTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsBellcurveZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsBellcurveZones)

        
class OptionPlotoptionsBellcurveDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBellcurveDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsBellcurveDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsBellcurveDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsBellcurveDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsBellcurveDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsBellcurveDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsBellcurveDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBellcurveAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBellcurveAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBellcurveAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsBellcurveAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsBellcurveAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsBellcurveAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsBellcurveAccessibilityPoint)

        
class OptionPlotoptionsBarZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsBarTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsBarTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBarStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBarStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBarStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBarStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBarStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsBarStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBarStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsBarStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsBarStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsBarStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsBarStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsBarStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsBarStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsBarStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsBarStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsBarStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsBarStatesSelect)

        
class OptionPlotoptionsBarSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBarSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBarSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBarSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBarSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsBarSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBarSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBarSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsBarSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBarSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBarSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBarSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBarSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBarSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBarSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBarSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBarSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBarSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBarSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBarSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBarSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBarSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBarSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBarSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBarSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBarSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBarSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBarSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBarSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBarSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBarSonificationTracksMappingVolume)

        
class OptionPlotoptionsBarSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBarSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBarSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsBarSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBarSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBarSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBarSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBarSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBarSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBarSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsBarSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsBarSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsBarSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsBarSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBarSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBarSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsBarSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsBarSonificationTracks)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsBarSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsBarSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBarSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBarSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBarSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBarSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBarSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsBarSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsBarSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsBarSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsBarSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBarSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsBarSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsBarSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsBarSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsBarSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsBarSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsBarSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsBarSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsBarSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsBarSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsBarSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsBarSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsBarSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsBarSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsBarSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsBarSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsBarSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsBarSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsBarSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsBarSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsBarSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsBarSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsBarSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsBarPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsBarPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsBarPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsBarPointEvents)

        
class OptionPlotoptionsBarOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsBarOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsBarOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsBarOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsBarOnpointPosition)

        
class OptionPlotoptionsBarLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsBarLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsBarLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBar(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsBarAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsBarAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsBarDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsBarDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsBarDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsBarDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsBarDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsBarDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsBarEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsBarEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsBarLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsBarLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsBarOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsBarOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsBarPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsBarPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsBarSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsBarSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsBarStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsBarStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsBarTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsBarTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsBarZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsBarZones)

        
class OptionPlotoptionsBarDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBarDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsBarDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsBarDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsBarDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsBarDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsBarDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsBarDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsBarAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsBarAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsBarAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsBarAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsBarAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsBarAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsBarAccessibilityPoint)

        
class OptionPlotoptionsAreasplinerangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsAreasplinerangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsAreasplinerangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplinerangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplinerangeStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsAreasplinerangeStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsAreasplinerangeStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreasplinerangeStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsAreasplinerangeStatesSelectMarker)

        
class OptionPlotoptionsAreasplinerangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplinerangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplinerangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsAreasplinerangeStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsAreasplinerangeStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsAreasplinerangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsAreasplinerangeStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsAreasplinerangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsAreasplinerangeStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsAreasplinerangeStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsAreasplinerangeStatesSelect)

        
class OptionPlotoptionsAreasplinerangeStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplinerangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplinerangeStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsAreasplinerangeStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsAreasplinerangeStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreasplinerangeStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsAreasplinerangeStatesHoverMarker)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreasplinerangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreasplinerangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreasplinerangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreasplinerangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplinerangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplinerangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsAreasplinerangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplinerangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreasplinerangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplinerangeSonificationTracksMappingVolume)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplinerangeSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsAreasplinerangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplinerangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplinerangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplinerangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsAreasplinerangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplinerangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsAreasplinerangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsAreasplinerangeSonificationTracks)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplinerangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplinerangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplinerangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplinerangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplinerangeSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsAreasplinerangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinerangePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsAreasplinerangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsAreasplinerangePointEvents)

        
class OptionPlotoptionsAreasplinerangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsAreasplinerangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsAreasplinerangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsAreasplinerangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsAreasplinerangeOnpointPosition)

        
class OptionPlotoptionsAreasplinerangeMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplinerangeMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplinerangeMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplinerangeMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsAreasplinerangeMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsAreasplinerangeMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsAreasplinerangeMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsAreasplinerangeMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsAreasplinerangeMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsAreasplinerangeMarkerStatesSelect)

        
class OptionPlotoptionsAreasplinerangeMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsAreasplinerangeMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsAreasplinerangeMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplinerangeLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplinerangeLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplinerangeLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsAreasplinerangeLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsAreasplinerangeLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsAreasplinerangeLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsAreasplinerangeLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsAreasplinerangeLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsAreasplinerangeLowmarkerStatesSelect)

        
class OptionPlotoptionsAreasplinerangeLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsAreasplinerangeLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsAreasplinerangeLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsAreasplinerangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsAreasplinerangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplinerange(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsAreasplinerangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsAreasplinerangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSplineRange/AreaSplineRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsAreasplinerangeDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsAreasplinerangeDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsAreasplinerangeDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsAreasplinerangeDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsAreasplinerangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsAreasplinerangeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsAreasplinerangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsAreasplinerangeEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSplineRange/AreaSplineRangeSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSplineRange/AreaSplineRangeSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsAreasplinerangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsAreasplinerangeLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the arearange graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionPlotoptionsAreasplinerangeLowmarker':
        """Options for the lower markers of the arearange-like series. """
        return self._config_sub_data("lowMarker", OptionPlotoptionsAreasplinerangeLowmarker)

    @property
    def marker(self) -> 'OptionPlotoptionsAreasplinerangeMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsAreasplinerangeMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsAreasplinerangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsAreasplinerangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsAreasplinerangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsAreasplinerangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsAreasplinerangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsAreasplinerangeSonification)

    @property
    def states(self) -> 'OptionPlotoptionsAreasplinerangeStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsAreasplinerangeStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsAreasplinerangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsAreasplinerangeTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(True)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsAreasplinerangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsAreasplinerangeZones)

        
class OptionPlotoptionsAreasplinerangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplinerangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplinerangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplinerangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsAreasplinerangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsAreasplinerangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsAreasplinerangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsAreasplinerangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplinerangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplinerangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplinerangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsAreasplinerangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsAreasplinerangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsAreasplinerangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsAreasplinerangeAccessibilityPoint)

        
class OptionPlotoptionsAreasplineZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsAreasplineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsAreasplineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsAreasplineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsAreasplineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreasplineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsAreasplineStatesSelectMarker)

        
class OptionPlotoptionsAreasplineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsAreasplineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsAreasplineStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsAreasplineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsAreasplineStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsAreasplineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsAreasplineStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsAreasplineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsAreasplineStatesSelect)

        
class OptionPlotoptionsAreasplineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsAreasplineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsAreasplineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreasplineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsAreasplineStatesHoverMarker)

        
class OptionPlotoptionsAreasplineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreasplineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreasplineSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplineSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreasplineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreasplineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreasplineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreasplineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreasplineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsAreasplineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreasplineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplineSonificationTracksMappingVolume)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplineSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsAreasplineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsAreasplineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsAreasplineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsAreasplineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsAreasplineSonificationTracks)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsAreasplineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsAreasplineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreasplineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreasplineSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreasplineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreasplineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreasplineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreasplineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreasplineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreasplineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsAreasplineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreasplineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreasplineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreasplineSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsAreasplineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreasplineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreasplineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreasplineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreasplineSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsAreasplinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreasplinePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsAreasplinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsAreasplinePointEvents)

        
class OptionPlotoptionsAreasplineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsAreasplineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsAreasplineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsAreasplineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsAreasplineOnpointPosition)

        
class OptionPlotoptionsAreasplineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsAreasplineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsAreasplineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsAreasplineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsAreasplineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsAreasplineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsAreasplineMarkerStatesSelect)

        
class OptionPlotoptionsAreasplineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsAreasplineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsAreasplineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsAreasplineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsAreasplineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreaspline(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsAreasplineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsAreasplineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSpline/AreaSplineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsAreasplineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsAreasplineDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsAreasplineDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsAreasplineDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsAreasplineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsAreasplineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsAreasplineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsAreasplineEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSpline/AreaSplineSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSpline/AreaSplineSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsAreasplineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsAreasplineLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreasplineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsAreasplineMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsAreasplineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsAreasplineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsAreasplinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsAreasplinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsAreasplineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsAreasplineSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsAreasplineStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsAreasplineStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsAreasplineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsAreasplineTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsAreasplineZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsAreasplineZones)

        
class OptionPlotoptionsAreasplineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsAreasplineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsAreasplineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsAreasplineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsAreasplineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsAreasplineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsAreasplineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreasplineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreasplineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreasplineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsAreasplineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsAreasplineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsAreasplineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsAreasplineAccessibilityPoint)

        
class OptionPlotoptionsArearangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsArearangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsArearangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArearangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsArearangeStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsArearangeStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsArearangeStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsArearangeStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsArearangeStatesSelectMarker)

        
class OptionPlotoptionsArearangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArearangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArearangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsArearangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsArearangeStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsArearangeStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsArearangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsArearangeStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsArearangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsArearangeStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsArearangeStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsArearangeStatesSelect)

        
class OptionPlotoptionsArearangeStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArearangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsArearangeStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsArearangeStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsArearangeStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsArearangeStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsArearangeStatesHoverMarker)

        
class OptionPlotoptionsArearangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsArearangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsArearangeSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsArearangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArearangeSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsArearangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsArearangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsArearangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsArearangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsArearangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsArearangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsArearangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArearangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsArearangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArearangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsArearangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsArearangeSonificationTracksMappingVolume)

        
class OptionPlotoptionsArearangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArearangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArearangeSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsArearangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArearangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArearangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArearangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArearangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArearangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArearangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsArearangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsArearangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsArearangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArearangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArearangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsArearangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsArearangeSonificationTracks)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsArearangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArearangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArearangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArearangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsArearangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsArearangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsArearangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArearangeSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsArearangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsArearangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsArearangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsArearangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsArearangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsArearangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArearangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsArearangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArearangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsArearangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsArearangeSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsArearangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArearangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArearangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArearangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArearangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArearangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArearangeSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsArearangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArearangePoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsArearangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsArearangePointEvents)

        
class OptionPlotoptionsArearangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsArearangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsArearangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsArearangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsArearangeOnpointPosition)

        
class OptionPlotoptionsArearangeMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArearangeMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArearangeMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsArearangeMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsArearangeMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsArearangeMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsArearangeMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsArearangeMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsArearangeMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsArearangeMarkerStatesSelect)

        
class OptionPlotoptionsArearangeMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsArearangeMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsArearangeMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArearangeLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArearangeLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsArearangeLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsArearangeLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsArearangeLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsArearangeLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsArearangeLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsArearangeLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsArearangeLowmarkerStatesSelect)

        
class OptionPlotoptionsArearangeLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsArearangeLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsArearangeLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsArearangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsArearangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArearange(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsArearangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsArearangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsArearangeDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsArearangeDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsArearangeDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsArearangeDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsArearangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsArearangeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsArearangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsArearangeEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsArearangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsArearangeLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the arearange graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionPlotoptionsArearangeLowmarker':
        """Options for the lower markers of the arearange-like series. """
        return self._config_sub_data("lowMarker", OptionPlotoptionsArearangeLowmarker)

    @property
    def marker(self) -> 'OptionPlotoptionsArearangeMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsArearangeMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsArearangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsArearangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsArearangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsArearangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsArearangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsArearangeSonification)

    @property
    def states(self) -> 'OptionPlotoptionsArearangeStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsArearangeStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsArearangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsArearangeTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(True)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsArearangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsArearangeZones)

        
class OptionPlotoptionsArearangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArearangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsArearangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsArearangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsArearangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsArearangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsArearangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsArearangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArearangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArearangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArearangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsArearangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsArearangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsArearangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsArearangeAccessibilityPoint)

        
class OptionPlotoptionsAreaZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsAreaTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsAreaTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreaStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsAreaStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsAreaStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsAreaStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreaStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsAreaStatesSelectMarker)

        
class OptionPlotoptionsAreaStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreaStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreaStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsAreaStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsAreaStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionPlotoptionsAreaStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsAreaStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionPlotoptionsAreaStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsAreaStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsAreaStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsAreaStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionPlotoptionsAreaStatesSelect)

        
class OptionPlotoptionsAreaStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreaStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsAreaStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionPlotoptionsAreaStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionPlotoptionsAreaStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreaStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionPlotoptionsAreaStatesHoverMarker)

        
class OptionPlotoptionsAreaSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreaSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreaSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsAreaSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreaSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsAreaSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreaSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreaSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreaSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreaSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreaSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreaSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreaSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsAreaSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreaSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreaSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreaSonificationTracksMappingVolume)

        
class OptionPlotoptionsAreaSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreaSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreaSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsAreaSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreaSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreaSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreaSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreaSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreaSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreaSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsAreaSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsAreaSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsAreaSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsAreaSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreaSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreaSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsAreaSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsAreaSonificationTracks)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsAreaSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsAreaSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreaSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreaSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreaSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreaSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreaSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsAreaSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsAreaSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsAreaSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreaSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsAreaSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsAreaSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsAreaSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsAreaSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsAreaSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsAreaSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsAreaSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsAreaSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsAreaSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsAreaSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsAreaSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsAreaSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsAreaSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsAreaSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsAreaSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsAreaSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsAreaSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsAreaSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsAreaSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsAreaSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsAreaPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsAreaPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsAreaPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsAreaPointEvents)

        
class OptionPlotoptionsAreaOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsAreaOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsAreaOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsAreaOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsAreaOnpointPosition)

        
class OptionPlotoptionsAreaMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreaMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsAreaMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsAreaMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsAreaMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsAreaMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsAreaMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsAreaMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsAreaMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsAreaMarkerStatesSelect)

        
class OptionPlotoptionsAreaMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsAreaMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsAreaMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsAreaLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsAreaLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArea(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsAreaAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsAreaAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsAreaDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsAreaDatalabels)

    @property
    def dataSorting(self) -> 'OptionPlotoptionsAreaDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionPlotoptionsAreaDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionPlotoptionsAreaDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionPlotoptionsAreaDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsAreaEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsAreaEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsAreaLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsAreaLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsAreaMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionPlotoptionsAreaMarker)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsAreaOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsAreaOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsAreaPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsAreaPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsAreaSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsAreaSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsAreaStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsAreaStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsAreaTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsAreaTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionPlotoptionsAreaZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionPlotoptionsAreaZones)

        
class OptionPlotoptionsAreaDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreaDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsAreaDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsAreaDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsAreaDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsAreaDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsAreaDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsAreaDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsAreaAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsAreaAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsAreaAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsAreaAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsAreaAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsAreaAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsAreaAccessibilityPoint)

        
class OptionPlotoptionsArcdiagramTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionPlotoptionsArcdiagramTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionPlotoptionsArcdiagramTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.name}: <b>{point.sum}</b><br/>")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsArcdiagramStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsArcdiagramStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsArcdiagramStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsArcdiagramStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsArcdiagramStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsArcdiagramStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsArcdiagramStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsArcdiagramStatesSelect)

        
class OptionPlotoptionsArcdiagramSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsArcdiagramSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsArcdiagramSonificationTracksMappingTremoloSpeed)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArcdiagramSonificationTracksMappingLowpassResonance)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsArcdiagramSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsArcdiagramSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsArcdiagramSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsArcdiagramSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsArcdiagramSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsArcdiagramSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArcdiagramSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsArcdiagramSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArcdiagramSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsArcdiagramSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsArcdiagramSonificationTracksMappingVolume)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArcdiagramSonificationTracksMappingHighpassResonance)

        
class OptionPlotoptionsArcdiagramSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArcdiagramSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArcdiagramSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArcdiagramSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArcdiagramSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonification(Options):

    @property
    def contextTracks(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionPlotoptionsArcdiagramSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArcdiagramSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArcdiagramSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionPlotoptionsArcdiagramSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionPlotoptionsArcdiagramSonificationTracks)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMappingVolume)

        
class OptionPlotoptionsArcdiagramSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArcdiagramSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremoloSpeed)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpassResonance)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionPlotoptionsArcdiagramSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionPlotoptionsArcdiagramSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionPlotoptionsArcdiagramSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionPlotoptionsArcdiagramSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionPlotoptionsArcdiagramSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionPlotoptionsArcdiagramSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionPlotoptionsArcdiagramSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionPlotoptionsArcdiagramSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionPlotoptionsArcdiagramSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionPlotoptionsArcdiagramSonificationContexttracksMappingVolume)

        
class OptionPlotoptionsArcdiagramSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionPlotoptionsArcdiagramSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionPlotoptionsArcdiagramSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionPlotoptionsArcdiagramSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionPlotoptionsArcdiagramSonificationContexttracksMappingHighpassResonance)

        
class OptionPlotoptionsArcdiagramPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionPlotoptionsArcdiagramPoint(Options):

    @property
    def events(self) -> 'OptionPlotoptionsArcdiagramPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionPlotoptionsArcdiagramPointEvents)

        
class OptionPlotoptionsArcdiagramOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionPlotoptionsArcdiagramOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionPlotoptionsArcdiagramOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionPlotoptionsArcdiagramOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionPlotoptionsArcdiagramOnpointPosition)

        
class OptionPlotoptionsArcdiagramMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramMarkerStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsArcdiagramMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionPlotoptionsArcdiagramMarkerStatesHover)

    @property
    def normal(self) -> 'OptionPlotoptionsArcdiagramMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionPlotoptionsArcdiagramMarkerStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsArcdiagramMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionPlotoptionsArcdiagramMarkerStatesSelect)

        
class OptionPlotoptionsArcdiagramMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsArcdiagramMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionPlotoptionsArcdiagramMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsStates(Options):

    @property
    def hover(self) -> 'OptionPlotoptionsArcdiagramLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionPlotoptionsArcdiagramLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionPlotoptionsArcdiagramLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionPlotoptionsArcdiagramLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionPlotoptionsArcdiagramLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionPlotoptionsArcdiagramLevelsStatesNormal)

    @property
    def select(self) -> 'OptionPlotoptionsArcdiagramLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionPlotoptionsArcdiagramLevelsStatesSelect)

        
class OptionPlotoptionsArcdiagramLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsArcdiagramLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsArcdiagramLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionPlotoptionsArcdiagramLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionPlotoptionsArcdiagramLevelsStates)

        
class OptionPlotoptionsArcdiagramLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsArcdiagramLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsArcdiagramLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsArcdiagramLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsArcdiagramLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionPlotoptionsArcdiagramLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionPlotoptionsArcdiagramLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagram(Options):

    @property
    def accessibility(self) -> 'OptionPlotoptionsArcdiagramAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionPlotoptionsArcdiagramAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centeredLinks(self):
        """The option to center links rather than position them one after another.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(False)

    @centeredLinks.setter
    def centeredLinks(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionPlotoptionsArcdiagramDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionPlotoptionsArcdiagramDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def equalNodes(self):
        """Whether nodes with different values should have the same size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(False)

    @equalNodes.setter
    def equalNodes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionPlotoptionsArcdiagramEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionPlotoptionsArcdiagramEvents)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionPlotoptionsArcdiagramLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionPlotoptionsArcdiagramLabel)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionPlotoptionsArcdiagramLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionPlotoptionsArcdiagramLevels)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionPlotoptionsArcdiagramMarker':
        """. """
        return self._config_sub_data("marker", OptionPlotoptionsArcdiagramMarker)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def nodeWidth(self):
        """The pixel width of each node in a sankey diagram or dependency wheel, or the height in case the chart is inverted.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(20)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionPlotoptionsArcdiagramOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionPlotoptionsArcdiagramOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionPlotoptionsArcdiagramPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionPlotoptionsArcdiagramPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def reversed(self):
        """Whether the series should be placed on the other side of the <code>plotArea</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionPlotoptionsArcdiagramSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionPlotoptionsArcdiagramSonification)

    @property
    def states(self) -> 'OptionPlotoptionsArcdiagramStates':
        """. """
        return self._config_sub_data("states", OptionPlotoptionsArcdiagramStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionPlotoptionsArcdiagramTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionPlotoptionsArcdiagramTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramDatalabelsLinktextpath(Options):

    @property
    def attributes(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get({"startOffset":"25%"})

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionPlotoptionsArcdiagramDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionPlotoptionsArcdiagramDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionPlotoptionsArcdiagramDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionPlotoptionsArcdiagramDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionPlotoptionsArcdiagramDatalabelsLinktextpath':
        """Options for a <em>link</em> label text which should follow link connection. """
        return self._config_sub_data("linkTextPath", OptionPlotoptionsArcdiagramDatalabelsLinktextpath)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionPlotoptionsArcdiagramDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionPlotoptionsArcdiagramDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionPlotoptionsArcdiagramAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionPlotoptionsArcdiagramAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionPlotoptionsArcdiagramAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionPlotoptionsArcdiagramAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionPlotoptionsArcdiagramAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionPlotoptionsArcdiagramAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionPlotoptionsArcdiagramAccessibilityPoint)
